/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HostSeriesView } from "./HostSeriesView";
import { BubbleSeries } from "igniteui-react-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { markType, enumGetBox, runOn, delegateCombine, delegateRemove, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { SizeScale } from "igniteui-react-charts";
import { BrushScale } from "igniteui-react-charts";
import { ScatterItemSearchMode_$type } from "igniteui-react-charts";
import { PropertyMetadata } from "igniteui-react-core";
/**
 * @hidden
 */
export let GeographicProportionalSymbolSeriesView = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.cu = null;
            this.cu = a;
        }
        a4() {
            super.a4();
            if (!this.t) {
            }
        }
        ci() {
            super.ci();
            let a = this.cu.w5;
            a.aay = this.cu.y4;
            a.aa6 = this.cu.y2;
            a.xf = this.cu.xf;
            a.x7 = this.cu.xv;
            a.xo = this.cu.xg;
            a.ac8 = this.cu.yo;
            a.ady = this.cu.y9;
            a.acx = this.cu.yg;
            a.ado = this.cu.y0;
            a.adj = this.cu.ys;
            a.acu = this.cu.yd;
            a.ac6 = this.cu.yk;
            a.ac7 = this.cu.yn;
            a.add = this.cu.yq;
            a.adc = this.cu.yp;
        }
        c3() {
            this.cu.w5.aay = this.cu.y4;
        }
        c2() {
            this.cu.w5.aa6 = this.cu.y2;
        }
        c8() {
            this.cu.w5.xf = this.cu.xf;
        }
        c6() {
            this.cu.w5.x7 = this.cu.xv;
        }
        c7() {
            this.cu.w5.xo = this.cu.xg;
        }
        c9() {
            this.cu.w5.aae = this.cu.xh;
        }
        db() {
            this.cu.w5.xAxis = this.cu.dc.w7;
        }
        dc() {
            this.cu.w5.yAxis = this.cu.dc.w9;
        }
        da() {
            let a = this.cu.w5;
            if (this.cu.dc == null) {
                a.xAxis = null;
                a.yAxis = null;
                return;
            }
            a.xAxis = this.cu.dc.w7;
            a.yAxis = this.cu.dc.w9;
        }
        c4() {
            this.cu.w5.yo = this.cu.x9;
        }
        c5() {
            this.cu.w5.yp = this.cu.ya;
        }
        dd() {
            this.cu.w5.ady = this.cu.y9;
        }
        de() {
            this.cu.w5.acx = this.cu.yg;
            this.cu.w5.ac8 = this.cu.yo;
        }
        cy() {
            this.cu.w5.ado = this.cu.y0;
        }
        cw() {
            this.cu.w5.acu = this.cu.yd;
            this.cu.w5.ac6 = this.cu.yk;
            this.cu.w5.ac7 = this.cu.yn;
            this.cu.w5.add = this.cu.yq;
            this.cu.w5.adc = this.cu.yp;
        }
        cv() {
            this.cu.w5.adj = this.cu.ys;
        }
        df() {
            this.cu.w5.ac8 = this.cu.yo;
        }
        cx() {
            this.cu.w5.ac6 = this.cu.yk;
        }
        c1() {
            this.cu.w5.ac7 = this.cu.yn;
        }
        c0() {
            this.cu.w5.add = this.cu.yq;
        }
        cz() {
            this.cu.w5.adc = this.cu.yp;
        }
    }
    GeographicProportionalSymbolSeriesView.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesView, 'GeographicProportionalSymbolSeriesView', HostSeriesView.$);
    return GeographicProportionalSymbolSeriesView;
})();
/**
 * @hidden
 */
export let GeographicProportionalSymbolSeries = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeries extends GeographicMarkerSeries {
        bk() {
            return new GeographicProportionalSymbolSeries();
        }
        get_ek() {
            return true;
        }
        constructor() {
            super();
            this.ye = null;
            this.yj = false;
            this.yi = false;
            this.assigningScatterStyle = null;
            this.assigningScatterMarkerStyle = null;
            this.ab = GeographicProportionalSymbolSeries.$;
        }
        ct() {
            return new GeographicProportionalSymbolSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.yh = a;
        }
        jm() {
            return 0.7;
        }
        w4() {
            return new BubbleSeries();
        }
        get_ff() {
            return true;
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.yh.da();
                    break;
                case GeographicProportionalSymbolSeries.$$p[9]:
                    this.yh.c3();
                    break;
                case GeographicProportionalSymbolSeries.$$p[8]:
                    this.yh.c2();
                    break;
                case "XAxis":
                    this.yh.db();
                    break;
                case "YAxis":
                    this.yh.dc();
                    break;
                case GeographicProportionalSymbolSeries.$$p[13]:
                    this.yh.dd();
                    break;
                case GeographicProportionalSymbolSeries.$$p[14]:
                    this.yh.de();
                    break;
                case GeographicProportionalSymbolSeries.$$p[15]:
                    this.yh.df();
                    break;
                case GeographicProportionalSymbolSeries.$$p[7]:
                    this.yh.cy();
                    break;
                case GeographicProportionalSymbolSeries.$$p[0]:
                    this.yh.cv();
                    break;
                case GeographicProportionalSymbolSeries.$$p[1]:
                    this.yh.cw();
                    break;
                case GeographicProportionalSymbolSeries.$$p[2]:
                    this.yh.cx();
                    break;
                case GeographicProportionalSymbolSeries.$$p[12]:
                    this.yh.c1();
                    break;
                case GeographicProportionalSymbolSeries.$$p[11]:
                    this.yh.c0();
                    break;
                case GeographicProportionalSymbolSeries.$$p[10]:
                    this.yh.cz();
                    break;
                case GeographicProportionalSymbolSeries.$$p[4]:
                    this.w5.zu = this.ym;
                    this.yj = this.ym;
                    if (this.ym) {
                        let e = this.w5;
                        e.assigningScatterStyle = delegateCombine(e.assigningScatterStyle, runOn(this, this.ze));
                    }
                    else {
                        let f = this.w5;
                        f.assigningScatterStyle = delegateRemove(f.assigningScatterStyle, runOn(this, this.ze));
                    }
                    break;
                case GeographicProportionalSymbolSeries.$$p[3]:
                    this.w5.zt = this.yl;
                    this.yi = this.yl;
                    if (this.ym) {
                        let g = this.w5;
                        g.assigningScatterMarkerStyle = delegateCombine(g.assigningScatterMarkerStyle, runOn(this, this.zd));
                    }
                    else {
                        let h = this.w5;
                        h.assigningScatterMarkerStyle = delegateRemove(h.assigningScatterMarkerStyle, runOn(this, this.zd));
                    }
                    break;
                case GeographicProportionalSymbolSeries.$$p[5]:
                    this.w5.zd = this.yf;
                    break;
                case GeographicProportionalSymbolSeries.$$p[6]:
                    this.w5.aad = this.yr;
                    break;
            }
        }
        ze(a, b) {
            if (this.assigningScatterStyle != null) {
                this.assigningScatterStyle(this, b);
            }
        }
        zd(a, b) {
            if (this.assigningScatterMarkerStyle != null) {
                this.assigningScatterMarkerStyle(this, b);
            }
        }
    }
    GeographicProportionalSymbolSeries.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeries, 'GeographicProportionalSymbolSeries', GeographicMarkerSeries.$);
    GeographicProportionalSymbolSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicProportionalSymbolSeries, 'raisePropertyChanged', ['FillMemberPath:ys:zf', [2], 'FillScale:yd:zg', [BrushScale.$], 'FillScaleUseGlobalValues:yk:zh', [0, false], 'IsCustomScatterMarkerStyleAllowed:yl:zi', [0, false], 'IsCustomScatterStyleAllowed:ym:zj', [0, false], 'ItemSearchMode:yf:zk', [ScatterItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:yr:zl', [1, 10000], 'LabelMemberPath:y0:zm', [2], 'LatitudeMemberPath:y2:zn', [2, null], 'LongitudeMemberPath:y4:zo', [2, null], 'MarkerBrushBrightness:yp:zp', [1, NaN], 'MarkerOutlineBrightness:yq:zq', [1, NaN], 'MarkerOutlineUsesFillScale:yn:zr', [0, false], 'RadiusMemberPath:y9:zs', [2, null], 'RadiusScale:yg:zt', [SizeScale.$], 'RadiusScaleUseGlobalValues:yo:zu', [0, false]]);
    return GeographicProportionalSymbolSeries;
})();
