/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { DependencyProperty } from "igniteui-react-core";
import { ShapeItemSearchMode_$type } from "igniteui-react-charts";
import { BrushScale } from "igniteui-react-charts";
import { enumGetBox, runOn, delegateCombine, delegateRemove, markType, markDep } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { HostSeriesView } from "./HostSeriesView";
/**
 * @hidden
 */
export let GeographicShapeSeriesBase = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBase extends GeographicMapSeriesHost {
        constructor() {
            super(...arguments);
            this.xm = false;
            this.xl = false;
            this.assigningShapeStyle = null;
            this.assigningShapeMarkerStyle = null;
            this.xi = null;
            this.xk = false;
        }
        ct() {
            return new GeographicShapeSeriesBaseView(this);
        }
        q3(a) {
            super.q3(a);
            this.xh = a;
        }
        get_ff() {
            return true;
        }
        get_ef() {
            return true;
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.xh.cv();
                    break;
                case "ShapeMemberPath":
                    this.xh.cx();
                    break;
                case GeographicShapeSeriesBase.$$p[8]:
                    this.xh.cw();
                    break;
                case GeographicShapeSeriesBase.$$p[4]:
                    this.w5.yd = this.xp;
                    this.xm = this.xp;
                    if (this.xp) {
                        let e = this.w5;
                        e.assigningShapeStyle = delegateCombine(e.assigningShapeStyle, runOn(this, this.x7));
                    }
                    else {
                        let f = this.w5;
                        f.assigningShapeStyle = delegateRemove(f.assigningShapeStyle, runOn(this, this.x7));
                    }
                    break;
                case GeographicShapeSeriesBase.$$p[3]:
                    this.w5.yc = this.xo;
                    this.xl = this.xo;
                    if (this.xp) {
                        let g = this.w5;
                        g.assigningShapeMarkerStyle = delegateCombine(g.assigningShapeMarkerStyle, runOn(this, this.x6));
                    }
                    else {
                        let h = this.w5;
                        h.assigningShapeMarkerStyle = delegateRemove(h.assigningShapeMarkerStyle, runOn(this, this.x6));
                    }
                    break;
                case GeographicShapeSeriesBase.$$p[5]:
                    this.w5.xp = this.xg;
                    break;
                case GeographicShapeSeriesBase.$$p[6]:
                    this.w5.yu = this.xr;
                    break;
                case GeographicShapeSeriesBase.$$p[7]:
                    this.w5.yv = this.xs;
                    break;
                case GeographicShapeSeriesBase.$$p[0]:
                    this.w5.yz = this.xt;
                    break;
                case GeographicShapeSeriesBase.$$p[1]:
                    this.w5.xf = this.xf;
                    break;
                case GeographicShapeSeriesBase.$$p[2]:
                    this.w5.x8 = this.xn;
                    break;
                case "ShapefileDataSource":
                    if (c != null) {
                        let i = c;
                        if (this.xk) {
                            i.importCompleted = delegateRemove(i.importCompleted, runOn(this, this.x8));
                        }
                    }
                    if (d != null) {
                        let j = d;
                        if (j.count > 0) {
                            this.x9();
                            break;
                        }
                        this.xk = true;
                        j.importCompleted = delegateCombine(j.importCompleted, runOn(this, this.x8));
                    }
                    break;
            }
        }
        x7(a, b) {
            if (this.assigningShapeStyle != null) {
                this.assigningShapeStyle(this, b);
            }
        }
        x6(a, b) {
            if (this.assigningShapeMarkerStyle != null) {
                this.assigningShapeMarkerStyle(this, b);
            }
        }
        x8(a, b) {
            this.x9();
        }
        x9() {
            let sds_ = this.xj;
            let ext_ = sds_.externalObject;
            this.itemsSource = (ext_.getPointData());
        }
        get xj() {
            return this.xi;
        }
        set xj(a) {
            let b = this.xi;
            this.xi = a;
            if (b != this.xi) {
                this.raisePropertyChanged("ShapefileDataSource", b, this.xi);
            }
        }
        get_g8() {
            return true;
        }
        set_g8(a) {
            super.set_g8(a);
        }
    }
    GeographicShapeSeriesBase.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBase, 'GeographicShapeSeriesBase', GeographicMapSeriesHost.$);
    GeographicShapeSeriesBase.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeriesBase, 'raisePropertyChanged', ['FillMemberPath:xt:ya', [2], 'FillScale:xf:yb', [BrushScale.$], 'FillScaleUseGlobalValues:xn:yc', [0, false], 'IsCustomShapeMarkerStyleAllowed:xo:yd', [0, false], 'IsCustomShapeStyleAllowed:xp:ye', [0, false], 'ItemSearchMode:xg:yf', [ShapeItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ShapeItemSearchMode_$type, 0)], 'ItemSearchPointsThreshold:xr:yg', [1, 10000], 'ItemSearchThreshold:xs:yh', [1, 10000], 'ShapeFilterResolution:xq:yi', [1, 2], 'ShapeMemberPath:x4:yj', [2, "points"]]);
    return GeographicShapeSeriesBase;
})();
/**
 * @hidden
 */
export let GeographicShapeSeriesBaseView = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBaseView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.cu = null;
            this.cu = a;
        }
        ci() {
            super.ci();
            this.cu.w5.zc = this.cu.x4;
        }
        cv() {
            let a = this.cu.w5;
            if (this.cu.dc == null) {
                a.xj = null;
                a.xl = null;
                return;
            }
            a.xj = this.cu.dc.w7;
            a.xl = this.cu.dc.w9;
        }
        cx() {
            this.cu.w5.zc = this.cu.x4;
        }
        cw() {
            this.cu.w5.yr = this.cu.xq;
        }
    }
    GeographicShapeSeriesBaseView.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBaseView, 'GeographicShapeSeriesBaseView', HostSeriesView.$);
    return GeographicShapeSeriesBaseView;
})();
