/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HostSeriesView } from "./HostSeriesView";
import { ScatterSeries } from "igniteui-react-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { markType, enumGetBox, runOn, delegateCombine, delegateRemove, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "igniteui-react-charts";
import { ScatterItemSearchMode_$type } from "igniteui-react-charts";
import { PropertyMetadata } from "igniteui-react-core";
/**
 * @hidden
 */
export let GeographicSymbolSeriesView = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.cu = null;
            this.cu = a;
        }
        a4() {
            super.a4();
            if (!this.t) {
            }
        }
        ci() {
            let a = this.cu.w5;
            super.ci();
            a.aay = this.cu.yt;
            a.aa6 = this.cu.yr;
            a.xf = this.cu.xf;
            a.x7 = this.cu.xv;
            a.xo = this.cu.xg;
        }
        cw() {
            this.cu.w5.aay = this.cu.yt;
        }
        cv() {
            this.cu.w5.aa6 = this.cu.yr;
        }
        c2() {
            this.cu.w5.xf = this.cu.xf;
        }
        c0() {
            this.cu.w5.x7 = this.cu.xv;
        }
        c1() {
            this.cu.w5.xo = this.cu.xg;
        }
        c3() {
            this.cu.w5.aae = this.cu.xh;
        }
        c5() {
            this.cu.w5.xAxis = this.cu.dc.w7;
        }
        c6() {
            this.cu.w5.yAxis = this.cu.dc.w9;
        }
        c4() {
            let a = this.cu.w5;
            if (this.cu.dc == null) {
                a.xAxis = null;
                a.yAxis = null;
                return;
            }
            a.xAxis = this.cu.dc.w7;
            a.yAxis = this.cu.dc.w9;
        }
        cy() {
            this.cu.w5.yy = this.cu.yd;
        }
        cx() {
            this.cu.w5.yo = this.cu.x9;
        }
        cz() {
            this.cu.w5.yp = this.cu.ya;
        }
    }
    GeographicSymbolSeriesView.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesView, 'GeographicSymbolSeriesView', HostSeriesView.$);
    return GeographicSymbolSeriesView;
})();
/**
 * @hidden
 */
export let GeographicSymbolSeries = /*@__PURE__*/ (() => {
    class GeographicSymbolSeries extends GeographicMarkerSeries {
        bk() {
            return new GeographicSymbolSeries();
        }
        get_ek() {
            return true;
        }
        constructor() {
            super();
            this.yf = null;
            this.yi = false;
            this.yh = false;
            this.assigningScatterStyle = null;
            this.assigningScatterMarkerStyle = null;
            this.ab = GeographicSymbolSeries.$;
        }
        ct() {
            return new GeographicSymbolSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.yg = a;
        }
        jm() {
            return 0.7;
        }
        w4() {
            return new ScatterSeries();
        }
        get_ff() {
            return true;
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.yg.c4();
                    break;
                case GeographicSymbolSeries.$$p[5]:
                    this.yg.cw();
                    break;
                case GeographicSymbolSeries.$$p[4]:
                    this.yg.cv();
                    break;
                case GeographicSymbolSeries.$$p[6]:
                    this.yg.cy();
                    break;
                case "XAxis":
                    this.yg.c5();
                    break;
                case "YAxis":
                    this.yg.c6();
                    break;
                case GeographicSymbolSeries.$$p[1]:
                    this.w5.zu = this.yk;
                    this.yi = this.yk;
                    if (this.yk) {
                        let e = this.w5;
                        e.assigningScatterStyle = delegateCombine(e.assigningScatterStyle, runOn(this, this.yy));
                    }
                    else {
                        let f = this.w5;
                        f.assigningScatterStyle = delegateRemove(f.assigningScatterStyle, runOn(this, this.yy));
                    }
                    break;
                case GeographicSymbolSeries.$$p[0]:
                    this.w5.zt = this.yj;
                    this.yh = this.yj;
                    if (this.yk) {
                        let g = this.w5;
                        g.assigningScatterMarkerStyle = delegateCombine(g.assigningScatterMarkerStyle, runOn(this, this.yx));
                    }
                    else {
                        let h = this.w5;
                        h.assigningScatterMarkerStyle = delegateRemove(h.assigningScatterMarkerStyle, runOn(this, this.yx));
                    }
                    break;
                case GeographicSymbolSeries.$$p[2]:
                    this.w5.zd = this.ye;
                    break;
                case GeographicSymbolSeries.$$p[3]:
                    this.w5.aad = this.ym;
                    break;
            }
        }
        yy(a, b) {
            if (this.assigningScatterStyle != null) {
                this.assigningScatterStyle(this, b);
            }
        }
        yx(a, b) {
            if (this.assigningScatterMarkerStyle != null) {
                this.assigningScatterMarkerStyle(this, b);
            }
        }
    }
    GeographicSymbolSeries.$t = /*@__PURE__*/ markType(GeographicSymbolSeries, 'GeographicSymbolSeries', GeographicMarkerSeries.$);
    GeographicSymbolSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicSymbolSeries, 'raisePropertyChanged', ['IsCustomScatterMarkerStyleAllowed:yj:yz', [0, false], 'IsCustomScatterStyleAllowed:yk:y0', [0, false], 'ItemSearchMode:ye:y1', [ScatterItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:ym:y2', [1, 10000], 'LatitudeMemberPath:yr:y3', [2, null], 'LongitudeMemberPath:yt:y4', [2, null], 'MarkerCollisionAvoidance:yd:y5', [CollisionAvoidanceType_$type, /*@__PURE__*/ enumGetBox(CollisionAvoidanceType_$type, 0)], 'UseLightweightMarkers:yl:y6', [0, false]]);
    return GeographicSymbolSeries;
})();
