/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ShapeSeriesBase } from "igniteui-react-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-react-core";
import { EventArgs, runOn, delegateRemove, delegateCombine, typeCast, markType } from "igniteui-react-core";
import { XamGeographicMap } from "./XamGeographicMap";
import { ShapeSeriesViewBase } from "igniteui-react-charts";
import { RenderingContext } from "igniteui-react-core";
import { GeometryGroup } from "igniteui-react-core";
import { Defaults } from "igniteui-react-charts";
import { CanvasViewRenderer } from "igniteui-react-core";
import { truncate } from "igniteui-react-core";
/**
 * @hidden
 */
export let TileSeries = /*@__PURE__*/ (() => {
    class TileSeries extends ShapeSeriesBase {
        bk() {
            return new TileSeries();
        }
        get_f4() {
            return true;
        }
        constructor() {
            super();
            this.aae = null;
            this.aad = null;
            this.imageTilesReady = null;
            this.aah = null;
            this.aai = false;
            this.ab = TileSeries.$;
        }
        ct() {
            return new TileSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.aac = a;
        }
        get_yf() {
            return false;
        }
        get aag() {
            return this.aae;
        }
        set aag(a) {
            let b = a != this.aag;
            if (b) {
                let c = this.aag;
                this.aae = a;
                this.raisePropertyChanged("TileImagery", c, a);
            }
        }
        get aaf() {
            return this.aad;
        }
        set aaf(a) {
            let b = this.aad;
            this.aad = a;
            this.raisePropertyChanged("ActualTileImagery", b, this.aad);
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            let e;
            let f;
            switch (b) {
                case "TileImagery":
                    e = c;
                    f = d;
                    if (e != null) {
                        e.propertyChanged = delegateRemove(e.propertyChanged, runOn(this, this.aal));
                    }
                    if (f != null) {
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.aal));
                    }
                    this.aac.dv(e, f);
                    this.ru(false);
                    this.qn();
                    break;
                case "ActualTileImagery":
                    e = c;
                    f = d;
                    if (e != null) {
                        e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.aam));
                        e.deferralHandler = null;
                    }
                    if (f != null) {
                        f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.aam));
                        f.deferralHandler = this;
                    }
                    this.aac.du(e, f);
                    if (f != null && typeCast(XamGeographicMap.$, this.dc) !== null) {
                        f.geographicMap = this.dc;
                        this.aao(this.cw);
                        this.aac.dr(this.dc.wh);
                    }
                    this.qn();
                    break;
                case "ActualWindowRect":
                    this.aac.dr(d);
                    break;
                case "WorldRect":
                    this.aac.dy(d);
                    break;
                case "SeriesViewer":
                    let g = c;
                    let h = d;
                    if (g != null && this.aaf != null) {
                        this.aaf.be(null);
                    }
                    if (h != null && this.aaf != null) {
                        this.aaf.be(this.cw.ae);
                    }
                    break;
                case "ActualBrush":
                case "ActualOutline":
                case "ActualThickness":
                    this.qp();
                    break;
            }
        }
        aal(a, b) {
            if (b.propertyName == "MultiScaleImage") {
                this.aao(this.cw);
            }
        }
        aam(a, b) {
            if (this.imageTilesReady != null) {
                this.imageTilesReady(this, new EventArgs());
            }
            if (!this.aai) {
                this.aac.dw();
            }
        }
        register(a, b) {
            this.aah = b;
        }
        unRegister(a) {
            this.aah = null;
        }
        deferredRefresh() {
            this.ru(false);
        }
        deferAction(a) {
            if (this.j0 != null) {
                this.j0.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        }
        su(a, b) {
            this.aac.dx();
            super.su(a, b);
        }
        rv(a) {
            super.rv(a);
            this.aan(a, this.cw);
        }
        aan(a, b) {
            let c;
            let d;
            let e = b;
            let f = b.getViewInfo(c, d);
            c = f.p0;
            d = f.p1;
            this.aao(b);
            if (this.aah != null) {
                this.aai = true;
                this.aah(a);
                this.aai = false;
            }
            e.dw();
        }
        rt(a, b, c, d, e) {
            super.rt(a, b, c, d, e);
            let f = this.ho.item(d);
            f.bd(c);
            if (this.d7(f)) {
                return;
            }
            this.zs(f);
        }
        aao(a) {
            let b;
            let c;
            let d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            if (this.aag != null && this.aag.ao != null) {
                if (this.aag != this.aaf) {
                    this.aaf = this.aag;
                }
                if (this.aaf != null && !b.isEmpty) {
                    if (this.aaf.width != b.width) {
                        this.aaf.width = b.width;
                    }
                    if (this.aaf.height != b.height) {
                        this.aaf.height = b.height;
                    }
                }
            }
        }
        o7(a, b) {
            super.o7(a, b);
            b.ds();
        }
    }
    TileSeries.$t = /*@__PURE__*/ markType(TileSeries, 'TileSeries', ShapeSeriesBase.$, [IMapRenderDeferralHandler_$type]);
    return TileSeries;
})();
/**
 * @hidden
 */
export let TileSeriesView = /*@__PURE__*/ (() => {
    class TileSeriesView extends ShapeSeriesViewBase {
        constructor(a) {
            super(a);
            this.dn = null;
            this.dz = new GeometryGroup();
            this.dq = null;
            this.dp = null;
            this.dn = a;
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.dn.v0 = Defaults.tileSeries_Outline;
                this.dn.vk = Defaults.tileSeries_Brush;
            }
        }
        cx(a, b) {
            if (b.c.count > 0) {
                this.dz.d.add(b);
            }
        }
        di(a, b) {
            return this.dj(a, b, true);
        }
        dh(a, b) {
            return null;
        }
        c1(a, b) {
        }
        cz(a, b, c) {
        }
        c7() {
            super.c7();
            this.dz.d.clear();
        }
        c6() {
            super.c6();
            this.a2();
        }
        dr(a) {
            if (this.dn.aag != null) {
                this.dn.aag.windowRect = a;
            }
        }
        du(a, b) {
            if (this.dq == null) {
                this.dq = this.f.j0.createElement("canvas");
                let c = this.f.j0.get2DCanvasContext(this.dq);
                this.dp = new RenderingContext(new CanvasViewRenderer(), c);
                this.dq.setAttribute("width", this.b9.width.toString());
                this.dq.setAttribute("height", this.b9.height.toString());
            }
            if (a != null) {
                a.bd(null);
                a.be(null);
                a.imagesChanged = delegateRemove(a.imagesChanged, runOn(this, this.dt));
            }
            if (b != null) {
                if (this.ae != null) {
                    b.be(this.ae);
                }
                b.bd(this.dp);
                b.bf(this.b9);
                b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.dt));
            }
        }
        dt(a, b) {
            this.a2();
        }
        dv(a, b) {
        }
        dx() {
            if (this.dq != null) {
                this.dq.setAttribute("width", this.b9.width.toString());
                this.dq.setAttribute("height", this.b9.height.toString());
            }
            if (this.dn.aag != null) {
                this.dn.aag.bf(this.b9);
            }
        }
        bj(a, b) {
            super.bj(a, b);
            if (b) {
                return;
            }
            if (this.dq == null) {
                return;
            }
            let c = false;
            if (this.dz.d.count > 0) {
                c = true;
                this.m.aa();
                this.m.r(this.dz);
                let d = this.m.h();
                d.clip();
            }
            let e = truncate(Math.round(this.b9.left));
            let f = truncate(Math.round(this.b9.top));
            let g = truncate(Math.round(this.b9.width));
            let h = truncate(Math.round(this.b9.height));
            this.m.o(this.dq.getNativeElement(), 1, e, f, g, h, e, f, g, h);
            if (c) {
                this.m.z();
            }
        }
        dw() {
            this.a2();
        }
        ds() {
        }
        dy(a) {
            if (this.dn.aag != null) {
                this.dn.aag.a6();
            }
        }
    }
    TileSeriesView.$t = /*@__PURE__*/ markType(TileSeriesView, 'TileSeriesView', ShapeSeriesViewBase.$);
    return TileSeriesView;
})();
