/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { SeriesViewer } from "igniteui-react-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { MapResizeBehavior_$type } from "./MapResizeBehavior";
import { MapBackgroundTilingMode_$type } from "./MapBackgroundTilingMode";
import { Rect } from "igniteui-react-core";
import { Base, Boolean_$type, typeCast, enumGetBox, Point_$type, fromEnum, Number_$type, runOn, delegateRemove, delegateCombine, markType, markDep, INotifyPropertyChanged_$type, PropertyChangedEventArgs, String_$type, IEnumerable_$type } from "igniteui-react-core";
import { NumericXAxis } from "igniteui-react-charts";
import { NumericYAxis } from "igniteui-react-charts";
import { SphericalMercatorVerticalScaler } from "./SphericalMercatorVerticalScaler";
import { Control } from "igniteui-react-core";
import { SphericalMercatorHorizontalScaler } from "./SphericalMercatorHorizontalScaler";
import { ScalerParams } from "igniteui-react-charts";
import { SeriesViewerView } from "igniteui-react-charts";
import { Tuple$2 } from "igniteui-react-core";
import { MathUtil } from "igniteui-react-core";
import { ImageTilesReadyEventArgs } from "./ImageTilesReadyEventArgs";
import { ItfConverter } from "igniteui-react-core";
import { ChartVisualData } from "igniteui-react-charts";
import { RectData } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-react-core";
import { XamMultiScaleImage } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { ImagesChangedEventArgs } from "./ImagesChangedEventArgs";
import { HostSeriesView } from "./HostSeriesView";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { ScatterAreaSeries } from "igniteui-react-charts";
import { BrushCollection } from "igniteui-react-core";
import { Defaults } from "igniteui-react-charts";
import { OpenStreetMapTileSource } from "igniteui-react-core";
import { ColorScale } from "igniteui-react-charts";
/**
 * @hidden
 */
export let XamGeographicMap = /*@__PURE__*/ (() => {
    class XamGeographicMap extends SeriesViewer {
        constructor() {
            super();
            this.xw = null;
            this.xl = false;
            this.xd = 1;
            this.xs = 0;
            this.y3 = null;
            this.xa = null;
            this.w6 = null;
            this.w8 = null;
            this.xc = null;
            this.yz = { $type: Point_$type, x: NaN, y: NaN };
            this.y6 = null;
            this.xr = 1;
            this.imageTilesReady = null;
            this.xk = null;
            this.y5 = Rect.empty;
            this.xs = SphericalMercatorVerticalScaler.am(XamGeographicMap.y4.bottom) - SphericalMercatorVerticalScaler.am(XamGeographicMap.y4.top);
            this.ab = XamGeographicMap.$;
            this.backgroundContent = new OpenStreetMapImagery();
            let a = ((() => {
                let $ret = new NumericXAxis();
                $ret.bi = this;
                return $ret;
            })());
            a.cf = true;
            this.w7 = a;
            this.w7.n4 = new SphericalMercatorHorizontalScaler();
            let b = ((() => {
                let $ret = new NumericYAxis();
                $ret.bi = this;
                return $ret;
            })());
            b.cf = true;
            this.w9 = b;
            this.w9.n4 = new SphericalMercatorVerticalScaler();
            this.ye();
            this.yl();
            this.n9();
        }
        provideContainer(a) {
            super.provideContainer(a);
            this.w7.provideRenderer(a);
            this.w9.provideRenderer(a);
        }
        n9() {
            super.n9();
            this.xj.fv(this.hk);
        }
        fl() {
            return this.xp;
        }
        fm() {
            return this.xp;
        }
        xg() {
            if (this.xe == 0) {
                if (this.xl) {
                    return 2;
                }
            }
            return 1;
        }
        get xf() {
            return this.xd;
        }
        set xf(a) {
            this.xd = a;
        }
        get y8() {
            return this.y3;
        }
        set y8(a) {
            let b = Rect.l_op_Inequality(this.y3, a);
            if (b) {
                let c = this.y3;
                this.y3 = a;
                this.qv("ActualWorldRect", c, a);
            }
        }
        zc() {
            return this.y8;
        }
        ye() {
            if (this.zk.isEmpty) {
                return;
            }
            this.y8 = this.zi(this.zk, this.cr == 1);
        }
        zi(a, b) {
            let c = a.top;
            let d = a.left;
            let e = a.width;
            let f = a.height;
            let g = SphericalMercatorVerticalScaler.am(a.bottom);
            let h = SphericalMercatorVerticalScaler.am(a.top);
            let i = g - h;
            let j = a.width / XamGeographicMap.y4.width;
            let k = SphericalMercatorVerticalScaler.am(XamGeographicMap.y4.top);
            let l = i / j;
            if (i / j > this.xs) {
                let m = i / this.xs;
                let n = m - j;
                d = d - (n / 2) * XamGeographicMap.y4.width;
                e = m * XamGeographicMap.y4.width;
                if (b) {
                    if (d < XamGeographicMap.y4.left) {
                        d += (XamGeographicMap.y4.left - d);
                    }
                    else if ((d + e) > XamGeographicMap.y4.right) {
                        d -= ((d + e) - XamGeographicMap.y4.right);
                    }
                }
            }
            else if (i / j < this.xs) {
                let o = this.xs * j;
                let p = o - i;
                let q = h - (p / 2);
                let r = g + (p / 2);
                if (b) {
                    if (q < k) {
                        q += (k - q);
                        r += (k - q);
                    }
                    else if (r > (k + this.xs)) {
                        q -= ((r) - (k + this.xs));
                        r -= ((r) - (k + this.xs));
                    }
                }
                c = SphericalMercatorVerticalScaler.aq(q);
                f = SphericalMercatorVerticalScaler.aq(r) - c;
            }
            let s = new Rect(0, d, c, e, f);
            return s;
        }
        get backgroundContent() {
            return this.xa;
        }
        set backgroundContent(a) {
            let b = a != this.backgroundContent;
            if (b) {
                let c = this.backgroundContent;
                this.xa = a;
                this.qv("BackgroundContent", c, a);
            }
        }
        get w7() {
            return this.w6;
        }
        set w7(a) {
            let b = a != this.w7;
            if (b) {
                let c = this.w7;
                this.w6 = a;
                this.qv("XAxis", c, a);
            }
        }
        get w9() {
            return this.w8;
        }
        set w9(a) {
            let b = a != this.w9;
            if (b) {
                let c = this.w9;
                this.w8 = a;
                this.qv("YAxis", c, a);
            }
        }
        getZoomRectFromGeoRect(a) {
            return this.getZoomFromGeographicRect(a);
        }
        yo(a) {
            this.w0 = a;
        }
        yn(a) {
            this.zk = a;
        }
        getZoomFromGeographicRect(a) {
            return this.za(a, true, 0);
        }
        y9(a, b) {
            return this.za(a, false, b);
        }
        za(a, b, c) {
            let d = a;
            if (b) {
                d = this.zi(a, false);
            }
            let e = this.w7;
            let f = this.w9;
            let g = new ScalerParams(1, XamGeographicMap.y7, this.wz, e.ch);
            g.c = this.wl;
            let h = new ScalerParams(1, XamGeographicMap.y7, this.wz, f.ch);
            h.c = this.wl;
            let i = this.w7.el(d.left, g);
            let j = this.w7.el(d.right, g);
            let k = this.w9.el(d.top, h);
            let l = this.w9.el(d.bottom, h);
            let m = (i - c) / this.wz.width;
            let n = (l - c) / this.wz.height;
            let o = (j - i + (c * 2)) / this.wz.width;
            let p = (k - l + (c * 2)) / this.wz.height;
            let q = new Rect(0, m, n, o, p);
            q.intersect(XamGeographicMap.y7);
            if (q.isEmpty) {
                q = XamGeographicMap.y7;
            }
            return q;
        }
        getZoomFromGeographicPoints(a, b) {
            let c = a.x;
            let d = b.y;
            let e = b.x - a.x;
            let f = a.y - b.y;
            if (e < 0 || f < 0) {
                return XamGeographicMap.y7;
            }
            else {
                let g = new Rect(0, c, d, e, f);
                return this.getZoomFromGeographicRect(g);
            }
        }
        ze(a) {
            let b = this.w7;
            let c = this.w9;
            let d = new ScalerParams(1, a, this.wz, b.ch);
            d.c = this.wl;
            let e = new ScalerParams(1, a, this.wz, c.ch);
            e.c = this.wl;
            let f = this.wk;
            let g = b.eo(f.left, d);
            let h = c.eo(f.top, e);
            let i = b.eo(f.right, d);
            let j = c.eo(f.bottom, e);
            let k = i - g;
            let l = h - j;
            let m = new Rect(0, g, j, k, l);
            if (this.cr == 1) {
                m.intersect(XamGeographicMap.y4);
                if (m.isEmpty) {
                    m = XamGeographicMap.y4;
                }
            }
            return m;
        }
        y0(a) {
            let b = this.w7.mf(a.x);
            let c = this.w9.mf(a.y);
            return { $type: Point_$type, x: b, y: c };
        }
        y1(a) {
            let b = this.w7.e6(a.x);
            let c = this.w9.e6(a.y);
            return { $type: Point_$type, x: b, y: c };
        }
        y2(a) {
            return this.y1(a);
        }
        yb() {
            let a = typeCast(GeographicMapImagery.$, this.backgroundContent);
            if (a != null) {
                a.clearTileCache();
            }
        }
        yh(a) {
        }
        gg() {
            return true;
        }
        yj() {
            this.xj.ee();
            for (let a of fromEnum(this.series)) {
                a.sg();
            }
        }
        ym() {
            if (this.xi == 2) {
                if (!this.wz.isEmpty && this.wz.width > 0 && this.wz.height > 0) {
                    let a = this.w7.mf(this.wz.left + (this.wz.width / 2));
                    let b = this.w9.mf(this.wz.top + (this.wz.height / 2));
                    this.yz = { $type: Point_$type, x: a, y: b };
                }
            }
            else {
                if (!this.wz.isEmpty && this.wz.width > 0 && this.wz.height > 0) {
                    let c = this.w7.mf(this.wz.left);
                    let d = this.w9.mf(this.wz.top);
                    this.yz = { $type: Point_$type, x: c, y: d };
                }
            }
        }
        yi() {
            if (isNaN_(this.yz.x) || isNaN_(this.yz.y)) {
                this.ym();
            }
            let a = this.yz.x;
            let b = this.yz.y;
            if (!isNaN_(a) && !isNaN_(b)) {
                let c = this.wh.left;
                let d = this.wh.top;
                let e = this.wh.width;
                let f = this.wh.height;
                if (e > this.y6.width) {
                }
                else {
                    let g = new ScalerParams(1, XamGeographicMap.y7, this.wz, this.w7.ch);
                    g.c = this.wl;
                    let h = this.w7.el(a, g);
                    if (this.xi == 2) {
                        let i = h / this.wz.width;
                        c = i - (e / 2);
                    }
                    else {
                        c = h / this.wz.width;
                    }
                    if (c + e > this.y6.right) {
                        c = this.y6.right - e;
                    }
                    else if (c < this.y6.left) {
                        c = this.y6.left;
                    }
                }
                if (f > this.y6.height) {
                }
                else {
                    let j = new ScalerParams(1, XamGeographicMap.y7, this.wz, this.w9.ch);
                    j.c = this.wl;
                    let k = this.w9.el(b, j);
                    if (this.xi == 2) {
                        let l = k / this.wz.height;
                        d = l - (f / 2);
                    }
                    else {
                        d = k / this.wz.height;
                    }
                    if (d + f > this.y6.bottom) {
                        d = this.y6.bottom - f;
                    }
                    else if (d < this.y6.top) {
                        d = this.y6.top;
                    }
                }
                this.r6(new Rect(0, c, d, e, f), false);
            }
        }
        get_fd() {
            return true;
        }
        wi() {
            let a = super.wi();
            if (this.w7 == null || this.w9 == null) {
                return a;
            }
            this.wt();
            let b = a.left;
            let c = a.top;
            if (this.cr == 1) {
                if (this.w0.width > this.y6.width) {
                    b = 0.5 - (this.w0.width / 2);
                }
                else if (b + a.width > this.y6.right) {
                    b = this.y6.right - this.w0.width;
                }
                else if (b < this.y6.left) {
                    b = this.y6.left;
                }
                if (this.w0.height > this.y6.height) {
                    c = 0.5 - (this.w0.height / 2);
                }
                else if (c + this.w0.height > this.y6.bottom) {
                    c = this.y6.bottom - this.w0.height;
                }
                else if (c < this.y6.top) {
                    c = this.y6.top;
                }
            }
            let d = false;
            if (!this.xo && this.cr == 2 && this.xl) {
                if (b > 1) {
                    b = (b - Math.floor(b)) + 1;
                }
                if (b < 0) {
                    b = 0 - (Math.ceil(b) - b);
                }
                if ((a.right - this.y6.right) > 0 && ((a.right - this.y6.right) / a.width) > 0.8) {
                    b = this.y6.left - (a.width - (a.right - this.y6.right));
                    d = true;
                }
                else if (a.left < this.y6.left && (Math.abs(a.left - this.y6.left) / a.width) > 0.8) {
                    b = this.y6.right - (Math.abs(a.left - this.y6.left));
                    d = true;
                }
            }
            let e = new Rect(0, b, c, a.width, a.height);
            if (this.xo) {
                let f = this.y9(this.zk, 1);
                f = this.zb(f);
                let g = e.left + e.width / 2;
                let h = e.top + e.height / 2;
                if (e.width > f.width) {
                    let i = e.height / e.width;
                    let j = f.width;
                    let k = i * j;
                    e = new Rect(0, g - j / 2, h - k / 2, j, k);
                    d = true;
                }
                if (e.height > f.height) {
                    let l = e.width / e.height;
                    let m = f.height;
                    let n = l * m;
                    e = new Rect(0, g - n / 2, h - m / 2, n, m);
                    d = true;
                }
                if (e.left < f.left) {
                    e = new Rect(0, f.left, e.top, e.width, e.height);
                    d = true;
                }
                if (e.top < f.top) {
                    e = new Rect(0, e.left, f.top, e.width, e.height);
                    d = true;
                }
                if (e.right > f.right) {
                    e = new Rect(0, f.right - e.width, e.top, e.width, e.height);
                    d = true;
                }
                if (e.bottom > f.bottom) {
                    e = new Rect(0, e.left, f.bottom - e.height, e.width, e.height);
                    d = true;
                }
            }
            if (d) {
                this.ez = true;
                this.w0 = e;
                this.ez = false;
            }
            return e;
        }
        nd(a, b) {
            let c = true;
            let d = true;
            let e = 0;
            let f = this.wt();
            let g = 0;
            let h = 0;
            if ((a.right - f.right) > 0) {
                g = ((a.right - f.right) / a.width);
            }
            if (a.left < f.left) {
                h = (Math.abs(a.left - f.left) / a.width);
            }
            if (h == 0 && g == 0) {
                c = false;
            }
            if (h > g) {
                d = false;
            }
            if (c) {
                if (d) {
                    let i = this.w6.el(-180, b);
                    let j = this.w6.el(180, b);
                    e = j - i;
                }
                else {
                    let k = this.w6.el(-180, b);
                    let l = this.w6.el(180, b);
                    e = k - l;
                }
            }
            return new Tuple$2(Boolean_$type, Number_$type, c, e);
        }
        wt() {
            let a = new ScalerParams(1, XamGeographicMap.y7, this.wz, this.w7.ch);
            a.c = this.wl;
            let b = new ScalerParams(1, XamGeographicMap.y7, this.wz, this.w9.ch);
            b.c = this.wl;
            let c = this.w7.el(XamGeographicMap.y4.left, a);
            let d = this.w7.el(XamGeographicMap.y4.right, a);
            let e = this.w9.el(XamGeographicMap.y4.top, b);
            let f = this.w9.el(XamGeographicMap.y4.bottom, b);
            this.y6 = new Rect(0, c / this.wz.width, f / this.wz.height, (d - c) / this.wz.width, (e - f) / this.wz.height);
            return this.y6;
        }
        zb(a) {
            let b = this.ho;
            let c = 0.5 * (a.left + a.right);
            let d = 0.5 * (a.top + a.bottom);
            let e = a.width;
            let f = a.height;
            let g = MathUtil.d(a.width, b, 1);
            let h = MathUtil.d(a.height, b, 1);
            let i = this.wz;
            let j = i.width / i.height;
            let k = g * i.width;
            let l = h * i.height;
            let m = k / l;
            if (m != j) {
                if (l * j > k) {
                    k = l * j;
                    g = k / i.width;
                }
                else {
                    l = k / j;
                    h = l / i.height;
                }
            }
            let n = g != e;
            let o = h != f;
            let p = n ? c - 0.5 * g : a.left;
            let q = o ? d - 0.5 * h : a.top;
            let r = n ? c + 0.5 * g : a.right;
            let s = o ? d + 0.5 * h : a.bottom;
            if (p < 0) {
                p = 0;
                r = p + g;
            }
            if (r > 1) {
                r = 1;
                p = r - g;
            }
            if (q < 0) {
                q = 0;
                s = q + h;
            }
            if (s > 1) {
                s = 1;
                q = s - h;
            }
            return new Rect(0, p, q, r - p, s - q);
        }
        wj(a) {
            super.wj(this.wz);
            if (a.isEmpty) {
                return Rect.empty;
            }
            let b;
            if (a.width > a.height) {
                let c = intDivide(truncate((a.width - a.height)), 2);
                b = new Rect(0, a.left + c, a.top, a.height, a.height);
            }
            else {
                let d = intDivide(truncate((a.height - a.width)), 2);
                b = new Rect(0, a.left, a.top + d, a.width, a.width);
            }
            return b;
        }
        zd(a) {
            return this.wj(a);
        }
        c8() {
            return new XamGeographicMapView(this);
        }
        yd(a) {
            if (a != null) {
                a.bi = this;
            }
        }
        qe(a) {
            super.qe(a);
            this.xj = a;
        }
        qp(a, b) {
            super.qp(a, b);
            this.ru(this.w7);
            this.ru(this.w9);
            if (Rect.l_op_Inequality(a, b)) {
                this.yi();
            }
            if (this.xo) {
                this.wh = this.wi();
            }
            this.yp();
        }
        get xt() {
            return this.xr;
        }
        set xt(a) {
            let b = this.xr;
            this.xr = a;
            this.qv("ActualWindowScale", b, this.xr);
        }
        hu() {
            return this.xt;
        }
        hv() {
            return this.xt;
        }
        rt() {
            super.rt();
            let a = Math.min(this.wh.width, this.wh.height);
            this.xt = a;
        }
        f4() {
            return this.xl;
        }
        cs() {
            if (this.ct == 0) {
                if (this.xm) {
                    return 2;
                }
            }
            return this.ct;
        }
        qq(a, b, c, d) {
            super.qq(a, b, c, d);
            switch (b) {
                case "ZoomCoercionMode":
                    this.ye();
                    break;
                case "WindowRect":
                    this.ym();
                    break;
                case XamGeographicMap.$$p[0]:
                    this.xf = this.xg();
                    if (this.xc != null) {
                        this.xc.isHorizontalWrappingEnabled = this.xf == 2;
                    }
                    break;
                case XamGeographicMap.$$p[1]:
                    this.xl = this.xm;
                    this.xf = this.xg();
                    this.cr = this.cs();
                    if (this.xc != null) {
                        this.xc.isHorizontalWrappingEnabled = this.xf == 2;
                    }
                    break;
                case XamGeographicMap.$$p[4]:
                    this.wh = this.wi();
                    break;
                case "BackgroundContent":
                    if (this.xc != null) {
                        let e = this.xc;
                        e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.yf));
                        this.xc.deferralHandler = null;
                    }
                    this.xc = typeCast(GeographicMapImagery.$, this.backgroundContent);
                    if (this.xc != null) {
                        let f = this.xc;
                        f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.yf));
                        this.xc.deferralHandler = this;
                        this.xc.isHorizontalWrappingEnabled = this.xf == 2;
                    }
                    this.xj.fu(typeCast(GeographicMapImagery.$, c), typeCast(GeographicMapImagery.$, d));
                    if (this.xc != null) {
                        this.xc.geographicMap = this;
                        this.xj.fr(this.wh);
                        this.xj.fv(this.hk);
                    }
                    break;
                case "YAxis":
                case "XAxis":
                    this.yk(c);
                    this.yd(d);
                    break;
                case XamGeographicMap.$$p[6]:
                    if (!this.xn) {
                        this.w0 = XamGeographicMap.y7;
                    }
                    this.ye();
                    this.yl();
                    this.ym();
                    this.wh = this.wi();
                    this.xj.fs();
                    break;
                case "ActualWindowRect":
                    this.xj.fr(this.wh);
                    break;
                case "ActualWorldRect":
                    for (let g of fromEnum(this.series)) {
                        g.ru(false);
                    }
                    break;
                case XamGeographicMap.$$p[5]:
                    this.xt = this.xu;
                    break;
                case "ActualWindowScale":
                    if (!this.gc) {
                        this.r4(this.hu(), this.hv());
                    }
                    break;
                case "ActualPixelScalingRatio":
                    this.xj.fv(this.hk);
                    break;
                case "WindowRectMinWidth":
                case "WindowRectMinHeight":
                    let h = d;
                    if (isNaN_(h) || isInfinity(h)) {
                        this.ho = 5E-06;
                        this.hn = 5E-06;
                    }
                    else {
                        this.ho = h;
                        this.hn = h;
                    }
                    break;
                case XamGeographicMap.$$p[7]:
                    this.r0();
                    break;
                case "MarkerAutomaticBehavior":
                    for (let i of fromEnum(this.series)) {
                        i.qi();
                    }
                    break;
            }
        }
        yf(a, b) {
            if (this.imageTilesReady != null) {
                this.imageTilesReady(this, new ImageTilesReadyEventArgs());
            }
        }
        yk(a) {
            if (a != null) {
                a.bi = null;
            }
        }
        yl() {
            if (this.w7 != null) {
                this.w7.mc = this.y8.left;
                this.w7.mb = this.y8.right;
            }
            if (this.w9 != null) {
                this.w9.mc = this.y8.top;
                this.w9.mb = this.y8.bottom;
            }
            this.w7.c2(true);
            this.w9.c2(true);
        }
        getFontInfo() {
            this.xk = this.xj.fo;
            return this.xk;
        }
        vl() {
            return this.xj.fw;
        }
        getFontBrush() {
            return this.xj.fx;
        }
        rm(a, b) {
            if (typeCast(ItfConverter.$, b) !== null) {
                let c = b;
                let d = a;
                d.itemsSource = c.triangulationSource.points;
                d.xe = c.triangulationSource.triangles;
            }
            else {
                super.rm(a, b);
            }
        }
        register(a, b) {
            this.ra(a, b);
        }
        unRegister(a) {
            this.rs(a);
        }
        deferredRefresh() {
            this.nr();
        }
        deferAction(a) {
            if (this.xw != null) {
                this.xw.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        }
        yc(a) {
            this.rz(a);
        }
        xx() {
            let a = new ChartVisualData();
            let b = this.w7.fy();
            let c = this.w9.fy();
            a.axes.add1(b);
            a.axes.add1(c);
            for (let d = 0; d < this.series.count; d++) {
                let e = this.series._inner[d].kn();
                a.series.add1(e);
            }
            a.name = this.name;
            a.contentArea = RectData.b(this.wz);
            a.centralArea = RectData.b(this.wz);
            a.plotArea = RectData.b(this.wz);
            return a;
        }
        wp(a, b, c) {
            return a;
        }
        yg() {
        }
        get zj() {
            return this.y5;
        }
        set zj(a) {
            this.y5 = a;
        }
        yq(a) {
            this.zj = a;
            this.yp();
        }
        yp() {
            if (this.xq && !this.zj.isEmpty) {
                let a = this.getZoomFromGeographicRect(this.zj);
                this.zj = Rect.empty;
                this.r6(a, false);
            }
        }
        get xq() {
            return !this.wz.isEmpty && !this.wl.isEmpty;
        }
    }
    XamGeographicMap.$t = /*@__PURE__*/ markType(XamGeographicMap, 'XamGeographicMap', SeriesViewer.$, [IMapRenderDeferralHandler_$type]);
    XamGeographicMap.xh = 0;
    XamGeographicMap.y4 = /*@__PURE__*/ new Rect(2, { $type: Point_$type, x: -180, y: -85.05112878 }, { $type: Point_$type, x: 180, y: 85.05112878 });
    XamGeographicMap.y7 = /*@__PURE__*/ new Rect(0, 0, 0, 1, 1);
    XamGeographicMap.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, XamGeographicMap, 'qv', ['BackgroundTilingMode:xe:yr', [MapBackgroundTilingMode_$type, /*@__PURE__*/ enumGetBox(MapBackgroundTilingMode_$type, 0)], 'IsHorizontalWrappingEnabled:xm:ys', [0, false], 'ResizeBehavior:xi:yt', [MapResizeBehavior_$type, /*@__PURE__*/ enumGetBox(MapResizeBehavior_$type, XamGeographicMap.xh)], 'SuppressZoomResetOnWorldRectChange:xn:yu', [0, false], 'UseWorldRectForZoomBounds:xo:yv', [0, false], 'WindowScale:xu:yw', [1, NaN], 'WorldRect:zk:yx', [Rect.$, XamGeographicMap.y4], 'Zoomable:xp:yy', [0, true]]);
    return XamGeographicMap;
})();
/**
 * @hidden
 */
export let GeographicMapImagery = /*@__PURE__*/ (() => {
    class GeographicMapImagery extends Control {
        constructor(a) {
            super();
            this.ak = null;
            this.imageTilesReady = null;
            this.an = null;
            this.ap = null;
            this.propertyChanged = null;
            this.imagesChanged = null;
            this.cancellingImage = null;
            this.downloadingImage = null;
            this.ab = GeographicMapImagery.$;
            this.ap = a;
            this.aj = this.ai();
            this.bb(this.aj);
        }
        bb(a) {
        }
        ai() {
            return new GeographicMapImageryView(this);
        }
        get deferralHandler() {
            return this.ak;
        }
        set deferralHandler(a) {
            this.ak = a;
            if (this.ao != null) {
                this.ao.al = a;
            }
        }
        a5(a, b) {
            if (this.imageTilesReady != null) {
                this.imageTilesReady(this, new ImageTilesReadyEventArgs());
            }
        }
        a9() {
            let a = this.ao;
            a.imageTilesReady = delegateCombine(a.imageTilesReady, runOn(this, this.a5));
            this.ao.al = this.deferralHandler;
            let b = this.ao;
            b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.a4));
            let c = this.ao;
            c.downloadingImage = delegateCombine(c.downloadingImage, runOn(this, this.a3));
            let d = this.ao;
            d.cancellingImage = delegateCombine(d.cancellingImage, runOn(this, this.a2));
            this.ao.bf = this.referer;
            this.ao.bj = this.userAgent;
            this.ao.av = this.isHorizontalWrappingEnabled;
        }
        a3(a, b) {
            if (this.downloadingImage != null) {
                this.downloadingImage(this, b);
            }
        }
        a2(a, b) {
            if (this.cancellingImage != null) {
                this.cancellingImage(this, b);
            }
        }
        bg() {
            if (this.ao != null) {
                this.aj.e();
            }
        }
        ba(a, b, c) {
            switch (a) {
                case GeographicMapImagery.$$p[3]:
                    this.bg();
                    break;
                case "GeographicMap":
                    this.aj.e();
                    break;
                case GeographicMapImagery.$$p[1]:
                    if (this.ao != null) {
                        this.ao.bf = this.referer;
                    }
                    break;
                case GeographicMapImagery.$$p[2]:
                    if (this.ao != null) {
                        this.ao.bj = this.userAgent;
                    }
                    break;
                case GeographicMapImagery.$$p[0]:
                    if (this.ao != null) {
                        this.ao.av = this.isHorizontalWrappingEnabled;
                    }
                    break;
            }
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
        }
        get geographicMap() {
            return this.c(GeographicMapImagery.geographicMapProperty);
        }
        set geographicMap(a) {
            this.h(GeographicMapImagery.geographicMapProperty, a);
        }
        static a8(a, b) {
            a.a7(b.oldValue, b.newValue);
        }
        a7(a, b) {
            this.ba("GeographicMap", a, b);
        }
        clearTileCache() {
            if (this.ao != null) {
                this.ao.bs(0, 0, 0, 0);
            }
        }
        get ao() {
            return this.an;
        }
        set ao(a) {
            this.an = a;
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs("MultiScaleImage"));
            }
        }
        bn(a) {
            if (this.geographicMap == null || a.width < 1 || a.height < 1) {
                return a;
            }
            let b = new Rect(0, 0, 0, a.width, a.height);
            let c = this.geographicMap.zd(b);
            let d = XamGeographicMap.y4;
            let e = this.geographicMap.y8;
            let f = Math.min(this.windowRect.height, this.windowRect.width);
            let g = e.width / d.width;
            this.ao.a5 = (b.width / c.width) * f * g;
            let h = this.geographicMap.w7;
            let i = this.geographicMap.w9;
            let j = new ScalerParams(1, this.windowRect, b, h.ch);
            j.c = c;
            let k = new ScalerParams(1, this.windowRect, b, i.ch);
            k.c = c;
            let l = h.el(d.left, j);
            let m = i.el(d.bottom, k);
            let n = (-l / b.width) * this.ao.a5;
            let o = (-m / b.height) * this.ao.a5 * (b.height / b.width);
            this.ao.cm = { $type: Point_$type, x: n, y: o };
            return a;
        }
        bd(a) {
            this.aj.f(a);
        }
        bf(a) {
            this.aj.h(a);
        }
        be(a) {
            this.aj.g(a);
        }
        a4(a, b) {
            if (this.imagesChanged != null) {
                this.imagesChanged(this, new ImagesChangedEventArgs());
            }
        }
        a6() {
            this.aj.e();
        }
        bc(a) {
            this.aj.i(a);
        }
        v() {
            super.v();
            this.ap.o = this._opacity;
        }
    }
    GeographicMapImagery.$t = /*@__PURE__*/ markType(GeographicMapImagery, 'GeographicMapImagery', Control.$, [INotifyPropertyChanged_$type]);
    GeographicMapImagery.geographicMapProperty = /*@__PURE__*/ DependencyProperty.i("GeographicMap", XamGeographicMap.$, GeographicMapImagery.$, /*@__PURE__*/ new PropertyMetadata(2, null, GeographicMapImagery.a8));
    GeographicMapImagery.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicMapImagery, 'ba', ['IsHorizontalWrappingEnabled', [0, false], 'Referer', [2, null], 'UserAgent', [2, null], 'WindowRect', [Rect.$, Rect.empty]]);
    return GeographicMapImagery;
})();
/**
 * @hidden
 */
export let GeographicMapImageryView = /*@__PURE__*/ (() => {
    class GeographicMapImageryView extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.j = null;
            this.d = null;
            this.b = 1;
            this.j = Rect.empty;
            this.a = a;
            this.a.ao = new XamMultiScaleImage();
            this.a.ao.ao = this.a.ap;
            this.a.a9();
        }
        e() {
            if (this.j.isEmpty) {
                return;
            }
            this.a.bn(new Size(1, this.j.width, this.j.height));
        }
        f(a) {
            this.a.ao.b1(a);
        }
        g(a) {
            this.d = a;
            this.a.ao.b2(a);
        }
        h(a) {
            this.j = a;
            this.a.ao.b3(a);
            this.a.a6();
        }
        get c() {
            return this.b;
        }
        i(a) {
            this.b = a;
            this.a.ao.bz(a);
        }
    }
    GeographicMapImageryView.$t = /*@__PURE__*/ markType(GeographicMapImageryView, 'GeographicMapImageryView');
    return GeographicMapImageryView;
})();
/**
 * @hidden
 */
export let GeographicXYTriangulatingSeriesView = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.cu = null;
            this.cu = a;
        }
        ci() {
            super.ci();
            let a = this.cu.w5;
            a.x5 = this.cu.xh;
            a.yd = this.cu.xf;
            a.trianglesSource = this.cu.xe;
            a.xt = this.cu.xk;
            a.xv = this.cu.xm;
            a.xx = this.cu.xo;
        }
        cx() {
            let a = this.cu.w5;
            if (this.cu.dc == null) {
                a.w3 = null;
                a.w4 = null;
                return;
            }
            a.w3 = this.cu.dc.w7;
            a.w4 = this.cu.dc.w9;
        }
        cw() {
            this.cu.w5.x5 = this.cu.xh;
        }
        cv() {
            this.cu.w5.yd = this.cu.xf;
        }
        cy() {
            this.cu.w5.trianglesSource = this.cu.xe;
        }
        cz() {
            this.cu.w5.xt = this.cu.xk;
        }
        c0() {
            this.cu.w5.xv = this.cu.xm;
        }
        c1() {
            this.cu.w5.xx = this.cu.xo;
        }
    }
    GeographicXYTriangulatingSeriesView.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeriesView, 'GeographicXYTriangulatingSeriesView', HostSeriesView.$);
    return GeographicXYTriangulatingSeriesView;
})();
/**
 * @hidden
 */
export let GeographicScatterAreaSeriesView = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeriesView extends GeographicXYTriangulatingSeriesView {
        constructor(a) {
            super(a);
            this.c2 = null;
            this.c2 = a;
        }
        a4() {
            super.a4();
            if (!this.t) {
            }
        }
        ci() {
            super.ci();
            if (this.c2.xz != null) {
                this.c2.xz.zc = this.c2.x3;
                this.c2.xz.y0 = this.c2.xy;
            }
        }
        c3() {
            if (this.c2.xz != null) {
                this.c2.xz.zc = this.c2.x3;
            }
        }
        c4() {
            if (this.c2.xz != null) {
                this.c2.xz.y0 = this.c2.xy;
            }
        }
    }
    GeographicScatterAreaSeriesView.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeriesView, 'GeographicScatterAreaSeriesView', GeographicXYTriangulatingSeriesView.$);
    return GeographicScatterAreaSeriesView;
})();
/**
 * @hidden
 */
export let XamGeographicMapView = /*@__PURE__*/ (() => {
    class XamGeographicMapView extends SeriesViewerView {
        constructor(a) {
            super(a);
            this.fn = null;
            this.fz = null;
            this.fx = null;
            this.fw = null;
            this.fo = null;
            this.fp = NaN;
            this.fz = Rect.empty;
            this.fn = a;
            this.fn.ve = 2;
            this.fn.iv = 5E-06;
        }
        m(a) {
            return 2;
        }
        bk(a) {
            this.j.bw(a);
            this.fn.yc(a);
            this.el();
        }
        get_ap() {
            return true;
        }
        d4() {
            let a;
            let b;
            let c;
            let d;
            let e;
            let f = this.j.a8(a, b, c, d, e);
            a = f.p0;
            b = f.p1;
            c = f.p2;
            d = f.p3;
            e = f.p4;
            this.fx = c;
            this.fo = d;
            this.fw = e;
            let g = this.j.e();
            this.fn.ag = g.a;
            this.fn.aj = g.f;
            this.fn.ah = g.b != null ? g.b : new BrushCollection();
            this.fn.ai = g.c != null ? g.c : new BrushCollection();
            if (this.fn.ah.count == 0) {
                for (let h = 0; h < g.a.count; h++) {
                    this.fn.ah.add(g.a.item(h));
                }
            }
            if (g.c.count == 0) {
                for (let i = 0; i < g.f.count; i++) {
                    this.fn.ai.add(g.f.item(i));
                }
            }
        }
        du(a) {
            super.du(a);
            if (this.fn.backgroundContent != null) {
                let b = this.fn.backgroundContent;
                b.be(this.j.ae);
                b.bd(a);
            }
        }
        dv(a) {
            super.dv(a);
            this.fz = a;
            if (this.fn.backgroundContent != null) {
                let b = this.fn.backgroundContent;
                b.bf(this.fz);
            }
        }
        fy() {
            return new Rect(0, 0, 0, this.fz.width, this.fz.height);
        }
        fs() {
            if (this.fn.backgroundContent != null) {
                let a = this.fn.backgroundContent;
                a.a6();
            }
        }
        fr(a) {
            if (this.fn.xc != null) {
                this.fn.xc.windowRect = a;
            }
        }
        fu(a, b) {
            if (this.fn.xc != null) {
                this.fn.xc.windowRect = this.fn.wh;
            }
            if (a != null) {
                let c = a.ao;
                if (c != null) {
                    this.fn.al.h.remove(c.ag);
                }
                a.bd(null);
                a.be(null);
            }
            if (b != null) {
                let d = b.ao;
                if (d != null) {
                    this.fn.al.h.add(d.ag);
                }
                if (!this.fz.isEmpty) {
                    this.dv(this.fz);
                }
                if (this.w != null) {
                    this.du(this.w);
                }
            }
            if (b == null) {
                this.ft(this.w);
            }
        }
        ft(a) {
            let b = this.fn.hk;
            if (b != 1) {
                a.aa();
                a.ab(b, b);
            }
            a.l(this.fz.left, this.fz.top, this.fz.width, this.fz.height);
            if (b != 1) {
                a.z();
            }
        }
        d1() {
            this.fd.ad = Defaults.crosshairLineThickness;
            this.fe.ad = Defaults.crosshairLineThickness;
            this.fd._stroke = Defaults.crosshairLineBrush;
            this.fe._stroke = Defaults.crosshairLineBrush;
            super.d1();
        }
        fv(a) {
            this.fp = a;
            if (this.fn.backgroundContent != null) {
                this.fn.backgroundContent.bc(a);
            }
        }
        get fq() {
            return this.fp;
        }
        set fq(a) {
            this.fp = a;
        }
    }
    XamGeographicMapView.$t = /*@__PURE__*/ markType(XamGeographicMapView, 'XamGeographicMapView', SeriesViewerView.$);
    return XamGeographicMapView;
})();
/**
 * @hidden
 */
export let OpenStreetMapImagery = /*@__PURE__*/ (() => {
    class OpenStreetMapImagery extends GeographicMapImagery {
        constructor() {
            super(new OpenStreetMapTileSource());
        }
        get tilePath() {
            return this.c(OpenStreetMapImagery.tilePathProperty);
        }
        set tilePath(a) {
            this.h(OpenStreetMapImagery.tilePathProperty, a);
        }
        static br(a, b) {
            a.bq("TilePath", b.oldValue, b.newValue);
        }
        bq(a, b, c) {
            switch (a) {
                case "TilePath":
                    this.ap.setTilePathUrl(c == null ? null : c);
                    this.aj.e();
                    break;
            }
            super.ba(a, b, c);
        }
    }
    OpenStreetMapImagery.$t = /*@__PURE__*/ markType(OpenStreetMapImagery, 'OpenStreetMapImagery', GeographicMapImagery.$);
    OpenStreetMapImagery.tilePathProperty = /*@__PURE__*/ DependencyProperty.i("TilePath", String_$type, OpenStreetMapImagery.$, /*@__PURE__*/ new PropertyMetadata(2, null, OpenStreetMapImagery.br));
    return OpenStreetMapImagery;
})();
/**
 * @hidden
 */
export let GeographicXYTriangulatingSeries = /*@__PURE__*/ (() => {
    class GeographicXYTriangulatingSeries extends GeographicMapSeriesHost {
        ct() {
            return new GeographicXYTriangulatingSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.xd = a;
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.xd.cx();
                    break;
                case GeographicXYTriangulatingSeries.$$p[1]:
                    this.xd.cw();
                    break;
                case GeographicXYTriangulatingSeries.$$p[0]:
                    this.xd.cv();
                    break;
                case GeographicXYTriangulatingSeries.$$p[5]:
                    this.xd.cy();
                    break;
                case GeographicXYTriangulatingSeries.$$p[2]:
                    this.xd.cz();
                    break;
                case GeographicXYTriangulatingSeries.$$p[3]:
                    this.xd.c0();
                    break;
                case GeographicXYTriangulatingSeries.$$p[4]:
                    this.xd.c1();
                    break;
            }
        }
    }
    GeographicXYTriangulatingSeries.$t = /*@__PURE__*/ markType(GeographicXYTriangulatingSeries, 'GeographicXYTriangulatingSeries', GeographicMapSeriesHost.$);
    GeographicXYTriangulatingSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicXYTriangulatingSeries, 'raisePropertyChanged', ['LatitudeMemberPath:xf:xq', [2, "pointY"], 'LongitudeMemberPath:xh:xr', [2, "pointX"], 'TriangleVertexMemberPath1:xk:xt', [2, "v1"], 'TriangleVertexMemberPath2:xm:xu', [2, "v2"], 'TriangleVertexMemberPath3:xo:xv', [2, "v3"], 'TrianglesSource:xe:xs', [IEnumerable_$type, null]]);
    return GeographicXYTriangulatingSeries;
})();
/**
 * @hidden
 */
export let GeographicScatterAreaSeries = /*@__PURE__*/ (() => {
    class GeographicScatterAreaSeries extends GeographicXYTriangulatingSeries {
        bk() {
            return new GeographicScatterAreaSeries();
        }
        get_ew() {
            return true;
        }
        constructor() {
            super();
            this.xw = null;
            this.triangulationStatusChanged = null;
            this.ab = GeographicScatterAreaSeries.$;
        }
        get xy() {
            return this.xw;
        }
        set xy(a) {
            let b = this.xw != a;
            if (b) {
                let c = this.xw;
                if (this.xw != null) {
                    let d = this.xw;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.x6));
                }
                this.xw = a;
                if (this.xw != null) {
                    let e = this.xw;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.x6));
                }
                this.raisePropertyChanged("ColorScale", c, this.xw);
                if (this.xz != null) {
                    this.xz.y0 = a;
                }
            }
        }
        x6(a, b) {
            this.x1.c4();
            this.x8();
            this.ru(false);
        }
        x8() {
            if (this.xz != null) {
                this.xx = this.xz.yz;
            }
        }
        sl() {
            super.sl();
            this.x8();
        }
        w4() {
            this.xz = new ScatterAreaSeries();
            let a = this.xz;
            a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.x7));
            return this.xz;
        }
        x7(a, b) {
            if (this.triangulationStatusChanged != null) {
                this.triangulationStatusChanged(this, b);
            }
        }
        ct() {
            return new GeographicScatterAreaSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.x1 = a;
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case GeographicScatterAreaSeries.$$p[1]:
                    this.x1.c3();
                    break;
                case "ColorScale":
                    this.x1.c4();
                    this.x8();
                    break;
            }
        }
        get_g8() {
            return true;
        }
        set_g8(a) {
            super.set_g8(a);
        }
    }
    GeographicScatterAreaSeries.$t = /*@__PURE__*/ markType(GeographicScatterAreaSeries, 'GeographicScatterAreaSeries', GeographicXYTriangulatingSeries.$);
    GeographicScatterAreaSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:xx:x9', [ColorScale.$, null], 'ColorMemberPath:x3:ya', [2, "value"]]);
    return GeographicScatterAreaSeries;
})();
