/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GeographicXYTriangulatingSeriesView } from "./GeographicXYTriangulatingSeriesView";
import { Defaults } from "igniteui-react-charts";
import { ScatterContourSeries } from "igniteui-react-charts";
import { markType, runOn, delegateCombine, typeCast, markDep } from "igniteui-react-core";
import { GeographicXYTriangulatingSeries } from "./GeographicXYTriangulatingSeries";
import { DependencyProperty } from "igniteui-react-core";
import { ValueBrushScale } from "igniteui-react-charts";
import { ContourValueResolver } from "igniteui-react-charts";
import { PropertyMetadata } from "igniteui-react-core";
/**
 * @hidden
 */
var GeographicContourLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicContourLineSeriesView, _super);
    function GeographicContourLineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c2 = null;
        _this.c2 = a;
        return _this;
    }
    GeographicContourLineSeriesView.prototype.a4 = function () {
        _super.prototype.a4.call(this);
        if (!this.t) {
            this.c2.jq = Defaults.z;
        }
    };
    GeographicContourLineSeriesView.prototype.ci = function () {
        _super.prototype.ci.call(this);
        if (this.c2.w5 != null) {
            this.c2.xx.y0 = this.c2.x0;
            this.c2.xx.za = this.c2.x4;
        }
    };
    GeographicContourLineSeriesView.prototype.c3 = function () {
        if (this.c2.xx != null) {
            this.c2.xx.y0 = this.c2.x0;
        }
    };
    GeographicContourLineSeriesView.prototype.c4 = function () {
        if (this.c2.xx != null) {
            this.c2.xx.za = this.c2.x4;
        }
    };
    GeographicContourLineSeriesView.$t = markType(GeographicContourLineSeriesView, 'GeographicContourLineSeriesView', GeographicXYTriangulatingSeriesView.$);
    return GeographicContourLineSeriesView;
}(GeographicXYTriangulatingSeriesView));
export { GeographicContourLineSeriesView };
/**
 * @hidden
 */
var GeographicContourLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicContourLineSeries, _super);
    function GeographicContourLineSeries() {
        var _this = _super.call(this) || this;
        _this.triangulationStatusChanged = null;
        _this.ab = GeographicContourLineSeries.$;
        return _this;
    }
    GeographicContourLineSeries.prototype.bk = function () {
        return new GeographicContourLineSeries();
    };
    GeographicContourLineSeries.prototype.get_fk = function () {
        return true;
    };
    GeographicContourLineSeries.prototype.xa = function (a, b) {
        _super.prototype.xa.call(this, a, b);
    };
    GeographicContourLineSeries.prototype.w4 = function () {
        this.xx = new ScatterContourSeries();
        var a = this.xx;
        a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.x7));
        var b = this.xx;
        b.propertyUpdated = delegateCombine(b.propertyUpdated, runOn(this, this.x8));
        return this.xx;
    };
    GeographicContourLineSeries.prototype.x7 = function (a, b) {
        if (this.triangulationStatusChanged != null) {
            this.triangulationStatusChanged(this, b);
        }
    };
    GeographicContourLineSeries.prototype.x8 = function (a, b) {
        var c = typeCast(ScatterContourSeries.$, this.w5);
        if (c == null) {
            return;
        }
        if (b.propertyName == "ActualFillScale") {
            this.xz = c.yz;
        }
    };
    GeographicContourLineSeries.prototype.sl = function () {
        _super.prototype.sl.call(this);
    };
    GeographicContourLineSeries.prototype.ct = function () {
        return new GeographicContourLineSeriesView(this);
    };
    GeographicContourLineSeries.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.x1 = a;
    };
    GeographicContourLineSeries.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case GeographicContourLineSeries.$$p[1]:
                this.x1.c3();
                break;
            case GeographicContourLineSeries.$$p[2]:
                this.x1.c4();
                break;
            case GeographicContourLineSeries.$$p[3]:
                this.xx.yx = this.xw;
                break;
            case "DashArray":
                this.xx.v7 = this.v7;
                break;
            case "DashCap":
                this.xx.v8 = this.v8;
                break;
            case "MiterLimit":
                this.xx.ji = this.ji;
                break;
            case "LineJoin":
                this.xx.wa = this.wa;
                break;
        }
    };
    GeographicContourLineSeries.$t = markType(GeographicContourLineSeries, 'GeographicContourLineSeries', GeographicXYTriangulatingSeries.$);
    GeographicContourLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicContourLineSeries, 'raisePropertyChanged', ['ActualFillScale:xz:x9', [ValueBrushScale.$, null], 'FillScale:x0:ya', [ValueBrushScale.$, null], 'ValueMemberPath:x4:yb', [2, "value"], 'ValueResolver:xw:yc', [ContourValueResolver.$, null]]);
    return GeographicContourLineSeries;
}(GeographicXYTriangulatingSeries));
export { GeographicContourLineSeries };
