/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { HostSeriesView } from "./HostSeriesView";
import { HighDensityScatterSeries } from "igniteui-react-charts";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { Color } from "igniteui-react-core";
import { Defaults } from "igniteui-react-charts";
import { typeCast, markType, runOn, delegateCombine, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var GeographicHighDensityScatterSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicHighDensityScatterSeriesView, _super);
    function GeographicHighDensityScatterSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cu = null;
        _this.cu = a;
        return _this;
    }
    GeographicHighDensityScatterSeriesView.prototype.ci = function () {
        _super.prototype.ci.call(this);
        var a = typeCast(HighDensityScatterSeries.$, this.cu.w5);
        a.ze = this.cu.xu;
        a.zm = this.cu.xs;
        a.xr = this.cu.xh;
        a.xq = this.cu.xg;
        a.f9 = this.cu.xf;
        a.ym = this.cu.xj;
        a.yl = this.cu.xi;
        a.aak = this.cu.yd;
        a.aaj = this.cu.yc;
        a.yy = this.cu.xm;
    };
    GeographicHighDensityScatterSeriesView.prototype.c0 = function () {
        this.cu.w5.ze = this.cu.xu;
    };
    GeographicHighDensityScatterSeriesView.prototype.cz = function () {
        this.cu.w5.zm = this.cu.xs;
    };
    GeographicHighDensityScatterSeriesView.prototype.c5 = function () {
        this.cu.w5.xr = this.cu.xh;
    };
    GeographicHighDensityScatterSeriesView.prototype.c3 = function () {
        this.cu.w5.xq = this.cu.xg;
    };
    GeographicHighDensityScatterSeriesView.prototype.c1 = function () {
        this.cu.w5.f9 = this.cu.xf;
    };
    GeographicHighDensityScatterSeriesView.prototype.cy = function () {
        this.cu.w5.ym = this.cu.xj;
    };
    GeographicHighDensityScatterSeriesView.prototype.cw = function () {
        this.cu.w5.yl = this.cu.xi;
    };
    GeographicHighDensityScatterSeriesView.prototype.c4 = function () {
        var a = typeCast(HighDensityScatterSeries.$, this.cu.w5);
        if (this.cu.dc == null) {
            a.xa = null;
            a.xc = null;
            return;
        }
        a.xa = this.cu.dc.w7;
        a.xc = this.cu.dc.w9;
    };
    GeographicHighDensityScatterSeriesView.prototype.c6 = function () {
        this.cu.w5.xa = this.cu.dc.w7;
    };
    GeographicHighDensityScatterSeriesView.prototype.c7 = function () {
        this.cu.w5.xc = this.cu.dc.w9;
    };
    GeographicHighDensityScatterSeriesView.prototype.cx = function () {
        this.cu.w5.aak = this.cu.yd;
    };
    GeographicHighDensityScatterSeriesView.prototype.cv = function () {
        this.cu.w5.aaj = this.cu.yc;
    };
    GeographicHighDensityScatterSeriesView.prototype.c2 = function () {
        this.cu.w5.yy = this.cu.xm;
    };
    GeographicHighDensityScatterSeriesView.prototype.a4 = function () {
        _super.prototype.a4.call(this);
        if (!this.t) {
            this.cu.yd = Defaults.bf;
            this.cu.yc = Defaults.be;
            this.cu.vk = Defaults.ba;
            this.cu.v0 = Defaults.a9;
        }
    };
    GeographicHighDensityScatterSeriesView.$t = markType(GeographicHighDensityScatterSeriesView, 'GeographicHighDensityScatterSeriesView', HostSeriesView.$);
    return GeographicHighDensityScatterSeriesView;
}(HostSeriesView));
export { GeographicHighDensityScatterSeriesView };
/**
 * @hidden
 */
var GeographicHighDensityScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicHighDensityScatterSeries, _super);
    function GeographicHighDensityScatterSeries() {
        var _this = _super.call(this) || this;
        _this.xd = null;
        _this.progressiveLoadStatusChanged = null;
        _this.xl = 0;
        _this.ab = GeographicHighDensityScatterSeries.$;
        return _this;
    }
    GeographicHighDensityScatterSeries.prototype.bk = function () {
        return new GeographicHighDensityScatterSeries();
    };
    GeographicHighDensityScatterSeries.prototype.jl = function () {
        if (!isNaN_(this.jk)) {
            return _super.prototype.jl.call(this);
        }
        return Defaults.ad;
    };
    GeographicHighDensityScatterSeries.prototype.get_fp = function () {
        return true;
    };
    GeographicHighDensityScatterSeries.prototype.ct = function () {
        return new GeographicHighDensityScatterSeriesView(this);
    };
    GeographicHighDensityScatterSeries.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.xe = a;
    };
    GeographicHighDensityScatterSeries.prototype.w4 = function () {
        this.xd = new HighDensityScatterSeries();
        return this.xd;
    };
    Object.defineProperty(GeographicHighDensityScatterSeries.prototype, "xn", {
        get: function () {
            return this.xl;
        },
        set: function (a) {
            var b = this.xl;
            this.xl = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.xl);
        },
        enumerable: false,
        configurable: true
    });
    GeographicHighDensityScatterSeries.prototype.xa = function (a, b) {
        _super.prototype.xa.call(this, a, b);
        var c = this.w5;
        c.progressiveLoadStatusChanged = delegateCombine(c.progressiveLoadStatusChanged, runOn(this, this.x1));
        var d = this.w5;
        d.propertyUpdated = delegateCombine(d.propertyUpdated, runOn(this, this.x0));
    };
    GeographicHighDensityScatterSeries.prototype.x1 = function (a, b) {
        this.xn = b.currentStatus;
        if (this.progressiveLoadStatusChanged != null) {
            this.progressiveLoadStatusChanged(this, b);
        }
    };
    GeographicHighDensityScatterSeries.prototype.x0 = function (a, b) {
        if (this.xd == null) {
            return;
        }
    };
    GeographicHighDensityScatterSeries.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.xe.c4();
                break;
            case GeographicHighDensityScatterSeries.$$p[5]:
                this.xe.c0();
                break;
            case GeographicHighDensityScatterSeries.$$p[4]:
                this.xe.cz();
                break;
            case GeographicHighDensityScatterSeries.$$p[9]:
                this.xe.c5();
                break;
            case GeographicHighDensityScatterSeries.$$p[8]:
                this.xe.c3();
                break;
            case GeographicHighDensityScatterSeries.$$p[6]:
                this.xe.c1();
                break;
            case "XAxis":
                this.xe.c6();
                break;
            case "YAxis":
                this.xe.c7();
                break;
            case GeographicHighDensityScatterSeries.$$p[3]:
                this.xe.cy();
                break;
            case GeographicHighDensityScatterSeries.$$p[1]:
                this.xe.cw();
                break;
            case GeographicHighDensityScatterSeries.$$p[2]:
                this.xe.cx();
                break;
            case GeographicHighDensityScatterSeries.$$p[0]:
                this.xe.cv();
                break;
            case GeographicHighDensityScatterSeries.$$p[7]:
                this.xe.c2();
                break;
        }
    };
    GeographicHighDensityScatterSeries.prototype.get_g8 = function () {
        return true;
    };
    GeographicHighDensityScatterSeries.prototype.set_g8 = function (a) {
        _super.prototype.set_g8.call(this, a);
    };
    GeographicHighDensityScatterSeries.$t = markType(GeographicHighDensityScatterSeries, 'GeographicHighDensityScatterSeries', GeographicMapSeriesHost.$);
    GeographicHighDensityScatterSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicHighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:yc:x2', [Color.$, Defaults.be], 'HeatMaximum:xi:x3', [1, 50], 'HeatMinimumColor:yd:x4', [Color.$, Defaults.bf], 'HeatMinimum:xj:x5', [1, 0], 'LatitudeMemberPath:xs:x6', [2, null], 'LongitudeMemberPath:xu:x7', [2, null], 'MouseOverEnabled:xf:x8', [0, false], 'PointExtent:xm:x9', [1, 1], 'ProgressiveLoad:xg:ya', [0, true], 'UseBruteForce:xh:yb', [0, false]]);
    return GeographicHighDensityScatterSeries;
}(GeographicMapSeriesHost));
export { GeographicHighDensityScatterSeries };
