/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { DependencyProperty } from "igniteui-react-core";
import { ShapeItemSearchMode_$type } from "igniteui-react-charts";
import { BrushScale } from "igniteui-react-charts";
import { enumGetBox, runOn, delegateCombine, delegateRemove, markType, markDep } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { HostSeriesView } from "./HostSeriesView";
/**
 * @hidden
 */
var GeographicShapeSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeriesBase, _super);
    function GeographicShapeSeriesBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.xm = false;
        _this.xl = false;
        _this.assigningShapeStyle = null;
        _this.assigningShapeMarkerStyle = null;
        _this.xi = null;
        _this.xk = false;
        return _this;
    }
    GeographicShapeSeriesBase.prototype.ct = function () {
        return new GeographicShapeSeriesBaseView(this);
    };
    GeographicShapeSeriesBase.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.xh = a;
    };
    GeographicShapeSeriesBase.prototype.get_ff = function () {
        return true;
    };
    GeographicShapeSeriesBase.prototype.get_ef = function () {
        return true;
    };
    GeographicShapeSeriesBase.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.xh.cv();
                break;
            case "ShapeMemberPath":
                this.xh.cx();
                break;
            case GeographicShapeSeriesBase.$$p[8]:
                this.xh.cw();
                break;
            case GeographicShapeSeriesBase.$$p[4]:
                this.w5.yd = this.xp;
                this.xm = this.xp;
                if (this.xp) {
                    var e = this.w5;
                    e.assigningShapeStyle = delegateCombine(e.assigningShapeStyle, runOn(this, this.x7));
                }
                else {
                    var f = this.w5;
                    f.assigningShapeStyle = delegateRemove(f.assigningShapeStyle, runOn(this, this.x7));
                }
                break;
            case GeographicShapeSeriesBase.$$p[3]:
                this.w5.yc = this.xo;
                this.xl = this.xo;
                if (this.xp) {
                    var g = this.w5;
                    g.assigningShapeMarkerStyle = delegateCombine(g.assigningShapeMarkerStyle, runOn(this, this.x6));
                }
                else {
                    var h = this.w5;
                    h.assigningShapeMarkerStyle = delegateRemove(h.assigningShapeMarkerStyle, runOn(this, this.x6));
                }
                break;
            case GeographicShapeSeriesBase.$$p[5]:
                this.w5.xp = this.xg;
                break;
            case GeographicShapeSeriesBase.$$p[6]:
                this.w5.yu = this.xr;
                break;
            case GeographicShapeSeriesBase.$$p[7]:
                this.w5.yv = this.xs;
                break;
            case GeographicShapeSeriesBase.$$p[0]:
                this.w5.yz = this.xt;
                break;
            case GeographicShapeSeriesBase.$$p[1]:
                this.w5.xf = this.xf;
                break;
            case GeographicShapeSeriesBase.$$p[2]:
                this.w5.x8 = this.xn;
                break;
            case "ShapefileDataSource":
                if (c != null) {
                    var i = c;
                    if (this.xk) {
                        i.importCompleted = delegateRemove(i.importCompleted, runOn(this, this.x8));
                    }
                }
                if (d != null) {
                    var j = d;
                    if (j.count > 0) {
                        this.x9();
                        break;
                    }
                    this.xk = true;
                    j.importCompleted = delegateCombine(j.importCompleted, runOn(this, this.x8));
                }
                break;
        }
    };
    GeographicShapeSeriesBase.prototype.x7 = function (a, b) {
        if (this.assigningShapeStyle != null) {
            this.assigningShapeStyle(this, b);
        }
    };
    GeographicShapeSeriesBase.prototype.x6 = function (a, b) {
        if (this.assigningShapeMarkerStyle != null) {
            this.assigningShapeMarkerStyle(this, b);
        }
    };
    GeographicShapeSeriesBase.prototype.x8 = function (a, b) {
        this.x9();
    };
    GeographicShapeSeriesBase.prototype.x9 = function () {
        var sds_ = this.xj;
        var ext_ = sds_.externalObject;
        this.itemsSource = (ext_.getPointData());
    };
    Object.defineProperty(GeographicShapeSeriesBase.prototype, "xj", {
        get: function () {
            return this.xi;
        },
        set: function (a) {
            var b = this.xi;
            this.xi = a;
            if (b != this.xi) {
                this.raisePropertyChanged("ShapefileDataSource", b, this.xi);
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicShapeSeriesBase.prototype.get_g8 = function () {
        return true;
    };
    GeographicShapeSeriesBase.prototype.set_g8 = function (a) {
        _super.prototype.set_g8.call(this, a);
    };
    GeographicShapeSeriesBase.$t = markType(GeographicShapeSeriesBase, 'GeographicShapeSeriesBase', GeographicMapSeriesHost.$);
    GeographicShapeSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeriesBase, 'raisePropertyChanged', ['FillMemberPath:xt:ya', [2], 'FillScale:xf:yb', [BrushScale.$], 'FillScaleUseGlobalValues:xn:yc', [0, false], 'IsCustomShapeMarkerStyleAllowed:xo:yd', [0, false], 'IsCustomShapeStyleAllowed:xp:ye', [0, false], 'ItemSearchMode:xg:yf', [ShapeItemSearchMode_$type, enumGetBox(ShapeItemSearchMode_$type, 0)], 'ItemSearchPointsThreshold:xr:yg', [1, 10000], 'ItemSearchThreshold:xs:yh', [1, 10000], 'ShapeFilterResolution:xq:yi', [1, 2], 'ShapeMemberPath:x4:yj', [2, "points"]]);
    return GeographicShapeSeriesBase;
}(GeographicMapSeriesHost));
export { GeographicShapeSeriesBase };
/**
 * @hidden
 */
var GeographicShapeSeriesBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeriesBaseView, _super);
    function GeographicShapeSeriesBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cu = null;
        _this.cu = a;
        return _this;
    }
    GeographicShapeSeriesBaseView.prototype.ci = function () {
        _super.prototype.ci.call(this);
        this.cu.w5.zc = this.cu.x4;
    };
    GeographicShapeSeriesBaseView.prototype.cv = function () {
        var a = this.cu.w5;
        if (this.cu.dc == null) {
            a.xj = null;
            a.xl = null;
            return;
        }
        a.xj = this.cu.dc.w7;
        a.xl = this.cu.dc.w9;
    };
    GeographicShapeSeriesBaseView.prototype.cx = function () {
        this.cu.w5.zc = this.cu.x4;
    };
    GeographicShapeSeriesBaseView.prototype.cw = function () {
        this.cu.w5.yr = this.cu.xq;
    };
    GeographicShapeSeriesBaseView.$t = markType(GeographicShapeSeriesBaseView, 'GeographicShapeSeriesBaseView', HostSeriesView.$);
    return GeographicShapeSeriesBaseView;
}(HostSeriesView));
export { GeographicShapeSeriesBaseView };
