/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GeographicShapeSeriesBaseView } from "./GeographicShapeSeriesBaseView";
import { GeographicShapeSeriesBase } from "./GeographicShapeSeriesBase";
import { Brush } from "igniteui-react-core";
import { Defaults } from "igniteui-react-charts";
import { MarkerType_$type } from "igniteui-react-charts";
import { MarkerFillMode_$type } from "igniteui-react-charts";
import { ScatterPolygonSeries } from "igniteui-react-charts";
import { markType, runOn, delegateCombine, typeCast, enumGetBox, markDep } from "igniteui-react-core";
import { StyleSelector } from "igniteui-react-charts";
import { DependencyProperty } from "igniteui-react-core";
import { Style } from "igniteui-react-core";
import { MarkerOutlineMode_$type } from "igniteui-react-charts";
import { DataTemplate } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "igniteui-react-charts";
import { PropertyMetadata } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
var GeographicShapeSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeriesView, _super);
    function GeographicShapeSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cy = null;
        _this.cy = a;
        if (!_this.t) {
            _this.cy.x4 = "points";
        }
        return _this;
    }
    GeographicShapeSeriesView.prototype.a4 = function () {
        _super.prototype.a4.call(this);
        if (!this.t) {
            this.cy.zr = Defaults.a8;
            this.cy.jq = Defaults.ac;
            this.cy.yq = Defaults.ab;
            this.cy.yn = Defaults.d;
            this.cy.yl = Defaults.a;
        }
    };
    GeographicShapeSeriesView.prototype.ci = function () {
        _super.prototype.ci.call(this);
        this.cy.w5.aby = this.cy.zt;
        this.cy.w5.aar = this.cy.yo;
        this.cy.w5.abd = this.cy.y9;
        this.cy.w5.aau = this.cy.yq;
        this.cy.w5.aad = this.cy.yk;
    };
    GeographicShapeSeriesView.prototype.c3 = function () {
        this.cy.w5.abd = this.cy.y9;
    };
    GeographicShapeSeriesView.prototype.c5 = function () {
        this.cy.w5.aau = this.cy.yq;
    };
    GeographicShapeSeriesView.prototype.c0 = function () {
        this.cy.w5.aad = this.cy.yk;
    };
    GeographicShapeSeriesView.prototype.c4 = function () {
        this.cy.w5.aam = this.cy.yn;
    };
    GeographicShapeSeriesView.prototype.cz = function () {
        this.cy.w5.abu = this.cy.zq;
    };
    GeographicShapeSeriesView.prototype.c1 = function () {
        this.cy.w5.abv = this.cy.zr;
    };
    GeographicShapeSeriesView.prototype.c2 = function () {
        this.cy.w5.abx = this.cy.zs;
    };
    GeographicShapeSeriesView.prototype.c6 = function () {
        this.cy.w5.aar = this.cy.yo;
    };
    GeographicShapeSeriesView.prototype.c7 = function () {
        this.cy.w5.aby = this.cy.zt;
    };
    GeographicShapeSeriesView.$t = markType(GeographicShapeSeriesView, 'GeographicShapeSeriesView', GeographicShapeSeriesBaseView.$);
    return GeographicShapeSeriesView;
}(GeographicShapeSeriesBaseView));
export { GeographicShapeSeriesView };
/**
 * @hidden
 */
var GeographicShapeSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeries, _super);
    function GeographicShapeSeries() {
        var _this = _super.call(this) || this;
        _this.styleShape = null;
        _this.ab = GeographicShapeSeries.$;
        return _this;
    }
    GeographicShapeSeries.prototype.bk = function () {
        return new GeographicShapeSeries();
    };
    GeographicShapeSeries.prototype.get_fr = function () {
        return true;
    };
    GeographicShapeSeries.prototype.ct = function () {
        return new GeographicShapeSeriesView(this);
    };
    GeographicShapeSeries.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.yp = a;
    };
    GeographicShapeSeries.prototype.w4 = function () {
        var a = new ScatterPolygonSeries();
        a.styleShape = delegateCombine(a.styleShape, runOn(this, this.y6));
        a.propertyUpdated = delegateCombine(a.propertyUpdated, runOn(this, this.y7));
        return a;
    };
    GeographicShapeSeries.prototype.y6 = function (a, b) {
        if (this.styleShape != null) {
            this.styleShape(this, b);
        }
    };
    GeographicShapeSeries.prototype.y7 = function (a, b) {
        var c = typeCast(ScatterPolygonSeries.$, this.w5);
        if (c == null) {
            return;
        }
    };
    GeographicShapeSeries.prototype.ip = function () {
        return this.yq;
    };
    GeographicShapeSeries.prototype.vq = function () {
        return this.zo;
    };
    GeographicShapeSeries.prototype.vr = function () {
        return this.zp;
    };
    GeographicShapeSeries.prototype.s3 = function () {
        return this.y8;
    };
    GeographicShapeSeries.prototype.mc = function () {
        var a = typeCast(ScatterPolygonSeries.$, this.w5);
        if (a == null) {
            return "Unknown";
        }
        return a.mc();
    };
    GeographicShapeSeries.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case GeographicShapeSeries.$$p[6]:
                this.w5.aak = this.ym;
                break;
            case GeographicShapeSeries.$$p[5]:
                this.w5.aag = this.yl;
                break;
            case GeographicShapeSeries.$$p[9]:
                this.yp.c3();
                break;
            case GeographicShapeSeries.$$p[10]:
                this.yp.c5();
                break;
            case GeographicShapeSeries.$$p[4]:
                this.yp.c0();
                break;
            case GeographicShapeSeries.$$p[11]:
                this.yp.c4();
                break;
            case GeographicShapeSeries.$$p[3]:
                this.yp.cz();
                break;
            case GeographicShapeSeries.$$p[7]:
                this.yp.c1();
                break;
            case GeographicShapeSeries.$$p[8]:
                this.yp.c2();
                break;
            case GeographicShapeSeries.$$p[13]:
                this.yp.c6();
                break;
            case GeographicShapeSeries.$$p[12]:
                this.yp.c7();
                break;
        }
    };
    GeographicShapeSeries.prototype.jm = function () {
        return 0.7;
    };
    GeographicShapeSeries.$t = markType(GeographicShapeSeries, 'GeographicShapeSeries', GeographicShapeSeriesBase.$);
    GeographicShapeSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeries, 'raisePropertyChanged', ['ActualMarkerBrush:zo:za', [Brush.$], 'ActualMarkerOutline:zp:zb', [Brush.$], 'ActualMarkerTemplate:y8:zc', [DataTemplate.$, null], 'MarkerBrush:zq:zd', [Brush.$], 'MarkerCollisionAvoidance:yk:ze', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:yl:zf', [MarkerFillMode_$type, enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:ym:zg', [MarkerOutlineMode_$type, enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:zr:zh', [Brush.$], 'MarkerStyle:zs:zi', [Style.$], 'MarkerTemplate:y9:zj', [DataTemplate.$, null], 'MarkerThickness:yq:zk', [1, DeviceUtils.g(2)], 'MarkerType:yn:zl', [MarkerType_$type, enumGetBox(MarkerType_$type, 2)], 'ShapeStyle:zt:zm', [Style.$, null], 'ShapeStyleSelector:yo:zn', [StyleSelector.$, null]]);
    return GeographicShapeSeries;
}(GeographicShapeSeriesBase));
export { GeographicShapeSeries };
