/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { TileSeries } from "./TileSeries";
import { GeographicShapeSeriesBase } from "./GeographicShapeSeriesBase";
import { runOn, delegateRemove, delegateCombine, markType } from "igniteui-react-core";
import { ImageTilesReadyEventArgs } from "./ImageTilesReadyEventArgs";
/**
 * @hidden
 */
var GeographicTileSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicTileSeries, _super);
    function GeographicTileSeries() {
        var _this = _super.call(this) || this;
        _this.yl = null;
        _this.yk = null;
        _this.imageTilesReady = null;
        _this.ab = GeographicTileSeries.$;
        return _this;
    }
    GeographicTileSeries.prototype.bk = function () {
        return new GeographicTileSeries();
    };
    GeographicTileSeries.prototype.get_f4 = function () {
        return true;
    };
    Object.defineProperty(GeographicTileSeries.prototype, "ym", {
        get: function () {
            return this.yl;
        },
        set: function (a) {
            var b = a != this.ym;
            if (b) {
                var c = this.ym;
                this.yl = a;
                this.raisePropertyChanged("TileImagery", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicTileSeries.prototype.yq = function () {
        if (this.ym != null) {
            this.ym.clearTileCache();
        }
    };
    GeographicTileSeries.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case "TileImagery":
                if (this.w5 != null) {
                    this.w5.aag = this.ym;
                }
                break;
        }
    };
    GeographicTileSeries.prototype.xa = function (a, b) {
        _super.prototype.xa.call(this, a, b);
        this.w5.aag = this.ym;
        if (this.yk != null) {
            var c = this.yk;
            c.imageTilesReady = delegateRemove(c.imageTilesReady, runOn(this, this.yp));
        }
        this.yk = this.w5;
        if (this.yk != null) {
            var d = this.yk;
            d.imageTilesReady = delegateCombine(d.imageTilesReady, runOn(this, this.yp));
        }
    };
    GeographicTileSeries.prototype.w4 = function () {
        return new TileSeries();
    };
    GeographicTileSeries.prototype.yp = function (a, b) {
        if (this.imageTilesReady != null) {
            this.imageTilesReady(this, new ImageTilesReadyEventArgs());
        }
    };
    GeographicTileSeries.$t = markType(GeographicTileSeries, 'GeographicTileSeries', GeographicShapeSeriesBase.$);
    return GeographicTileSeries;
}(GeographicShapeSeriesBase));
export { GeographicTileSeries };
