/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { ShapeSeriesBase } from "igniteui-react-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-react-core";
import { EventArgs, runOn, delegateRemove, delegateCombine, typeCast, markType } from "igniteui-react-core";
import { XamGeographicMap } from "./XamGeographicMap";
import { ShapeSeriesViewBase } from "igniteui-react-charts";
import { RenderingContext } from "igniteui-react-core";
import { GeometryGroup } from "igniteui-react-core";
import { Defaults } from "igniteui-react-charts";
import { CanvasViewRenderer } from "igniteui-react-core";
import { truncate } from "igniteui-react-core";
/**
 * @hidden
 */
var TileSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TileSeries, _super);
    function TileSeries() {
        var _this = _super.call(this) || this;
        _this.aae = null;
        _this.aad = null;
        _this.imageTilesReady = null;
        _this.aah = null;
        _this.aai = false;
        _this.ab = TileSeries.$;
        return _this;
    }
    TileSeries.prototype.bk = function () {
        return new TileSeries();
    };
    TileSeries.prototype.get_f4 = function () {
        return true;
    };
    TileSeries.prototype.ct = function () {
        return new TileSeriesView(this);
    };
    TileSeries.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.aac = a;
    };
    TileSeries.prototype.get_yf = function () {
        return false;
    };
    Object.defineProperty(TileSeries.prototype, "aag", {
        get: function () {
            return this.aae;
        },
        set: function (a) {
            var b = a != this.aag;
            if (b) {
                var c = this.aag;
                this.aae = a;
                this.raisePropertyChanged("TileImagery", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TileSeries.prototype, "aaf", {
        get: function () {
            return this.aad;
        },
        set: function (a) {
            var b = this.aad;
            this.aad = a;
            this.raisePropertyChanged("ActualTileImagery", b, this.aad);
        },
        enumerable: false,
        configurable: true
    });
    TileSeries.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        var e;
        var f;
        switch (b) {
            case "TileImagery":
                e = c;
                f = d;
                if (e != null) {
                    e.propertyChanged = delegateRemove(e.propertyChanged, runOn(this, this.aal));
                }
                if (f != null) {
                    f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.aal));
                }
                this.aac.dv(e, f);
                this.ru(false);
                this.qn();
                break;
            case "ActualTileImagery":
                e = c;
                f = d;
                if (e != null) {
                    e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.aam));
                    e.deferralHandler = null;
                }
                if (f != null) {
                    f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.aam));
                    f.deferralHandler = this;
                }
                this.aac.du(e, f);
                if (f != null && typeCast(XamGeographicMap.$, this.dc) !== null) {
                    f.geographicMap = this.dc;
                    this.aao(this.cw);
                    this.aac.dr(this.dc.wh);
                }
                this.qn();
                break;
            case "ActualWindowRect":
                this.aac.dr(d);
                break;
            case "WorldRect":
                this.aac.dy(d);
                break;
            case "SeriesViewer":
                var g = c;
                var h = d;
                if (g != null && this.aaf != null) {
                    this.aaf.be(null);
                }
                if (h != null && this.aaf != null) {
                    this.aaf.be(this.cw.ae);
                }
                break;
            case "ActualBrush":
            case "ActualOutline":
            case "ActualThickness":
                this.qp();
                break;
        }
    };
    TileSeries.prototype.aal = function (a, b) {
        if (b.propertyName == "MultiScaleImage") {
            this.aao(this.cw);
        }
    };
    TileSeries.prototype.aam = function (a, b) {
        if (this.imageTilesReady != null) {
            this.imageTilesReady(this, new EventArgs());
        }
        if (!this.aai) {
            this.aac.dw();
        }
    };
    TileSeries.prototype.register = function (a, b) {
        this.aah = b;
    };
    TileSeries.prototype.unRegister = function (a) {
        this.aah = null;
    };
    TileSeries.prototype.deferredRefresh = function () {
        this.ru(false);
    };
    TileSeries.prototype.deferAction = function (a) {
        if (this.j0 != null) {
            this.j0.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    };
    TileSeries.prototype.su = function (a, b) {
        this.aac.dx();
        _super.prototype.su.call(this, a, b);
    };
    TileSeries.prototype.rv = function (a) {
        _super.prototype.rv.call(this, a);
        this.aan(a, this.cw);
    };
    TileSeries.prototype.aan = function (a, b) {
        var c;
        var d;
        var e = b;
        var f = b.getViewInfo(c, d);
        c = f.p0;
        d = f.p1;
        this.aao(b);
        if (this.aah != null) {
            this.aai = true;
            this.aah(a);
            this.aai = false;
        }
        e.dw();
    };
    TileSeries.prototype.rt = function (a, b, c, d, e) {
        _super.prototype.rt.call(this, a, b, c, d, e);
        var f = this.ho.item(d);
        f.bd(c);
        if (this.d7(f)) {
            return;
        }
        this.zs(f);
    };
    TileSeries.prototype.aao = function (a) {
        var b;
        var c;
        var d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        if (this.aag != null && this.aag.ao != null) {
            if (this.aag != this.aaf) {
                this.aaf = this.aag;
            }
            if (this.aaf != null && !b.isEmpty) {
                if (this.aaf.width != b.width) {
                    this.aaf.width = b.width;
                }
                if (this.aaf.height != b.height) {
                    this.aaf.height = b.height;
                }
            }
        }
    };
    TileSeries.prototype.o7 = function (a, b) {
        _super.prototype.o7.call(this, a, b);
        b.ds();
    };
    TileSeries.$t = markType(TileSeries, 'TileSeries', ShapeSeriesBase.$, [IMapRenderDeferralHandler_$type]);
    return TileSeries;
}(ShapeSeriesBase));
export { TileSeries };
/**
 * @hidden
 */
var TileSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TileSeriesView, _super);
    function TileSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.dn = null;
        _this.dz = new GeometryGroup();
        _this.dq = null;
        _this.dp = null;
        _this.dn = a;
        return _this;
    }
    TileSeriesView.prototype.a4 = function () {
        _super.prototype.a4.call(this);
        if (!this.t) {
            this.dn.v0 = Defaults.tileSeries_Outline;
            this.dn.vk = Defaults.tileSeries_Brush;
        }
    };
    TileSeriesView.prototype.cx = function (a, b) {
        if (b.c.count > 0) {
            this.dz.d.add(b);
        }
    };
    TileSeriesView.prototype.di = function (a, b) {
        return this.dj(a, b, true);
    };
    TileSeriesView.prototype.dh = function (a, b) {
        return null;
    };
    TileSeriesView.prototype.c1 = function (a, b) {
    };
    TileSeriesView.prototype.cz = function (a, b, c) {
    };
    TileSeriesView.prototype.c7 = function () {
        _super.prototype.c7.call(this);
        this.dz.d.clear();
    };
    TileSeriesView.prototype.c6 = function () {
        _super.prototype.c6.call(this);
        this.a2();
    };
    TileSeriesView.prototype.dr = function (a) {
        if (this.dn.aag != null) {
            this.dn.aag.windowRect = a;
        }
    };
    TileSeriesView.prototype.du = function (a, b) {
        if (this.dq == null) {
            this.dq = this.f.j0.createElement("canvas");
            var c = this.f.j0.get2DCanvasContext(this.dq);
            this.dp = new RenderingContext(new CanvasViewRenderer(), c);
            this.dq.setAttribute("width", this.b9.width.toString());
            this.dq.setAttribute("height", this.b9.height.toString());
        }
        if (a != null) {
            a.bd(null);
            a.be(null);
            a.imagesChanged = delegateRemove(a.imagesChanged, runOn(this, this.dt));
        }
        if (b != null) {
            if (this.ae != null) {
                b.be(this.ae);
            }
            b.bd(this.dp);
            b.bf(this.b9);
            b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.dt));
        }
    };
    TileSeriesView.prototype.dt = function (a, b) {
        this.a2();
    };
    TileSeriesView.prototype.dv = function (a, b) {
    };
    TileSeriesView.prototype.dx = function () {
        if (this.dq != null) {
            this.dq.setAttribute("width", this.b9.width.toString());
            this.dq.setAttribute("height", this.b9.height.toString());
        }
        if (this.dn.aag != null) {
            this.dn.aag.bf(this.b9);
        }
    };
    TileSeriesView.prototype.bj = function (a, b) {
        _super.prototype.bj.call(this, a, b);
        if (b) {
            return;
        }
        if (this.dq == null) {
            return;
        }
        var c = false;
        if (this.dz.d.count > 0) {
            c = true;
            this.m.aa();
            this.m.r(this.dz);
            var d = this.m.h();
            d.clip();
        }
        var e = truncate(Math.round(this.b9.left));
        var f = truncate(Math.round(this.b9.top));
        var g = truncate(Math.round(this.b9.width));
        var h = truncate(Math.round(this.b9.height));
        this.m.o(this.dq.getNativeElement(), 1, e, f, g, h, e, f, g, h);
        if (c) {
            this.m.z();
        }
    };
    TileSeriesView.prototype.dw = function () {
        this.a2();
    };
    TileSeriesView.prototype.ds = function () {
    };
    TileSeriesView.prototype.dy = function (a) {
        if (this.dn.aag != null) {
            this.dn.aag.a6();
        }
    };
    TileSeriesView.$t = markType(TileSeriesView, 'TileSeriesView', ShapeSeriesViewBase.$);
    return TileSeriesView;
}(ShapeSeriesViewBase));
export { TileSeriesView };
