/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { SeriesViewer } from "igniteui-react-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { MapResizeBehavior_$type } from "./MapResizeBehavior";
import { MapBackgroundTilingMode_$type } from "./MapBackgroundTilingMode";
import { Rect } from "igniteui-react-core";
import { Base, Boolean_$type, typeCast, enumGetBox, Point_$type, fromEnum, Number_$type, runOn, delegateRemove, delegateCombine, markType, markDep, INotifyPropertyChanged_$type, PropertyChangedEventArgs, String_$type, IEnumerable_$type } from "igniteui-react-core";
import { NumericXAxis } from "igniteui-react-charts";
import { NumericYAxis } from "igniteui-react-charts";
import { SphericalMercatorVerticalScaler } from "./SphericalMercatorVerticalScaler";
import { Control } from "igniteui-react-core";
import { SphericalMercatorHorizontalScaler } from "./SphericalMercatorHorizontalScaler";
import { ScalerParams } from "igniteui-react-charts";
import { SeriesViewerView } from "igniteui-react-charts";
import { Tuple$2 } from "igniteui-react-core";
import { MathUtil } from "igniteui-react-core";
import { ImageTilesReadyEventArgs } from "./ImageTilesReadyEventArgs";
import { ItfConverter } from "igniteui-react-core";
import { ChartVisualData } from "igniteui-react-charts";
import { RectData } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-react-core";
import { XamMultiScaleImage } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { ImagesChangedEventArgs } from "./ImagesChangedEventArgs";
import { HostSeriesView } from "./HostSeriesView";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { ScatterAreaSeries } from "igniteui-react-charts";
import { BrushCollection } from "igniteui-react-core";
import { Defaults } from "igniteui-react-charts";
import { OpenStreetMapTileSource } from "igniteui-react-core";
import { ColorScale } from "igniteui-react-charts";
/**
 * @hidden
 */
var XamGeographicMap = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamGeographicMap, _super);
    function XamGeographicMap() {
        var _this = _super.call(this) || this;
        _this.xw = null;
        _this.xl = false;
        _this.xd = 1;
        _this.xs = 0;
        _this.y3 = null;
        _this.xa = null;
        _this.w6 = null;
        _this.w8 = null;
        _this.xc = null;
        _this.yz = { $type: Point_$type, x: NaN, y: NaN };
        _this.y6 = null;
        _this.xr = 1;
        _this.imageTilesReady = null;
        _this.xk = null;
        _this.y5 = Rect.empty;
        _this.xs = SphericalMercatorVerticalScaler.am(XamGeographicMap.y4.bottom) - SphericalMercatorVerticalScaler.am(XamGeographicMap.y4.top);
        _this.ab = XamGeographicMap.$;
        _this.backgroundContent = new OpenStreetMapImagery();
        var a = ((function () {
            var $ret = new NumericXAxis();
            $ret.bi = _this;
            return $ret;
        })());
        a.cf = true;
        _this.w7 = a;
        _this.w7.n4 = new SphericalMercatorHorizontalScaler();
        var b = ((function () {
            var $ret = new NumericYAxis();
            $ret.bi = _this;
            return $ret;
        })());
        b.cf = true;
        _this.w9 = b;
        _this.w9.n4 = new SphericalMercatorVerticalScaler();
        _this.ye();
        _this.yl();
        _this.n9();
        return _this;
    }
    XamGeographicMap.prototype.provideContainer = function (a) {
        _super.prototype.provideContainer.call(this, a);
        this.w7.provideRenderer(a);
        this.w9.provideRenderer(a);
    };
    XamGeographicMap.prototype.n9 = function () {
        _super.prototype.n9.call(this);
        this.xj.fv(this.hk);
    };
    XamGeographicMap.prototype.fl = function () {
        return this.xp;
    };
    XamGeographicMap.prototype.fm = function () {
        return this.xp;
    };
    XamGeographicMap.prototype.xg = function () {
        if (this.xe == 0) {
            if (this.xl) {
                return 2;
            }
        }
        return 1;
    };
    Object.defineProperty(XamGeographicMap.prototype, "xf", {
        get: function () {
            return this.xd;
        },
        set: function (a) {
            this.xd = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XamGeographicMap.prototype, "y8", {
        get: function () {
            return this.y3;
        },
        set: function (a) {
            var b = Rect.l_op_Inequality(this.y3, a);
            if (b) {
                var c = this.y3;
                this.y3 = a;
                this.qv("ActualWorldRect", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.zc = function () {
        return this.y8;
    };
    XamGeographicMap.prototype.ye = function () {
        if (this.zk.isEmpty) {
            return;
        }
        this.y8 = this.zi(this.zk, this.cr == 1);
    };
    XamGeographicMap.prototype.zi = function (a, b) {
        var c = a.top;
        var d = a.left;
        var e = a.width;
        var f = a.height;
        var g = SphericalMercatorVerticalScaler.am(a.bottom);
        var h = SphericalMercatorVerticalScaler.am(a.top);
        var i = g - h;
        var j = a.width / XamGeographicMap.y4.width;
        var k = SphericalMercatorVerticalScaler.am(XamGeographicMap.y4.top);
        var l = i / j;
        if (i / j > this.xs) {
            var m = i / this.xs;
            var n = m - j;
            d = d - (n / 2) * XamGeographicMap.y4.width;
            e = m * XamGeographicMap.y4.width;
            if (b) {
                if (d < XamGeographicMap.y4.left) {
                    d += (XamGeographicMap.y4.left - d);
                }
                else if ((d + e) > XamGeographicMap.y4.right) {
                    d -= ((d + e) - XamGeographicMap.y4.right);
                }
            }
        }
        else if (i / j < this.xs) {
            var o = this.xs * j;
            var p = o - i;
            var q = h - (p / 2);
            var r = g + (p / 2);
            if (b) {
                if (q < k) {
                    q += (k - q);
                    r += (k - q);
                }
                else if (r > (k + this.xs)) {
                    q -= ((r) - (k + this.xs));
                    r -= ((r) - (k + this.xs));
                }
            }
            c = SphericalMercatorVerticalScaler.aq(q);
            f = SphericalMercatorVerticalScaler.aq(r) - c;
        }
        var s = new Rect(0, d, c, e, f);
        return s;
    };
    Object.defineProperty(XamGeographicMap.prototype, "backgroundContent", {
        get: function () {
            return this.xa;
        },
        set: function (a) {
            var b = a != this.backgroundContent;
            if (b) {
                var c = this.backgroundContent;
                this.xa = a;
                this.qv("BackgroundContent", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XamGeographicMap.prototype, "w7", {
        get: function () {
            return this.w6;
        },
        set: function (a) {
            var b = a != this.w7;
            if (b) {
                var c = this.w7;
                this.w6 = a;
                this.qv("XAxis", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XamGeographicMap.prototype, "w9", {
        get: function () {
            return this.w8;
        },
        set: function (a) {
            var b = a != this.w9;
            if (b) {
                var c = this.w9;
                this.w8 = a;
                this.qv("YAxis", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.getZoomRectFromGeoRect = function (a) {
        return this.getZoomFromGeographicRect(a);
    };
    XamGeographicMap.prototype.yo = function (a) {
        this.w0 = a;
    };
    XamGeographicMap.prototype.yn = function (a) {
        this.zk = a;
    };
    XamGeographicMap.prototype.getZoomFromGeographicRect = function (a) {
        return this.za(a, true, 0);
    };
    XamGeographicMap.prototype.y9 = function (a, b) {
        return this.za(a, false, b);
    };
    XamGeographicMap.prototype.za = function (a, b, c) {
        var d = a;
        if (b) {
            d = this.zi(a, false);
        }
        var e = this.w7;
        var f = this.w9;
        var g = new ScalerParams(1, XamGeographicMap.y7, this.wz, e.ch);
        g.c = this.wl;
        var h = new ScalerParams(1, XamGeographicMap.y7, this.wz, f.ch);
        h.c = this.wl;
        var i = this.w7.el(d.left, g);
        var j = this.w7.el(d.right, g);
        var k = this.w9.el(d.top, h);
        var l = this.w9.el(d.bottom, h);
        var m = (i - c) / this.wz.width;
        var n = (l - c) / this.wz.height;
        var o = (j - i + (c * 2)) / this.wz.width;
        var p = (k - l + (c * 2)) / this.wz.height;
        var q = new Rect(0, m, n, o, p);
        q.intersect(XamGeographicMap.y7);
        if (q.isEmpty) {
            q = XamGeographicMap.y7;
        }
        return q;
    };
    XamGeographicMap.prototype.getZoomFromGeographicPoints = function (a, b) {
        var c = a.x;
        var d = b.y;
        var e = b.x - a.x;
        var f = a.y - b.y;
        if (e < 0 || f < 0) {
            return XamGeographicMap.y7;
        }
        else {
            var g = new Rect(0, c, d, e, f);
            return this.getZoomFromGeographicRect(g);
        }
    };
    XamGeographicMap.prototype.ze = function (a) {
        var b = this.w7;
        var c = this.w9;
        var d = new ScalerParams(1, a, this.wz, b.ch);
        d.c = this.wl;
        var e = new ScalerParams(1, a, this.wz, c.ch);
        e.c = this.wl;
        var f = this.wk;
        var g = b.eo(f.left, d);
        var h = c.eo(f.top, e);
        var i = b.eo(f.right, d);
        var j = c.eo(f.bottom, e);
        var k = i - g;
        var l = h - j;
        var m = new Rect(0, g, j, k, l);
        if (this.cr == 1) {
            m.intersect(XamGeographicMap.y4);
            if (m.isEmpty) {
                m = XamGeographicMap.y4;
            }
        }
        return m;
    };
    XamGeographicMap.prototype.y0 = function (a) {
        var b = this.w7.mf(a.x);
        var c = this.w9.mf(a.y);
        return { $type: Point_$type, x: b, y: c };
    };
    XamGeographicMap.prototype.y1 = function (a) {
        var b = this.w7.e6(a.x);
        var c = this.w9.e6(a.y);
        return { $type: Point_$type, x: b, y: c };
    };
    XamGeographicMap.prototype.y2 = function (a) {
        return this.y1(a);
    };
    XamGeographicMap.prototype.yb = function () {
        var a = typeCast(GeographicMapImagery.$, this.backgroundContent);
        if (a != null) {
            a.clearTileCache();
        }
    };
    XamGeographicMap.prototype.yh = function (a) {
    };
    XamGeographicMap.prototype.gg = function () {
        return true;
    };
    XamGeographicMap.prototype.yj = function () {
        var e_1, _a;
        this.xj.ee();
        try {
            for (var _b = __values(fromEnum(this.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.sg();
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    XamGeographicMap.prototype.ym = function () {
        if (this.xi == 2) {
            if (!this.wz.isEmpty && this.wz.width > 0 && this.wz.height > 0) {
                var a = this.w7.mf(this.wz.left + (this.wz.width / 2));
                var b = this.w9.mf(this.wz.top + (this.wz.height / 2));
                this.yz = { $type: Point_$type, x: a, y: b };
            }
        }
        else {
            if (!this.wz.isEmpty && this.wz.width > 0 && this.wz.height > 0) {
                var c = this.w7.mf(this.wz.left);
                var d = this.w9.mf(this.wz.top);
                this.yz = { $type: Point_$type, x: c, y: d };
            }
        }
    };
    XamGeographicMap.prototype.yi = function () {
        if (isNaN_(this.yz.x) || isNaN_(this.yz.y)) {
            this.ym();
        }
        var a = this.yz.x;
        var b = this.yz.y;
        if (!isNaN_(a) && !isNaN_(b)) {
            var c = this.wh.left;
            var d = this.wh.top;
            var e = this.wh.width;
            var f = this.wh.height;
            if (e > this.y6.width) {
            }
            else {
                var g = new ScalerParams(1, XamGeographicMap.y7, this.wz, this.w7.ch);
                g.c = this.wl;
                var h = this.w7.el(a, g);
                if (this.xi == 2) {
                    var i = h / this.wz.width;
                    c = i - (e / 2);
                }
                else {
                    c = h / this.wz.width;
                }
                if (c + e > this.y6.right) {
                    c = this.y6.right - e;
                }
                else if (c < this.y6.left) {
                    c = this.y6.left;
                }
            }
            if (f > this.y6.height) {
            }
            else {
                var j = new ScalerParams(1, XamGeographicMap.y7, this.wz, this.w9.ch);
                j.c = this.wl;
                var k = this.w9.el(b, j);
                if (this.xi == 2) {
                    var l = k / this.wz.height;
                    d = l - (f / 2);
                }
                else {
                    d = k / this.wz.height;
                }
                if (d + f > this.y6.bottom) {
                    d = this.y6.bottom - f;
                }
                else if (d < this.y6.top) {
                    d = this.y6.top;
                }
            }
            this.r6(new Rect(0, c, d, e, f), false);
        }
    };
    XamGeographicMap.prototype.get_fd = function () {
        return true;
    };
    XamGeographicMap.prototype.wi = function () {
        var a = _super.prototype.wi.call(this);
        if (this.w7 == null || this.w9 == null) {
            return a;
        }
        this.wt();
        var b = a.left;
        var c = a.top;
        if (this.cr == 1) {
            if (this.w0.width > this.y6.width) {
                b = 0.5 - (this.w0.width / 2);
            }
            else if (b + a.width > this.y6.right) {
                b = this.y6.right - this.w0.width;
            }
            else if (b < this.y6.left) {
                b = this.y6.left;
            }
            if (this.w0.height > this.y6.height) {
                c = 0.5 - (this.w0.height / 2);
            }
            else if (c + this.w0.height > this.y6.bottom) {
                c = this.y6.bottom - this.w0.height;
            }
            else if (c < this.y6.top) {
                c = this.y6.top;
            }
        }
        var d = false;
        if (!this.xo && this.cr == 2 && this.xl) {
            if (b > 1) {
                b = (b - Math.floor(b)) + 1;
            }
            if (b < 0) {
                b = 0 - (Math.ceil(b) - b);
            }
            if ((a.right - this.y6.right) > 0 && ((a.right - this.y6.right) / a.width) > 0.8) {
                b = this.y6.left - (a.width - (a.right - this.y6.right));
                d = true;
            }
            else if (a.left < this.y6.left && (Math.abs(a.left - this.y6.left) / a.width) > 0.8) {
                b = this.y6.right - (Math.abs(a.left - this.y6.left));
                d = true;
            }
        }
        var e = new Rect(0, b, c, a.width, a.height);
        if (this.xo) {
            var f = this.y9(this.zk, 1);
            f = this.zb(f);
            var g = e.left + e.width / 2;
            var h = e.top + e.height / 2;
            if (e.width > f.width) {
                var i = e.height / e.width;
                var j = f.width;
                var k = i * j;
                e = new Rect(0, g - j / 2, h - k / 2, j, k);
                d = true;
            }
            if (e.height > f.height) {
                var l = e.width / e.height;
                var m = f.height;
                var n = l * m;
                e = new Rect(0, g - n / 2, h - m / 2, n, m);
                d = true;
            }
            if (e.left < f.left) {
                e = new Rect(0, f.left, e.top, e.width, e.height);
                d = true;
            }
            if (e.top < f.top) {
                e = new Rect(0, e.left, f.top, e.width, e.height);
                d = true;
            }
            if (e.right > f.right) {
                e = new Rect(0, f.right - e.width, e.top, e.width, e.height);
                d = true;
            }
            if (e.bottom > f.bottom) {
                e = new Rect(0, e.left, f.bottom - e.height, e.width, e.height);
                d = true;
            }
        }
        if (d) {
            this.ez = true;
            this.w0 = e;
            this.ez = false;
        }
        return e;
    };
    XamGeographicMap.prototype.nd = function (a, b) {
        var c = true;
        var d = true;
        var e = 0;
        var f = this.wt();
        var g = 0;
        var h = 0;
        if ((a.right - f.right) > 0) {
            g = ((a.right - f.right) / a.width);
        }
        if (a.left < f.left) {
            h = (Math.abs(a.left - f.left) / a.width);
        }
        if (h == 0 && g == 0) {
            c = false;
        }
        if (h > g) {
            d = false;
        }
        if (c) {
            if (d) {
                var i = this.w6.el(-180, b);
                var j = this.w6.el(180, b);
                e = j - i;
            }
            else {
                var k = this.w6.el(-180, b);
                var l = this.w6.el(180, b);
                e = k - l;
            }
        }
        return new Tuple$2(Boolean_$type, Number_$type, c, e);
    };
    XamGeographicMap.prototype.wt = function () {
        var a = new ScalerParams(1, XamGeographicMap.y7, this.wz, this.w7.ch);
        a.c = this.wl;
        var b = new ScalerParams(1, XamGeographicMap.y7, this.wz, this.w9.ch);
        b.c = this.wl;
        var c = this.w7.el(XamGeographicMap.y4.left, a);
        var d = this.w7.el(XamGeographicMap.y4.right, a);
        var e = this.w9.el(XamGeographicMap.y4.top, b);
        var f = this.w9.el(XamGeographicMap.y4.bottom, b);
        this.y6 = new Rect(0, c / this.wz.width, f / this.wz.height, (d - c) / this.wz.width, (e - f) / this.wz.height);
        return this.y6;
    };
    XamGeographicMap.prototype.zb = function (a) {
        var b = this.ho;
        var c = 0.5 * (a.left + a.right);
        var d = 0.5 * (a.top + a.bottom);
        var e = a.width;
        var f = a.height;
        var g = MathUtil.d(a.width, b, 1);
        var h = MathUtil.d(a.height, b, 1);
        var i = this.wz;
        var j = i.width / i.height;
        var k = g * i.width;
        var l = h * i.height;
        var m = k / l;
        if (m != j) {
            if (l * j > k) {
                k = l * j;
                g = k / i.width;
            }
            else {
                l = k / j;
                h = l / i.height;
            }
        }
        var n = g != e;
        var o = h != f;
        var p = n ? c - 0.5 * g : a.left;
        var q = o ? d - 0.5 * h : a.top;
        var r = n ? c + 0.5 * g : a.right;
        var s = o ? d + 0.5 * h : a.bottom;
        if (p < 0) {
            p = 0;
            r = p + g;
        }
        if (r > 1) {
            r = 1;
            p = r - g;
        }
        if (q < 0) {
            q = 0;
            s = q + h;
        }
        if (s > 1) {
            s = 1;
            q = s - h;
        }
        return new Rect(0, p, q, r - p, s - q);
    };
    XamGeographicMap.prototype.wj = function (a) {
        _super.prototype.wj.call(this, this.wz);
        if (a.isEmpty) {
            return Rect.empty;
        }
        var b;
        if (a.width > a.height) {
            var c = intDivide(truncate((a.width - a.height)), 2);
            b = new Rect(0, a.left + c, a.top, a.height, a.height);
        }
        else {
            var d = intDivide(truncate((a.height - a.width)), 2);
            b = new Rect(0, a.left, a.top + d, a.width, a.width);
        }
        return b;
    };
    XamGeographicMap.prototype.zd = function (a) {
        return this.wj(a);
    };
    XamGeographicMap.prototype.c8 = function () {
        return new XamGeographicMapView(this);
    };
    XamGeographicMap.prototype.yd = function (a) {
        if (a != null) {
            a.bi = this;
        }
    };
    XamGeographicMap.prototype.qe = function (a) {
        _super.prototype.qe.call(this, a);
        this.xj = a;
    };
    XamGeographicMap.prototype.qp = function (a, b) {
        _super.prototype.qp.call(this, a, b);
        this.ru(this.w7);
        this.ru(this.w9);
        if (Rect.l_op_Inequality(a, b)) {
            this.yi();
        }
        if (this.xo) {
            this.wh = this.wi();
        }
        this.yp();
    };
    Object.defineProperty(XamGeographicMap.prototype, "xt", {
        get: function () {
            return this.xr;
        },
        set: function (a) {
            var b = this.xr;
            this.xr = a;
            this.qv("ActualWindowScale", b, this.xr);
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.hu = function () {
        return this.xt;
    };
    XamGeographicMap.prototype.hv = function () {
        return this.xt;
    };
    XamGeographicMap.prototype.rt = function () {
        _super.prototype.rt.call(this);
        var a = Math.min(this.wh.width, this.wh.height);
        this.xt = a;
    };
    XamGeographicMap.prototype.f4 = function () {
        return this.xl;
    };
    XamGeographicMap.prototype.cs = function () {
        if (this.ct == 0) {
            if (this.xm) {
                return 2;
            }
        }
        return this.ct;
    };
    XamGeographicMap.prototype.qq = function (a, b, c, d) {
        var e_2, _a, e_3, _b;
        _super.prototype.qq.call(this, a, b, c, d);
        switch (b) {
            case "ZoomCoercionMode":
                this.ye();
                break;
            case "WindowRect":
                this.ym();
                break;
            case XamGeographicMap.$$p[0]:
                this.xf = this.xg();
                if (this.xc != null) {
                    this.xc.isHorizontalWrappingEnabled = this.xf == 2;
                }
                break;
            case XamGeographicMap.$$p[1]:
                this.xl = this.xm;
                this.xf = this.xg();
                this.cr = this.cs();
                if (this.xc != null) {
                    this.xc.isHorizontalWrappingEnabled = this.xf == 2;
                }
                break;
            case XamGeographicMap.$$p[4]:
                this.wh = this.wi();
                break;
            case "BackgroundContent":
                if (this.xc != null) {
                    var e = this.xc;
                    e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.yf));
                    this.xc.deferralHandler = null;
                }
                this.xc = typeCast(GeographicMapImagery.$, this.backgroundContent);
                if (this.xc != null) {
                    var f = this.xc;
                    f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.yf));
                    this.xc.deferralHandler = this;
                    this.xc.isHorizontalWrappingEnabled = this.xf == 2;
                }
                this.xj.fu(typeCast(GeographicMapImagery.$, c), typeCast(GeographicMapImagery.$, d));
                if (this.xc != null) {
                    this.xc.geographicMap = this;
                    this.xj.fr(this.wh);
                    this.xj.fv(this.hk);
                }
                break;
            case "YAxis":
            case "XAxis":
                this.yk(c);
                this.yd(d);
                break;
            case XamGeographicMap.$$p[6]:
                if (!this.xn) {
                    this.w0 = XamGeographicMap.y7;
                }
                this.ye();
                this.yl();
                this.ym();
                this.wh = this.wi();
                this.xj.fs();
                break;
            case "ActualWindowRect":
                this.xj.fr(this.wh);
                break;
            case "ActualWorldRect":
                try {
                    for (var _c = __values(fromEnum(this.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var g = _d.value;
                        g.ru(false);
                    }
                }
                catch (e_2_1) {
                    e_2 = { error: e_2_1 };
                }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return))
                            _a.call(_c);
                    }
                    finally {
                        if (e_2)
                            throw e_2.error;
                    }
                }
                break;
            case XamGeographicMap.$$p[5]:
                this.xt = this.xu;
                break;
            case "ActualWindowScale":
                if (!this.gc) {
                    this.r4(this.hu(), this.hv());
                }
                break;
            case "ActualPixelScalingRatio":
                this.xj.fv(this.hk);
                break;
            case "WindowRectMinWidth":
            case "WindowRectMinHeight":
                var h = d;
                if (isNaN_(h) || isInfinity(h)) {
                    this.ho = 5E-06;
                    this.hn = 5E-06;
                }
                else {
                    this.ho = h;
                    this.hn = h;
                }
                break;
            case XamGeographicMap.$$p[7]:
                this.r0();
                break;
            case "MarkerAutomaticBehavior":
                try {
                    for (var _e = __values(fromEnum(this.series)), _f = _e.next(); !_f.done; _f = _e.next()) {
                        var i = _f.value;
                        i.qi();
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_f && !_f.done && (_b = _e.return))
                            _b.call(_e);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
                break;
        }
    };
    XamGeographicMap.prototype.yf = function (a, b) {
        if (this.imageTilesReady != null) {
            this.imageTilesReady(this, new ImageTilesReadyEventArgs());
        }
    };
    XamGeographicMap.prototype.yk = function (a) {
        if (a != null) {
            a.bi = null;
        }
    };
    XamGeographicMap.prototype.yl = function () {
        if (this.w7 != null) {
            this.w7.mc = this.y8.left;
            this.w7.mb = this.y8.right;
        }
        if (this.w9 != null) {
            this.w9.mc = this.y8.top;
            this.w9.mb = this.y8.bottom;
        }
        this.w7.c2(true);
        this.w9.c2(true);
    };
    XamGeographicMap.prototype.getFontInfo = function () {
        this.xk = this.xj.fo;
        return this.xk;
    };
    XamGeographicMap.prototype.vl = function () {
        return this.xj.fw;
    };
    XamGeographicMap.prototype.getFontBrush = function () {
        return this.xj.fx;
    };
    XamGeographicMap.prototype.rm = function (a, b) {
        if (typeCast(ItfConverter.$, b) !== null) {
            var c = b;
            var d = a;
            d.itemsSource = c.triangulationSource.points;
            d.xe = c.triangulationSource.triangles;
        }
        else {
            _super.prototype.rm.call(this, a, b);
        }
    };
    XamGeographicMap.prototype.register = function (a, b) {
        this.ra(a, b);
    };
    XamGeographicMap.prototype.unRegister = function (a) {
        this.rs(a);
    };
    XamGeographicMap.prototype.deferredRefresh = function () {
        this.nr();
    };
    XamGeographicMap.prototype.deferAction = function (a) {
        if (this.xw != null) {
            this.xw.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    };
    XamGeographicMap.prototype.yc = function (a) {
        this.rz(a);
    };
    XamGeographicMap.prototype.xx = function () {
        var a = new ChartVisualData();
        var b = this.w7.fy();
        var c = this.w9.fy();
        a.axes.add1(b);
        a.axes.add1(c);
        for (var d = 0; d < this.series.count; d++) {
            var e = this.series._inner[d].kn();
            a.series.add1(e);
        }
        a.name = this.name;
        a.contentArea = RectData.b(this.wz);
        a.centralArea = RectData.b(this.wz);
        a.plotArea = RectData.b(this.wz);
        return a;
    };
    XamGeographicMap.prototype.wp = function (a, b, c) {
        return a;
    };
    XamGeographicMap.prototype.yg = function () {
    };
    Object.defineProperty(XamGeographicMap.prototype, "zj", {
        get: function () {
            return this.y5;
        },
        set: function (a) {
            this.y5 = a;
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.prototype.yq = function (a) {
        this.zj = a;
        this.yp();
    };
    XamGeographicMap.prototype.yp = function () {
        if (this.xq && !this.zj.isEmpty) {
            var a = this.getZoomFromGeographicRect(this.zj);
            this.zj = Rect.empty;
            this.r6(a, false);
        }
    };
    Object.defineProperty(XamGeographicMap.prototype, "xq", {
        get: function () {
            return !this.wz.isEmpty && !this.wl.isEmpty;
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMap.$t = markType(XamGeographicMap, 'XamGeographicMap', SeriesViewer.$, [IMapRenderDeferralHandler_$type]);
    XamGeographicMap.xh = 0;
    XamGeographicMap.y4 = new Rect(2, { $type: Point_$type, x: -180, y: -85.05112878 }, { $type: Point_$type, x: 180, y: 85.05112878 });
    XamGeographicMap.y7 = new Rect(0, 0, 0, 1, 1);
    XamGeographicMap.$$p = markDep(DependencyProperty, PropertyMetadata, XamGeographicMap, 'qv', ['BackgroundTilingMode:xe:yr', [MapBackgroundTilingMode_$type, enumGetBox(MapBackgroundTilingMode_$type, 0)], 'IsHorizontalWrappingEnabled:xm:ys', [0, false], 'ResizeBehavior:xi:yt', [MapResizeBehavior_$type, enumGetBox(MapResizeBehavior_$type, XamGeographicMap.xh)], 'SuppressZoomResetOnWorldRectChange:xn:yu', [0, false], 'UseWorldRectForZoomBounds:xo:yv', [0, false], 'WindowScale:xu:yw', [1, NaN], 'WorldRect:zk:yx', [Rect.$, XamGeographicMap.y4], 'Zoomable:xp:yy', [0, true]]);
    return XamGeographicMap;
}(SeriesViewer));
export { XamGeographicMap };
/**
 * @hidden
 */
var GeographicMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicMapImagery, _super);
    function GeographicMapImagery(a) {
        var _this = _super.call(this) || this;
        _this.ak = null;
        _this.imageTilesReady = null;
        _this.an = null;
        _this.ap = null;
        _this.propertyChanged = null;
        _this.imagesChanged = null;
        _this.cancellingImage = null;
        _this.downloadingImage = null;
        _this.ab = GeographicMapImagery.$;
        _this.ap = a;
        _this.aj = _this.ai();
        _this.bb(_this.aj);
        return _this;
    }
    GeographicMapImagery.prototype.bb = function (a) {
    };
    GeographicMapImagery.prototype.ai = function () {
        return new GeographicMapImageryView(this);
    };
    Object.defineProperty(GeographicMapImagery.prototype, "deferralHandler", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            this.ak = a;
            if (this.ao != null) {
                this.ao.al = a;
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImagery.prototype.a5 = function (a, b) {
        if (this.imageTilesReady != null) {
            this.imageTilesReady(this, new ImageTilesReadyEventArgs());
        }
    };
    GeographicMapImagery.prototype.a9 = function () {
        var a = this.ao;
        a.imageTilesReady = delegateCombine(a.imageTilesReady, runOn(this, this.a5));
        this.ao.al = this.deferralHandler;
        var b = this.ao;
        b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.a4));
        var c = this.ao;
        c.downloadingImage = delegateCombine(c.downloadingImage, runOn(this, this.a3));
        var d = this.ao;
        d.cancellingImage = delegateCombine(d.cancellingImage, runOn(this, this.a2));
        this.ao.bf = this.referer;
        this.ao.bj = this.userAgent;
        this.ao.av = this.isHorizontalWrappingEnabled;
    };
    GeographicMapImagery.prototype.a3 = function (a, b) {
        if (this.downloadingImage != null) {
            this.downloadingImage(this, b);
        }
    };
    GeographicMapImagery.prototype.a2 = function (a, b) {
        if (this.cancellingImage != null) {
            this.cancellingImage(this, b);
        }
    };
    GeographicMapImagery.prototype.bg = function () {
        if (this.ao != null) {
            this.aj.e();
        }
    };
    GeographicMapImagery.prototype.ba = function (a, b, c) {
        switch (a) {
            case GeographicMapImagery.$$p[3]:
                this.bg();
                break;
            case "GeographicMap":
                this.aj.e();
                break;
            case GeographicMapImagery.$$p[1]:
                if (this.ao != null) {
                    this.ao.bf = this.referer;
                }
                break;
            case GeographicMapImagery.$$p[2]:
                if (this.ao != null) {
                    this.ao.bj = this.userAgent;
                }
                break;
            case GeographicMapImagery.$$p[0]:
                if (this.ao != null) {
                    this.ao.av = this.isHorizontalWrappingEnabled;
                }
                break;
        }
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    };
    Object.defineProperty(GeographicMapImagery.prototype, "geographicMap", {
        get: function () {
            return this.c(GeographicMapImagery.geographicMapProperty);
        },
        set: function (a) {
            this.h(GeographicMapImagery.geographicMapProperty, a);
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImagery.a8 = function (a, b) {
        a.a7(b.oldValue, b.newValue);
    };
    GeographicMapImagery.prototype.a7 = function (a, b) {
        this.ba("GeographicMap", a, b);
    };
    GeographicMapImagery.prototype.clearTileCache = function () {
        if (this.ao != null) {
            this.ao.bs(0, 0, 0, 0);
        }
    };
    Object.defineProperty(GeographicMapImagery.prototype, "ao", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            this.an = a;
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs("MultiScaleImage"));
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImagery.prototype.bn = function (a) {
        if (this.geographicMap == null || a.width < 1 || a.height < 1) {
            return a;
        }
        var b = new Rect(0, 0, 0, a.width, a.height);
        var c = this.geographicMap.zd(b);
        var d = XamGeographicMap.y4;
        var e = this.geographicMap.y8;
        var f = Math.min(this.windowRect.height, this.windowRect.width);
        var g = e.width / d.width;
        this.ao.a5 = (b.width / c.width) * f * g;
        var h = this.geographicMap.w7;
        var i = this.geographicMap.w9;
        var j = new ScalerParams(1, this.windowRect, b, h.ch);
        j.c = c;
        var k = new ScalerParams(1, this.windowRect, b, i.ch);
        k.c = c;
        var l = h.el(d.left, j);
        var m = i.el(d.bottom, k);
        var n = (-l / b.width) * this.ao.a5;
        var o = (-m / b.height) * this.ao.a5 * (b.height / b.width);
        this.ao.cm = { $type: Point_$type, x: n, y: o };
        return a;
    };
    GeographicMapImagery.prototype.bd = function (a) {
        this.aj.f(a);
    };
    GeographicMapImagery.prototype.bf = function (a) {
        this.aj.h(a);
    };
    GeographicMapImagery.prototype.be = function (a) {
        this.aj.g(a);
    };
    GeographicMapImagery.prototype.a4 = function (a, b) {
        if (this.imagesChanged != null) {
            this.imagesChanged(this, new ImagesChangedEventArgs());
        }
    };
    GeographicMapImagery.prototype.a6 = function () {
        this.aj.e();
    };
    GeographicMapImagery.prototype.bc = function (a) {
        this.aj.i(a);
    };
    GeographicMapImagery.prototype.v = function () {
        _super.prototype.v.call(this);
        this.ap.o = this._opacity;
    };
    GeographicMapImagery.$t = markType(GeographicMapImagery, 'GeographicMapImagery', Control.$, [INotifyPropertyChanged_$type]);
    GeographicMapImagery.geographicMapProperty = DependencyProperty.i("GeographicMap", XamGeographicMap.$, GeographicMapImagery.$, new PropertyMetadata(2, null, GeographicMapImagery.a8));
    GeographicMapImagery.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicMapImagery, 'ba', ['IsHorizontalWrappingEnabled', [0, false], 'Referer', [2, null], 'UserAgent', [2, null], 'WindowRect', [Rect.$, Rect.empty]]);
    return GeographicMapImagery;
}(Control));
export { GeographicMapImagery };
/**
 * @hidden
 */
var GeographicMapImageryView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicMapImageryView, _super);
    function GeographicMapImageryView(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.j = null;
        _this.d = null;
        _this.b = 1;
        _this.j = Rect.empty;
        _this.a = a;
        _this.a.ao = new XamMultiScaleImage();
        _this.a.ao.ao = _this.a.ap;
        _this.a.a9();
        return _this;
    }
    GeographicMapImageryView.prototype.e = function () {
        if (this.j.isEmpty) {
            return;
        }
        this.a.bn(new Size(1, this.j.width, this.j.height));
    };
    GeographicMapImageryView.prototype.f = function (a) {
        this.a.ao.b1(a);
    };
    GeographicMapImageryView.prototype.g = function (a) {
        this.d = a;
        this.a.ao.b2(a);
    };
    GeographicMapImageryView.prototype.h = function (a) {
        this.j = a;
        this.a.ao.b3(a);
        this.a.a6();
    };
    Object.defineProperty(GeographicMapImageryView.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapImageryView.prototype.i = function (a) {
        this.b = a;
        this.a.ao.bz(a);
    };
    GeographicMapImageryView.$t = markType(GeographicMapImageryView, 'GeographicMapImageryView');
    return GeographicMapImageryView;
}(Base));
export { GeographicMapImageryView };
/**
 * @hidden
 */
var GeographicXYTriangulatingSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicXYTriangulatingSeriesView, _super);
    function GeographicXYTriangulatingSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cu = null;
        _this.cu = a;
        return _this;
    }
    GeographicXYTriangulatingSeriesView.prototype.ci = function () {
        _super.prototype.ci.call(this);
        var a = this.cu.w5;
        a.x5 = this.cu.xh;
        a.yd = this.cu.xf;
        a.trianglesSource = this.cu.xe;
        a.xt = this.cu.xk;
        a.xv = this.cu.xm;
        a.xx = this.cu.xo;
    };
    GeographicXYTriangulatingSeriesView.prototype.cx = function () {
        var a = this.cu.w5;
        if (this.cu.dc == null) {
            a.w3 = null;
            a.w4 = null;
            return;
        }
        a.w3 = this.cu.dc.w7;
        a.w4 = this.cu.dc.w9;
    };
    GeographicXYTriangulatingSeriesView.prototype.cw = function () {
        this.cu.w5.x5 = this.cu.xh;
    };
    GeographicXYTriangulatingSeriesView.prototype.cv = function () {
        this.cu.w5.yd = this.cu.xf;
    };
    GeographicXYTriangulatingSeriesView.prototype.cy = function () {
        this.cu.w5.trianglesSource = this.cu.xe;
    };
    GeographicXYTriangulatingSeriesView.prototype.cz = function () {
        this.cu.w5.xt = this.cu.xk;
    };
    GeographicXYTriangulatingSeriesView.prototype.c0 = function () {
        this.cu.w5.xv = this.cu.xm;
    };
    GeographicXYTriangulatingSeriesView.prototype.c1 = function () {
        this.cu.w5.xx = this.cu.xo;
    };
    GeographicXYTriangulatingSeriesView.$t = markType(GeographicXYTriangulatingSeriesView, 'GeographicXYTriangulatingSeriesView', HostSeriesView.$);
    return GeographicXYTriangulatingSeriesView;
}(HostSeriesView));
export { GeographicXYTriangulatingSeriesView };
/**
 * @hidden
 */
var GeographicScatterAreaSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicScatterAreaSeriesView, _super);
    function GeographicScatterAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c2 = null;
        _this.c2 = a;
        return _this;
    }
    GeographicScatterAreaSeriesView.prototype.a4 = function () {
        _super.prototype.a4.call(this);
        if (!this.t) {
        }
    };
    GeographicScatterAreaSeriesView.prototype.ci = function () {
        _super.prototype.ci.call(this);
        if (this.c2.xz != null) {
            this.c2.xz.zc = this.c2.x3;
            this.c2.xz.y0 = this.c2.xy;
        }
    };
    GeographicScatterAreaSeriesView.prototype.c3 = function () {
        if (this.c2.xz != null) {
            this.c2.xz.zc = this.c2.x3;
        }
    };
    GeographicScatterAreaSeriesView.prototype.c4 = function () {
        if (this.c2.xz != null) {
            this.c2.xz.y0 = this.c2.xy;
        }
    };
    GeographicScatterAreaSeriesView.$t = markType(GeographicScatterAreaSeriesView, 'GeographicScatterAreaSeriesView', GeographicXYTriangulatingSeriesView.$);
    return GeographicScatterAreaSeriesView;
}(GeographicXYTriangulatingSeriesView));
export { GeographicScatterAreaSeriesView };
/**
 * @hidden
 */
var XamGeographicMapView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XamGeographicMapView, _super);
    function XamGeographicMapView(a) {
        var _this = _super.call(this, a) || this;
        _this.fn = null;
        _this.fz = null;
        _this.fx = null;
        _this.fw = null;
        _this.fo = null;
        _this.fp = NaN;
        _this.fz = Rect.empty;
        _this.fn = a;
        _this.fn.ve = 2;
        _this.fn.iv = 5E-06;
        return _this;
    }
    XamGeographicMapView.prototype.m = function (a) {
        return 2;
    };
    XamGeographicMapView.prototype.bk = function (a) {
        this.j.bw(a);
        this.fn.yc(a);
        this.el();
    };
    XamGeographicMapView.prototype.get_ap = function () {
        return true;
    };
    XamGeographicMapView.prototype.d4 = function () {
        var a;
        var b;
        var c;
        var d;
        var e;
        var f = this.j.a8(a, b, c, d, e);
        a = f.p0;
        b = f.p1;
        c = f.p2;
        d = f.p3;
        e = f.p4;
        this.fx = c;
        this.fo = d;
        this.fw = e;
        var g = this.j.e();
        this.fn.ag = g.a;
        this.fn.aj = g.f;
        this.fn.ah = g.b != null ? g.b : new BrushCollection();
        this.fn.ai = g.c != null ? g.c : new BrushCollection();
        if (this.fn.ah.count == 0) {
            for (var h = 0; h < g.a.count; h++) {
                this.fn.ah.add(g.a.item(h));
            }
        }
        if (g.c.count == 0) {
            for (var i = 0; i < g.f.count; i++) {
                this.fn.ai.add(g.f.item(i));
            }
        }
    };
    XamGeographicMapView.prototype.du = function (a) {
        _super.prototype.du.call(this, a);
        if (this.fn.backgroundContent != null) {
            var b = this.fn.backgroundContent;
            b.be(this.j.ae);
            b.bd(a);
        }
    };
    XamGeographicMapView.prototype.dv = function (a) {
        _super.prototype.dv.call(this, a);
        this.fz = a;
        if (this.fn.backgroundContent != null) {
            var b = this.fn.backgroundContent;
            b.bf(this.fz);
        }
    };
    XamGeographicMapView.prototype.fy = function () {
        return new Rect(0, 0, 0, this.fz.width, this.fz.height);
    };
    XamGeographicMapView.prototype.fs = function () {
        if (this.fn.backgroundContent != null) {
            var a = this.fn.backgroundContent;
            a.a6();
        }
    };
    XamGeographicMapView.prototype.fr = function (a) {
        if (this.fn.xc != null) {
            this.fn.xc.windowRect = a;
        }
    };
    XamGeographicMapView.prototype.fu = function (a, b) {
        if (this.fn.xc != null) {
            this.fn.xc.windowRect = this.fn.wh;
        }
        if (a != null) {
            var c = a.ao;
            if (c != null) {
                this.fn.al.h.remove(c.ag);
            }
            a.bd(null);
            a.be(null);
        }
        if (b != null) {
            var d = b.ao;
            if (d != null) {
                this.fn.al.h.add(d.ag);
            }
            if (!this.fz.isEmpty) {
                this.dv(this.fz);
            }
            if (this.w != null) {
                this.du(this.w);
            }
        }
        if (b == null) {
            this.ft(this.w);
        }
    };
    XamGeographicMapView.prototype.ft = function (a) {
        var b = this.fn.hk;
        if (b != 1) {
            a.aa();
            a.ab(b, b);
        }
        a.l(this.fz.left, this.fz.top, this.fz.width, this.fz.height);
        if (b != 1) {
            a.z();
        }
    };
    XamGeographicMapView.prototype.d1 = function () {
        this.fd.ad = Defaults.crosshairLineThickness;
        this.fe.ad = Defaults.crosshairLineThickness;
        this.fd._stroke = Defaults.crosshairLineBrush;
        this.fe._stroke = Defaults.crosshairLineBrush;
        _super.prototype.d1.call(this);
    };
    XamGeographicMapView.prototype.fv = function (a) {
        this.fp = a;
        if (this.fn.backgroundContent != null) {
            this.fn.backgroundContent.bc(a);
        }
    };
    Object.defineProperty(XamGeographicMapView.prototype, "fq", {
        get: function () {
            return this.fp;
        },
        set: function (a) {
            this.fp = a;
        },
        enumerable: false,
        configurable: true
    });
    XamGeographicMapView.$t = markType(XamGeographicMapView, 'XamGeographicMapView', SeriesViewerView.$);
    return XamGeographicMapView;
}(SeriesViewerView));
export { XamGeographicMapView };
/**
 * @hidden
 */
var OpenStreetMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(OpenStreetMapImagery, _super);
    function OpenStreetMapImagery() {
        return _super.call(this, new OpenStreetMapTileSource()) || this;
    }
    Object.defineProperty(OpenStreetMapImagery.prototype, "tilePath", {
        get: function () {
            return this.c(OpenStreetMapImagery.tilePathProperty);
        },
        set: function (a) {
            this.h(OpenStreetMapImagery.tilePathProperty, a);
        },
        enumerable: false,
        configurable: true
    });
    OpenStreetMapImagery.br = function (a, b) {
        a.bq("TilePath", b.oldValue, b.newValue);
    };
    OpenStreetMapImagery.prototype.bq = function (a, b, c) {
        switch (a) {
            case "TilePath":
                this.ap.setTilePathUrl(c == null ? null : c);
                this.aj.e();
                break;
        }
        _super.prototype.ba.call(this, a, b, c);
    };
    OpenStreetMapImagery.$t = markType(OpenStreetMapImagery, 'OpenStreetMapImagery', GeographicMapImagery.$);
    OpenStreetMapImagery.tilePathProperty = DependencyProperty.i("TilePath", String_$type, OpenStreetMapImagery.$, new PropertyMetadata(2, null, OpenStreetMapImagery.br));
    return OpenStreetMapImagery;
}(GeographicMapImagery));
export { OpenStreetMapImagery };
/**
 * @hidden
 */
var GeographicXYTriangulatingSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicXYTriangulatingSeries, _super);
    function GeographicXYTriangulatingSeries() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GeographicXYTriangulatingSeries.prototype.ct = function () {
        return new GeographicXYTriangulatingSeriesView(this);
    };
    GeographicXYTriangulatingSeries.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.xd = a;
    };
    GeographicXYTriangulatingSeries.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.xd.cx();
                break;
            case GeographicXYTriangulatingSeries.$$p[1]:
                this.xd.cw();
                break;
            case GeographicXYTriangulatingSeries.$$p[0]:
                this.xd.cv();
                break;
            case GeographicXYTriangulatingSeries.$$p[5]:
                this.xd.cy();
                break;
            case GeographicXYTriangulatingSeries.$$p[2]:
                this.xd.cz();
                break;
            case GeographicXYTriangulatingSeries.$$p[3]:
                this.xd.c0();
                break;
            case GeographicXYTriangulatingSeries.$$p[4]:
                this.xd.c1();
                break;
        }
    };
    GeographicXYTriangulatingSeries.$t = markType(GeographicXYTriangulatingSeries, 'GeographicXYTriangulatingSeries', GeographicMapSeriesHost.$);
    GeographicXYTriangulatingSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicXYTriangulatingSeries, 'raisePropertyChanged', ['LatitudeMemberPath:xf:xq', [2, "pointY"], 'LongitudeMemberPath:xh:xr', [2, "pointX"], 'TriangleVertexMemberPath1:xk:xt', [2, "v1"], 'TriangleVertexMemberPath2:xm:xu', [2, "v2"], 'TriangleVertexMemberPath3:xo:xv', [2, "v3"], 'TrianglesSource:xe:xs', [IEnumerable_$type, null]]);
    return GeographicXYTriangulatingSeries;
}(GeographicMapSeriesHost));
export { GeographicXYTriangulatingSeries };
/**
 * @hidden
 */
var GeographicScatterAreaSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicScatterAreaSeries, _super);
    function GeographicScatterAreaSeries() {
        var _this = _super.call(this) || this;
        _this.xw = null;
        _this.triangulationStatusChanged = null;
        _this.ab = GeographicScatterAreaSeries.$;
        return _this;
    }
    GeographicScatterAreaSeries.prototype.bk = function () {
        return new GeographicScatterAreaSeries();
    };
    GeographicScatterAreaSeries.prototype.get_ew = function () {
        return true;
    };
    Object.defineProperty(GeographicScatterAreaSeries.prototype, "xy", {
        get: function () {
            return this.xw;
        },
        set: function (a) {
            var b = this.xw != a;
            if (b) {
                var c = this.xw;
                if (this.xw != null) {
                    var d = this.xw;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.x6));
                }
                this.xw = a;
                if (this.xw != null) {
                    var e = this.xw;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.x6));
                }
                this.raisePropertyChanged("ColorScale", c, this.xw);
                if (this.xz != null) {
                    this.xz.y0 = a;
                }
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicScatterAreaSeries.prototype.x6 = function (a, b) {
        this.x1.c4();
        this.x8();
        this.ru(false);
    };
    GeographicScatterAreaSeries.prototype.x8 = function () {
        if (this.xz != null) {
            this.xx = this.xz.yz;
        }
    };
    GeographicScatterAreaSeries.prototype.sl = function () {
        _super.prototype.sl.call(this);
        this.x8();
    };
    GeographicScatterAreaSeries.prototype.w4 = function () {
        this.xz = new ScatterAreaSeries();
        var a = this.xz;
        a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.x7));
        return this.xz;
    };
    GeographicScatterAreaSeries.prototype.x7 = function (a, b) {
        if (this.triangulationStatusChanged != null) {
            this.triangulationStatusChanged(this, b);
        }
    };
    GeographicScatterAreaSeries.prototype.ct = function () {
        return new GeographicScatterAreaSeriesView(this);
    };
    GeographicScatterAreaSeries.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.x1 = a;
    };
    GeographicScatterAreaSeries.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case GeographicScatterAreaSeries.$$p[1]:
                this.x1.c3();
                break;
            case "ColorScale":
                this.x1.c4();
                this.x8();
                break;
        }
    };
    GeographicScatterAreaSeries.prototype.get_g8 = function () {
        return true;
    };
    GeographicScatterAreaSeries.prototype.set_g8 = function (a) {
        _super.prototype.set_g8.call(this, a);
    };
    GeographicScatterAreaSeries.$t = markType(GeographicScatterAreaSeries, 'GeographicScatterAreaSeries', GeographicXYTriangulatingSeries.$);
    GeographicScatterAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:xx:x9', [ColorScale.$, null], 'ColorMemberPath:x3:ya', [2, "value"]]);
    return GeographicScatterAreaSeries;
}(GeographicXYTriangulatingSeries));
export { GeographicScatterAreaSeries };
