/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IgrBingMapsMapImageryModule } from './igr-bing-maps-map-imagery-module';
import { IgrOpenStreetMapImageryModule } from './igr-open-street-map-imagery-module';
import { IgrCustomMapImageryModule } from './igr-custom-map-imagery-module';
import { IgrArcGISOnlineMapImageryModule } from './igr-arc-gis-online-map-imagery-module';
import { IgrGeographicMap } from './igr-geographic-map';
import { TypeRegistrar } from "igniteui-react-core";
var IgrGeographicMapCoreModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrGeographicMapCoreModule() {
    }
    IgrGeographicMapCoreModule.register = function () {
        IgrBingMapsMapImageryModule.register();
        IgrOpenStreetMapImageryModule.register();
        IgrCustomMapImageryModule.register();
        IgrArcGISOnlineMapImageryModule.register();
        TypeRegistrar.registerCons('IgrGeographicMap', IgrGeographicMap);
    };
    return IgrGeographicMapCoreModule;
}());
export { IgrGeographicMapCoreModule };
