/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IgrGeographicShapeSeriesModule } from './igr-geographic-shape-series-module';
import { IgrGeographicPolylineSeriesModule } from './igr-geographic-polyline-series-module';
import { IgrTileGeneratorMapImageryModule } from './igr-tile-generator-map-imagery-module';
import { IgrHeatTileGeneratorModule } from "igniteui-react-core";
import { IgrGeographicTileSeriesModule } from './igr-geographic-tile-series-module';
import { IgrSizeScaleModule } from "igniteui-react-charts";
import { IgrValueBrushScaleModule } from "igniteui-react-charts";
import { IgrCustomPaletteColorScaleModule } from "igniteui-react-charts";
import { IgrGeographicProportionalSymbolSeriesModule } from './igr-geographic-proportional-symbol-series-module';
import { IgrGeographicSymbolSeriesModule } from './igr-geographic-symbol-series-module';
import { IgrGeographicScatterAreaSeriesModule } from './igr-geographic-scatter-area-series-module';
import { IgrGeographicHighDensityScatterSeriesModule } from './igr-geographic-high-density-scatter-series-module';
import { IgrGeographicContourLineSeriesModule } from './igr-geographic-contour-line-series-module';
import { IgrGeographicMapCoreModule } from './igr-geographic-map-core-module';
import { IgrShapeDataSourceModule } from "igniteui-react-core";
var IgrGeographicMapModule = /** @class */ /*@__PURE__*/ (function () {
    function IgrGeographicMapModule() {
    }
    IgrGeographicMapModule.register = function () {
        IgrGeographicShapeSeriesModule.register();
        IgrGeographicPolylineSeriesModule.register();
        IgrTileGeneratorMapImageryModule.register();
        IgrHeatTileGeneratorModule.register();
        IgrGeographicTileSeriesModule.register();
        IgrSizeScaleModule.register();
        IgrValueBrushScaleModule.register();
        IgrCustomPaletteColorScaleModule.register();
        IgrGeographicProportionalSymbolSeriesModule.register();
        IgrGeographicSymbolSeriesModule.register();
        IgrGeographicScatterAreaSeriesModule.register();
        IgrGeographicHighDensityScatterSeriesModule.register();
        IgrGeographicContourLineSeriesModule.register();
        IgrGeographicMapCoreModule.register();
        IgrShapeDataSourceModule.register();
    };
    return IgrGeographicMapModule;
}());
export { IgrGeographicMapModule };
