import { ImagesChangedEventArgs as ImagesChangedEventArgs_internal } from "./ImagesChangedEventArgs";
var IgrImagesChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrImagesChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrImagesChangedEventArgs.prototype.createImplementation = function () {
        return new ImagesChangedEventArgs_internal();
    };
    Object.defineProperty(IgrImagesChangedEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrImagesChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrImagesChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrImagesChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    return IgrImagesChangedEventArgs;
}());
export { IgrImagesChangedEventArgs };
