import { __extends } from "tslib";
import { IgrGeographicMapImagery } from "./igr-geographic-map-imagery";
import { OpenStreetMapImagery as OpenStreetMapImagery_internal } from "./OpenStreetMapImagery";
/**
 * UI element class used to display OpenStreetMap imagery in the IgxGeographicMap.Component
*/
var IgrOpenStreetMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrOpenStreetMapImagery, _super);
    function IgrOpenStreetMapImagery() {
        return _super.call(this) || this;
    }
    IgrOpenStreetMapImagery.prototype.createImplementation = function () {
        return new OpenStreetMapImagery_internal();
    };
    Object.defineProperty(IgrOpenStreetMapImagery.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrOpenStreetMapImagery.prototype, "tilePath", {
        /**
         * Gets or sets the tile path URL.
        */
        get: function () {
            return this.i.tilePath;
        },
        set: function (v) {
            this.i.tilePath = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrOpenStreetMapImagery;
}(IgrGeographicMapImagery));
export { IgrOpenStreetMapImagery };
