import { __extends } from "tslib";
import { IgrGeographicMapImagery } from "./igr-geographic-map-imagery";
import { TileGeneratorMapImagery as TileGeneratorMapImagery_internal } from "./TileGeneratorMapImagery";
/**
 * Represents a CustomMapImagery MapImagery
*/
var IgrTileGeneratorMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTileGeneratorMapImagery, _super);
    function IgrTileGeneratorMapImagery() {
        return _super.call(this) || this;
    }
    IgrTileGeneratorMapImagery.prototype.createImplementation = function () {
        return new TileGeneratorMapImagery_internal();
    };
    Object.defineProperty(IgrTileGeneratorMapImagery.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTileGeneratorMapImagery.prototype, "tileGenerator", {
        /**
         * Gets or sets the culture name for this tile source.
        */
        get: function () {
            return this.i.tileGenerator;
        },
        set: function (v) {
            this.i.tileGenerator = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrTileGeneratorMapImagery;
}(IgrGeographicMapImagery));
export { IgrTileGeneratorMapImagery };
