# Ignite UI for React Maps - from Infragistics

[Ignite UI for React](https://www.infragistics.com/products/ignite-ui-react) includes a wide range of easy to use React UI components that have been designed and optimized for high-performance, high-volume data scenarios. Ignite UI for React is designed to enable developers to build the most modern, high-performance HTML5 & JavaScript apps for modern desktop browsers, mobile experiences and progressive web apps (PWA’s) targeting the React framework.

## View Samples and Documentation

This package provides the Geographic Map components for Ignite UI for React:

[Bubble Map](https://www.infragistics.com/reactsite/components/geo-map-type-scatter-bubble-series), [Symbol Map](https://www.infragistics.com/reactsite/components/geo-map-type-scatter-symbol-series), [High Density Map](https://www.infragistics.com/reactsite/components/geo-map-type-scatter-density-series), [Area Map](https://www.infragistics.com/reactsite/components/geo-map-type-scatter-area-series), [Contour Map](https://www.infragistics.com/reactsite/components/geo-map-type-scatter-contour-series), [Polygon Map](https://www.infragistics.com/reactsite/components/geo-map-type-shape-polygon-series), [Polyline Map](https://www.infragistics.com/reactsite/components/geo-map-type-shape-polyline-series), [Heat Map](https://www.infragistics.com/reactsite/components/geo-map-display-heat-imagery), [Imagery Tiles](https://www.infragistics.com/reactsite/components/geo-map-display-esri-imagery)


## NPM Package

You can include Ignite UI for React Maps in your project using this `npm` command:

`npm install --save igniteui-react-maps igniteui-react-charts igniteui-react-core`

## License
This is a commercial product, requiring a valid paid-for license for use. This license details can by found [here](http://www.infragistics.com/legal/ultimate/license/)

To acquire a license for usage, please register for a trial and acquire a license at [Infragistics.com](https://www.infragistics.com).

© Copyright 2023 Infragistics. All Rights Reserved. The Infragistics Ultimate license & copyright applies to this distribution. For information on that license, please go to our website [here](https://www.infragistics.com/legal/license).
