/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GeographicXYTriangulatingSeriesView } from "./GeographicXYTriangulatingSeriesView";
import { Defaults } from "igniteui-react-charts";
import { ScatterContourSeries } from "igniteui-react-charts";
import { markType, runOn, delegateCombine, typeCast, markDep } from "igniteui-react-core";
import { GeographicXYTriangulatingSeries } from "./GeographicXYTriangulatingSeries";
import { DependencyProperty } from "igniteui-react-core";
import { ValueBrushScale } from "igniteui-react-charts";
import { ContourValueResolver } from "igniteui-react-charts";
import { PropertyMetadata } from "igniteui-react-core";
/**
 * @hidden
 */
export let GeographicContourLineSeriesView = /*@__PURE__*/ (() => {
    class GeographicContourLineSeriesView extends GeographicXYTriangulatingSeriesView {
        constructor(a) {
            super(a);
            this.c2 = null;
            this.c2 = a;
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.c2.jq = Defaults.z;
            }
        }
        ci() {
            super.ci();
            if (this.c2.w5 != null) {
                this.c2.xx.y0 = this.c2.x0;
                this.c2.xx.za = this.c2.x4;
            }
        }
        c3() {
            if (this.c2.xx != null) {
                this.c2.xx.y0 = this.c2.x0;
            }
        }
        c4() {
            if (this.c2.xx != null) {
                this.c2.xx.za = this.c2.x4;
            }
        }
    }
    GeographicContourLineSeriesView.$t = /*@__PURE__*/ markType(GeographicContourLineSeriesView, 'GeographicContourLineSeriesView', GeographicXYTriangulatingSeriesView.$);
    return GeographicContourLineSeriesView;
})();
/**
 * @hidden
 */
export let GeographicContourLineSeries = /*@__PURE__*/ (() => {
    class GeographicContourLineSeries extends GeographicXYTriangulatingSeries {
        bk() {
            return new GeographicContourLineSeries();
        }
        get_fk() {
            return true;
        }
        constructor() {
            super();
            this.triangulationStatusChanged = null;
            this.ab = GeographicContourLineSeries.$;
        }
        xa(a, b) {
            super.xa(a, b);
        }
        w4() {
            this.xx = new ScatterContourSeries();
            let a = this.xx;
            a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.x7));
            let b = this.xx;
            b.propertyUpdated = delegateCombine(b.propertyUpdated, runOn(this, this.x8));
            return this.xx;
        }
        x7(a, b) {
            if (this.triangulationStatusChanged != null) {
                this.triangulationStatusChanged(this, b);
            }
        }
        x8(a, b) {
            let c = typeCast(ScatterContourSeries.$, this.w5);
            if (c == null) {
                return;
            }
            if (b.propertyName == "ActualFillScale") {
                this.xz = c.yz;
            }
        }
        sl() {
            super.sl();
        }
        ct() {
            return new GeographicContourLineSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.x1 = a;
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case GeographicContourLineSeries.$$p[1]:
                    this.x1.c3();
                    break;
                case GeographicContourLineSeries.$$p[2]:
                    this.x1.c4();
                    break;
                case GeographicContourLineSeries.$$p[3]:
                    this.xx.yx = this.xw;
                    break;
                case "DashArray":
                    this.xx.v7 = this.v7;
                    break;
                case "DashCap":
                    this.xx.v8 = this.v8;
                    break;
                case "MiterLimit":
                    this.xx.ji = this.ji;
                    break;
                case "LineJoin":
                    this.xx.wa = this.wa;
                    break;
            }
        }
    }
    GeographicContourLineSeries.$t = /*@__PURE__*/ markType(GeographicContourLineSeries, 'GeographicContourLineSeries', GeographicXYTriangulatingSeries.$);
    GeographicContourLineSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicContourLineSeries, 'raisePropertyChanged', ['ActualFillScale:xz:x9', [ValueBrushScale.$, null], 'FillScale:x0:ya', [ValueBrushScale.$, null], 'ValueMemberPath:x4:yb', [2, "value"], 'ValueResolver:xw:yc', [ContourValueResolver.$, null]]);
    return GeographicContourLineSeries;
})();
