/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HostSeriesView } from "./HostSeriesView";
import { HighDensityScatterSeries } from "igniteui-react-charts";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { Color } from "igniteui-react-core";
import { Defaults } from "igniteui-react-charts";
import { typeCast, markType, runOn, delegateCombine, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let GeographicHighDensityScatterSeriesView = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.cu = null;
            this.cu = a;
        }
        ci() {
            super.ci();
            let a = typeCast(HighDensityScatterSeries.$, this.cu.w5);
            a.ze = this.cu.xu;
            a.zm = this.cu.xs;
            a.xr = this.cu.xh;
            a.xq = this.cu.xg;
            a.f9 = this.cu.xf;
            a.ym = this.cu.xj;
            a.yl = this.cu.xi;
            a.aak = this.cu.yd;
            a.aaj = this.cu.yc;
            a.yy = this.cu.xm;
        }
        c0() {
            this.cu.w5.ze = this.cu.xu;
        }
        cz() {
            this.cu.w5.zm = this.cu.xs;
        }
        c5() {
            this.cu.w5.xr = this.cu.xh;
        }
        c3() {
            this.cu.w5.xq = this.cu.xg;
        }
        c1() {
            this.cu.w5.f9 = this.cu.xf;
        }
        cy() {
            this.cu.w5.ym = this.cu.xj;
        }
        cw() {
            this.cu.w5.yl = this.cu.xi;
        }
        c4() {
            let a = typeCast(HighDensityScatterSeries.$, this.cu.w5);
            if (this.cu.dc == null) {
                a.xa = null;
                a.xc = null;
                return;
            }
            a.xa = this.cu.dc.w7;
            a.xc = this.cu.dc.w9;
        }
        c6() {
            this.cu.w5.xa = this.cu.dc.w7;
        }
        c7() {
            this.cu.w5.xc = this.cu.dc.w9;
        }
        cx() {
            this.cu.w5.aak = this.cu.yd;
        }
        cv() {
            this.cu.w5.aaj = this.cu.yc;
        }
        c2() {
            this.cu.w5.yy = this.cu.xm;
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.cu.yd = Defaults.bf;
                this.cu.yc = Defaults.be;
                this.cu.vk = Defaults.ba;
                this.cu.v0 = Defaults.a9;
            }
        }
    }
    GeographicHighDensityScatterSeriesView.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeriesView, 'GeographicHighDensityScatterSeriesView', HostSeriesView.$);
    return GeographicHighDensityScatterSeriesView;
})();
/**
 * @hidden
 */
export let GeographicHighDensityScatterSeries = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeries extends GeographicMapSeriesHost {
        bk() {
            return new GeographicHighDensityScatterSeries();
        }
        jl() {
            if (!isNaN_(this.jk)) {
                return super.jl();
            }
            return Defaults.ad;
        }
        get_fp() {
            return true;
        }
        constructor() {
            super();
            this.xd = null;
            this.progressiveLoadStatusChanged = null;
            this.xl = 0;
            this.ab = GeographicHighDensityScatterSeries.$;
        }
        ct() {
            return new GeographicHighDensityScatterSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.xe = a;
        }
        w4() {
            this.xd = new HighDensityScatterSeries();
            return this.xd;
        }
        get xn() {
            return this.xl;
        }
        set xn(a) {
            let b = this.xl;
            this.xl = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.xl);
        }
        xa(a, b) {
            super.xa(a, b);
            let c = this.w5;
            c.progressiveLoadStatusChanged = delegateCombine(c.progressiveLoadStatusChanged, runOn(this, this.x1));
            let d = this.w5;
            d.propertyUpdated = delegateCombine(d.propertyUpdated, runOn(this, this.x0));
        }
        x1(a, b) {
            this.xn = b.currentStatus;
            if (this.progressiveLoadStatusChanged != null) {
                this.progressiveLoadStatusChanged(this, b);
            }
        }
        x0(a, b) {
            if (this.xd == null) {
                return;
            }
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.xe.c4();
                    break;
                case GeographicHighDensityScatterSeries.$$p[5]:
                    this.xe.c0();
                    break;
                case GeographicHighDensityScatterSeries.$$p[4]:
                    this.xe.cz();
                    break;
                case GeographicHighDensityScatterSeries.$$p[9]:
                    this.xe.c5();
                    break;
                case GeographicHighDensityScatterSeries.$$p[8]:
                    this.xe.c3();
                    break;
                case GeographicHighDensityScatterSeries.$$p[6]:
                    this.xe.c1();
                    break;
                case "XAxis":
                    this.xe.c6();
                    break;
                case "YAxis":
                    this.xe.c7();
                    break;
                case GeographicHighDensityScatterSeries.$$p[3]:
                    this.xe.cy();
                    break;
                case GeographicHighDensityScatterSeries.$$p[1]:
                    this.xe.cw();
                    break;
                case GeographicHighDensityScatterSeries.$$p[2]:
                    this.xe.cx();
                    break;
                case GeographicHighDensityScatterSeries.$$p[0]:
                    this.xe.cv();
                    break;
                case GeographicHighDensityScatterSeries.$$p[7]:
                    this.xe.c2();
                    break;
            }
        }
        get_g8() {
            return true;
        }
        set_g8(a) {
            super.set_g8(a);
        }
    }
    GeographicHighDensityScatterSeries.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeries, 'GeographicHighDensityScatterSeries', GeographicMapSeriesHost.$);
    GeographicHighDensityScatterSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicHighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:yc:x2', [Color.$, Defaults.be], 'HeatMaximum:xi:x3', [1, 50], 'HeatMinimumColor:yd:x4', [Color.$, Defaults.bf], 'HeatMinimum:xj:x5', [1, 0], 'LatitudeMemberPath:xs:x6', [2, null], 'LongitudeMemberPath:xu:x7', [2, null], 'MouseOverEnabled:xf:x8', [0, false], 'PointExtent:xm:x9', [1, 1], 'ProgressiveLoad:xg:ya', [0, true], 'UseBruteForce:xh:yb', [0, false]]);
    return GeographicHighDensityScatterSeries;
})();
