/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "igniteui-react-charts";
import { typeCast, Number_$type, runOn, delegateRemove, delegateCombine, markType, TypeRegistrar } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { SeriesView } from "igniteui-react-charts";
import { SeriesViewer } from "igniteui-react-charts";
import { PropertyMetadata } from "igniteui-react-core";
import { PlatformConstants } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let GeographicMapSeriesHost = /*@__PURE__*/ (() => {
    class GeographicMapSeriesHost extends Series {
        qi() {
            super.qi();
            if (this.w5 != null) {
                this.w5.qi();
            }
        }
        constructor() {
            super();
            this.w3 = null;
            this.w5 = this.w4();
        }
        get_fd() {
            return true;
        }
        kr(a, b) {
            let c = this.nf(b);
            if (c == "LatitudeMemberPath") {
                c = "YMemberPath";
            }
            if (c == "LongitudeMemberPath") {
                c = "XMemberPath";
            }
            return this.w5.kr(a, c);
        }
        mf(a) {
            let b = this.nf(a);
            if (b == "LatitudeMemberPath") {
                b = "YMemberPath";
            }
            if (b == "LongitudeMemberPath") {
                b = "XMemberPath";
            }
            return this.w5.mf(b);
        }
        get_kj() {
            return this.k1(this.w5);
        }
        set_kj(a) {
            this.o1(this.w5, a);
        }
        ed(a, b, c, d, e) {
            return this.w5.ed(a, b, c, d, e);
        }
        ai() {
            return this.w5.ai();
        }
        bp() {
            return this.w5;
        }
        get w5() {
            return this.w3;
        }
        set w5(a) {
            let b = this.w3;
            let c = this.w5 != a;
            if (c) {
                this.w3 = a;
                this.xa(b, this.w3);
            }
        }
        get_hasMarkers() {
            return this.w5.hasMarkers;
        }
        xa(a, b) {
            if (this.w3 != null) {
                let hostedSeries_ = this.w3;
                hostedSeries_.externalObject = TypeRegistrar.createFromInternal(hostedSeries_, PlatformConstants.Prefix, PlatformConstants.Postfix);
                hostedSeries_.externalObject._implementation = hostedSeries_;
            }
            this.ph(this.w5);
            this.w6.ci();
            if (a != null) {
                let c = (a);
                this.r5(c, null);
            }
            if (b != null) {
                let d = (b);
                this.r5(d, this);
            }
        }
        dh(a, b, c) {
            return this.dj(this.w5, a, b, c);
        }
        di(a, b, c) {
            return this.dk(this.w5, a, b, c);
        }
        ko(a) {
            return this.kx(this.w5, a);
        }
        kb(a, b) {
            return this.w5.kb(a, b);
        }
        j9(a, b) {
            return this.w5.j9(a, b);
        }
        i6(a, b, c) {
            return this.w5.i6(a, b, c);
        }
        wh(a, b, c) {
            return this.w5.wh(a, b, c);
        }
        ws(a) {
            return this.w5.ws(a);
        }
        ao(a) {
            return this.w5.ao(a);
        }
        wt(a) {
            return this.w5.wt(a);
        }
        ap(a) {
            return this.w5.ap(a);
        }
        wu(a) {
            return this.w5.wu(a);
        }
        wv(a) {
            return this.w5.wv(a);
        }
        i2(a, b, c) {
            return this.w5.i2(a, b, c);
        }
        wd(a, b, c) {
            return this.w5.wd(a, b, c);
        }
        i4(a, b, c) {
            return this.i6(a, b, c);
        }
        wf(a, b, c) {
            return this.w5.wf(a, b, c);
        }
        wi(a, b, c) {
            return this.w5.wi(a, b, c);
        }
        i7(a, b, c) {
            return this.w5.i7(a, b, c);
        }
        we(a, b, c) {
            return this.w5.we(a, b, c);
        }
        i3(a, b, c) {
            return this.w5.i3(a, b, c);
        }
        wg(a, b, c) {
            return this.w5.wg(a, b, c);
        }
        i5(a, b, c) {
            return this.w5.i5(a, b, c);
        }
        j5(a) {
            return this.w5.j5(a);
        }
        ix() {
            return this.w5.ix();
        }
        it(a) {
            return this.w5.it(a);
        }
        kp(a) {
            return this.w5.kp(a);
        }
        ct() {
            return new HostSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.w6 = typeCast(HostSeriesView.$, a);
        }
        get w7() {
            return this.c(GeographicMapSeriesHost.xc);
        }
        set w7(a) {
            this.h(GeographicMapSeriesHost.xc, a);
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.w5.dc = this.dc;
                    if (c != null) {
                        c.rd(this.w5);
                    }
                    if (d != null) {
                        this.dc.nh(this.w5);
                    }
                    this.w5.rf(this.wx);
                    this.w5.index = this.index;
                    this.p2(this.w5);
                    this.kh = this.w5.kh;
                    let e = typeCast(SeriesViewer.$, c);
                    if (e != null) {
                        e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.xb));
                    }
                    if (this.dc != null) {
                        let f = this.dc;
                        f.actualWindowRectChanged = delegateCombine(f.actualWindowRectChanged, runOn(this, this.xb));
                    }
                    this.w9();
                    break;
                case "SyncLink":
                    this.w5.c4 = this.c4;
                    break;
                case "VisibleFromScale":
                    this.w9();
                    break;
                case "Index":
                    this.w5.index = this.index;
                    break;
                case "ItemsSource":
                    this.w6.cj();
                    break;
                case "Resolution":
                    this.w6.cq();
                    break;
                case "TransitionDuration":
                    this.w6.ct();
                    break;
                case "Opacity":
                    this.w6.cn();
                    break;
                case "Visibility":
                    let hs_ = this.w5;
                    let v_ = this._visibility;
                    hs_.visibility = v_;
                    break;
                case "MouseOverEnabled":
                    this.w5.f9 = this.f9;
                    break;
                case "ExpectFunctions":
                    this.w5.expectFunctions = this.expectFunctions;
                    break;
                case "Thickness":
                    this.w6.cs();
                    break;
                case "Brush":
                    this.w6.ch();
                    break;
                case "Outline":
                    this.w6.cp();
                    break;
                case "ActualBrush":
                    this.w6.ce();
                    break;
                case "ActualOutline":
                    this.w6.cf();
                    break;
                case "MarkerFillOpacity":
                    if (!isNaN_(this.jh)) {
                        this.w6.cm();
                    }
                    break;
                case "AreaFillOpacity":
                    if (!isNaN_(this.il)) {
                        this.w6.cg();
                    }
                    break;
                case "OutlineMode":
                    this.w6.co();
                    break;
                case "ShowDefaultTooltip":
                    this.w6.cr();
                    break;
                case "Title":
                    this.w5.title = this.title;
                    break;
                case "LegendItemBadgeMode":
                    this.w6.ck();
                    break;
                case "LegendItemBadgeShape":
                    this.w6.cl();
                    break;
                case "Legend":
                    this.w5.legend = this.legend;
                    this.cw.a5();
                    break;
            }
        }
        w9() {
            if (this.dc == null || this.w5 == null) {
                return;
            }
            if (!isNaN_(this.w7)) {
                if (this.dc.wh.width > this.w7) {
                    let hs_ = this.w5;
                    let v_ = 1;
                    hs_.visibility = v_;
                }
                else {
                    let hs2_ = this.w5;
                    let v2_ = 0;
                    hs2_.visibility = v2_;
                }
            }
        }
        xb(a, b) {
            this.w9();
        }
        ru(a) {
            super.ru(a);
            if (this.w5 != null) {
                this.w5.ru(a);
            }
        }
        q7(a) {
            super.q7(a);
            if (this.w5 != null) {
                this.w5.qp();
            }
        }
        rt(a, b, c, d, e) {
            if (this.w5 != null) {
                this.w5.rt(a, b, c, d, e);
            }
        }
        a2(a, b) {
            return this.w5.a2(a, b);
        }
        sg() {
            super.sg();
            this.w5.sg();
        }
        get_coercionMethods() {
            return this._coercionMethods;
        }
        set_coercionMethods(a) {
            this._coercionMethods = a;
            this.w5.coercionMethods = a;
        }
        p1(a) {
            super.p1(a);
            if (this.w5 != null) {
                let b = this.w5.kn();
                this.pa(a, b);
            }
        }
    }
    GeographicMapSeriesHost.$t = /*@__PURE__*/ markType(GeographicMapSeriesHost, 'GeographicMapSeriesHost', Series.$);
    GeographicMapSeriesHost.xc = /*@__PURE__*/ DependencyProperty.i("VisibleFromScale", Number_$type, GeographicMapSeriesHost.$, /*@__PURE__*/ new PropertyMetadata(2, 1, (a, b) => {
        let c = a;
        c.raisePropertyChanged("VisibleFromScale", b.oldValue, b.newValue);
    }));
    return GeographicMapSeriesHost;
})();
/**
 * @hidden
 */
export let HostSeriesView = /*@__PURE__*/ (() => {
    class HostSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.cd = null;
            this.cd = a;
        }
        a3(a, b) {
            super.a3(a, b);
        }
        ci() {
            this.cd.legendItemVisibility = 1;
            this.cd.w5.legendItemVisibility = 0;
            this.cd.w5.itemsSource = this.cd.itemsSource;
            this.cd.w5.index = this.cd.index;
            this.cd.w5.vk = this.cd.vk;
            this.cd.w5.v0 = this.cd.vk;
            this.cd.w5.cj = this.cd.cj;
            this.cd.w5.jk = this.cd.jk;
            this.cd.w5.ke = this.cd.ke;
            this.cd.w5._opacity = this.cd._opacity;
            this.cd.w5.jq = this.cd.jq;
            this.cd.w5.il = this.cd.il;
            this.cd.w5.jh = this.cd.jh;
            this.cd.w5.gq = this.cd.gq;
            this.cd.w5.legendItemBadgeShape = this.cd.legendItemBadgeShape;
            this.cd.w5.be = this.cd.be;
        }
        cj() {
            this.cd.w5.itemsSource = this.cd.itemsSource;
        }
        cq() {
            this.cd.w5.jk = this.cd.jk;
        }
        ct() {
            this.cd.w5.ke = this.cd.ke;
        }
        cn() {
            this.cd.w5._opacity = this.cd._opacity;
        }
        cs() {
            this.cd.w5.jq = this.cd.jq;
        }
        ch() {
            this.cd.w5.vk = this.cd.vk;
        }
        cp() {
            this.cd.w5.v0 = this.cd.v0;
        }
        ce() {
            this.cd.w5.vk = this.cd.ve;
        }
        cf() {
            this.cd.w5.v0 = this.cd.vi;
        }
        ck() {
            this.cd.w5.be = this.cd.be;
        }
        cl() {
            this.cd.w5.legendItemBadgeShape = this.cd.legendItemBadgeShape;
        }
        cg() {
            this.cd.w5.il = this.cd.il;
        }
        cm() {
            this.cd.w5.jh = this.cd.jh;
        }
        co() {
            this.cd.w5.cj = this.cd.cj;
        }
        cr() {
            this.cd.w5.gq = this.cd.gq;
        }
    }
    HostSeriesView.$t = /*@__PURE__*/ markType(HostSeriesView, 'HostSeriesView', SeriesView.$);
    return HostSeriesView;
})();
