/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { MarkerType_$type } from "igniteui-react-charts";
import { DependencyProperty } from "igniteui-react-core";
import { MarkerOutlineMode_$type } from "igniteui-react-charts";
import { MarkerFillMode_$type } from "igniteui-react-charts";
import { DataTemplate } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { runOn, delegateCombine, typeCast, enumGetBox, markType, markDep } from "igniteui-react-core";
import { MarkerSeries } from "igniteui-react-charts";
import { Defaults } from "igniteui-react-charts";
import { PropertyMetadata } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
export let GeographicMarkerSeries = /*@__PURE__*/ (() => {
    class GeographicMarkerSeries extends GeographicMapSeriesHost {
        constructor() {
            super();
            let a = this.w5;
            a.propertyUpdated = delegateCombine(a.propertyUpdated, runOn(this, this.xt));
        }
        s3() {
            return this.xu;
        }
        vq() {
            return this.x7;
        }
        vr() {
            return this.x8;
        }
        ip() {
            return this.xg;
        }
        mc() {
            let a = typeCast(MarkerSeries.$, this.w5);
            if (a == null) {
                return "Unknown";
            }
            return a.mc();
        }
        xt(a, b) {
            let c = typeCast(MarkerSeries.$, this.w5);
            if (c == null) {
                return;
            }
            if (b.propertyName == "ActualMarkerTemplate") {
                this.xu = c.x5;
            }
            else if (b.propertyName == "ActualMarkerOutline") {
                this.x8 = c.yn;
            }
            else if (b.propertyName == "ActualMarkerBrush") {
                this.x7 = c.ym;
            }
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case GeographicMarkerSeries.$$p[3]:
                    this.w5.yo = this.x9;
                    break;
                case GeographicMarkerSeries.$$p[6]:
                    this.w5.yp = this.ya;
                    break;
                case GeographicMarkerSeries.$$p[5]:
                    this.w5.w9 = this.xe;
                    break;
                case GeographicMarkerSeries.$$p[4]:
                    this.w5.w5 = this.xd;
                    break;
                case GeographicMarkerSeries.$$p[9]:
                    this.w5.xf = this.xf;
                    break;
                case GeographicMarkerSeries.$$p[7]:
                    this.w5.x7 = this.xv;
                    break;
                case GeographicMarkerSeries.$$p[8]:
                    this.w5.xo = this.xg;
                    break;
                case GeographicMarkerSeries.$$p[10]:
                    this.w5.aae = this.xh;
                    break;
            }
        }
    }
    GeographicMarkerSeries.$t = /*@__PURE__*/ markType(GeographicMarkerSeries, 'GeographicMarkerSeries', GeographicMapSeriesHost.$);
    GeographicMarkerSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicMarkerSeries, 'raisePropertyChanged', ['ActualMarkerBrush:x7:xw', [Brush.$], 'ActualMarkerOutline:x8:xx', [Brush.$], 'ActualMarkerTemplate:xu:xy', [DataTemplate.$, null], 'MarkerBrush:x9:xz', [Brush.$], 'MarkerFillMode:xd:x0', [MarkerFillMode_$type, /*@__PURE__*/ enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:xe:x1', [MarkerOutlineMode_$type, /*@__PURE__*/ enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:ya:x2', [Brush.$], 'MarkerTemplate:xv:x3', [DataTemplate.$, null], 'MarkerThickness:xg:x4', [1, /*@__PURE__*/ DeviceUtils.g(2)], 'MarkerType:xf:x5', [MarkerType_$type, /*@__PURE__*/ enumGetBox(MarkerType_$type, Defaults.e)], 'MaximumMarkers:xh:x6', [1, 400]]);
    return GeographicMarkerSeries;
})();
