/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GeographicShapeSeriesBaseView } from "./GeographicShapeSeriesBaseView";
import { GeographicShapeSeriesBase } from "./GeographicShapeSeriesBase";
import { Brush } from "igniteui-react-core";
import { Defaults } from "igniteui-react-charts";
import { MarkerType_$type } from "igniteui-react-charts";
import { MarkerFillMode_$type } from "igniteui-react-charts";
import { ScatterPolygonSeries } from "igniteui-react-charts";
import { markType, runOn, delegateCombine, typeCast, enumGetBox, markDep } from "igniteui-react-core";
import { StyleSelector } from "igniteui-react-charts";
import { DependencyProperty } from "igniteui-react-core";
import { Style } from "igniteui-react-core";
import { MarkerOutlineMode_$type } from "igniteui-react-charts";
import { DataTemplate } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "igniteui-react-charts";
import { PropertyMetadata } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
export let GeographicShapeSeriesView = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesView extends GeographicShapeSeriesBaseView {
        constructor(a) {
            super(a);
            this.cy = null;
            this.cy = a;
            if (!this.t) {
                this.cy.x4 = "points";
            }
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.cy.zr = Defaults.a8;
                this.cy.jq = Defaults.ac;
                this.cy.yq = Defaults.ab;
                this.cy.yn = Defaults.d;
                this.cy.yl = Defaults.a;
            }
        }
        ci() {
            super.ci();
            this.cy.w5.aby = this.cy.zt;
            this.cy.w5.aar = this.cy.yo;
            this.cy.w5.abd = this.cy.y9;
            this.cy.w5.aau = this.cy.yq;
            this.cy.w5.aad = this.cy.yk;
        }
        c3() {
            this.cy.w5.abd = this.cy.y9;
        }
        c5() {
            this.cy.w5.aau = this.cy.yq;
        }
        c0() {
            this.cy.w5.aad = this.cy.yk;
        }
        c4() {
            this.cy.w5.aam = this.cy.yn;
        }
        cz() {
            this.cy.w5.abu = this.cy.zq;
        }
        c1() {
            this.cy.w5.abv = this.cy.zr;
        }
        c2() {
            this.cy.w5.abx = this.cy.zs;
        }
        c6() {
            this.cy.w5.aar = this.cy.yo;
        }
        c7() {
            this.cy.w5.aby = this.cy.zt;
        }
    }
    GeographicShapeSeriesView.$t = /*@__PURE__*/ markType(GeographicShapeSeriesView, 'GeographicShapeSeriesView', GeographicShapeSeriesBaseView.$);
    return GeographicShapeSeriesView;
})();
/**
 * @hidden
 */
export let GeographicShapeSeries = /*@__PURE__*/ (() => {
    class GeographicShapeSeries extends GeographicShapeSeriesBase {
        bk() {
            return new GeographicShapeSeries();
        }
        get_fr() {
            return true;
        }
        constructor() {
            super();
            this.styleShape = null;
            this.ab = GeographicShapeSeries.$;
        }
        ct() {
            return new GeographicShapeSeriesView(this);
        }
        q3(a) {
            super.q3(a);
            this.yp = a;
        }
        w4() {
            let a = new ScatterPolygonSeries();
            a.styleShape = delegateCombine(a.styleShape, runOn(this, this.y6));
            a.propertyUpdated = delegateCombine(a.propertyUpdated, runOn(this, this.y7));
            return a;
        }
        y6(a, b) {
            if (this.styleShape != null) {
                this.styleShape(this, b);
            }
        }
        y7(a, b) {
            let c = typeCast(ScatterPolygonSeries.$, this.w5);
            if (c == null) {
                return;
            }
        }
        ip() {
            return this.yq;
        }
        vq() {
            return this.zo;
        }
        vr() {
            return this.zp;
        }
        s3() {
            return this.y8;
        }
        mc() {
            let a = typeCast(ScatterPolygonSeries.$, this.w5);
            if (a == null) {
                return "Unknown";
            }
            return a.mc();
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case GeographicShapeSeries.$$p[6]:
                    this.w5.aak = this.ym;
                    break;
                case GeographicShapeSeries.$$p[5]:
                    this.w5.aag = this.yl;
                    break;
                case GeographicShapeSeries.$$p[9]:
                    this.yp.c3();
                    break;
                case GeographicShapeSeries.$$p[10]:
                    this.yp.c5();
                    break;
                case GeographicShapeSeries.$$p[4]:
                    this.yp.c0();
                    break;
                case GeographicShapeSeries.$$p[11]:
                    this.yp.c4();
                    break;
                case GeographicShapeSeries.$$p[3]:
                    this.yp.cz();
                    break;
                case GeographicShapeSeries.$$p[7]:
                    this.yp.c1();
                    break;
                case GeographicShapeSeries.$$p[8]:
                    this.yp.c2();
                    break;
                case GeographicShapeSeries.$$p[13]:
                    this.yp.c6();
                    break;
                case GeographicShapeSeries.$$p[12]:
                    this.yp.c7();
                    break;
            }
        }
        jm() {
            return 0.7;
        }
    }
    GeographicShapeSeries.$t = /*@__PURE__*/ markType(GeographicShapeSeries, 'GeographicShapeSeries', GeographicShapeSeriesBase.$);
    GeographicShapeSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeries, 'raisePropertyChanged', ['ActualMarkerBrush:zo:za', [Brush.$], 'ActualMarkerOutline:zp:zb', [Brush.$], 'ActualMarkerTemplate:y8:zc', [DataTemplate.$, null], 'MarkerBrush:zq:zd', [Brush.$], 'MarkerCollisionAvoidance:yk:ze', [CollisionAvoidanceType_$type, /*@__PURE__*/ enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:yl:zf', [MarkerFillMode_$type, /*@__PURE__*/ enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:ym:zg', [MarkerOutlineMode_$type, /*@__PURE__*/ enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:zr:zh', [Brush.$], 'MarkerStyle:zs:zi', [Style.$], 'MarkerTemplate:y9:zj', [DataTemplate.$, null], 'MarkerThickness:yq:zk', [1, /*@__PURE__*/ DeviceUtils.g(2)], 'MarkerType:yn:zl', [MarkerType_$type, /*@__PURE__*/ enumGetBox(MarkerType_$type, 2)], 'ShapeStyle:zt:zm', [Style.$, null], 'ShapeStyleSelector:yo:zn', [StyleSelector.$, null]]);
    return GeographicShapeSeries;
})();
