/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { TileSeries } from "./TileSeries";
import { GeographicShapeSeriesBase } from "./GeographicShapeSeriesBase";
import { runOn, delegateRemove, delegateCombine, markType } from "igniteui-react-core";
import { ImageTilesReadyEventArgs } from "./ImageTilesReadyEventArgs";
/**
 * @hidden
 */
export let GeographicTileSeries = /*@__PURE__*/ (() => {
    class GeographicTileSeries extends GeographicShapeSeriesBase {
        bk() {
            return new GeographicTileSeries();
        }
        get_f4() {
            return true;
        }
        constructor() {
            super();
            this.yl = null;
            this.yk = null;
            this.imageTilesReady = null;
            this.ab = GeographicTileSeries.$;
        }
        get ym() {
            return this.yl;
        }
        set ym(a) {
            let b = a != this.ym;
            if (b) {
                let c = this.ym;
                this.yl = a;
                this.raisePropertyChanged("TileImagery", c, a);
            }
        }
        yq() {
            if (this.ym != null) {
                this.ym.clearTileCache();
            }
        }
        rc(a, b, c, d) {
            super.rc(a, b, c, d);
            switch (b) {
                case "TileImagery":
                    if (this.w5 != null) {
                        this.w5.aag = this.ym;
                    }
                    break;
            }
        }
        xa(a, b) {
            super.xa(a, b);
            this.w5.aag = this.ym;
            if (this.yk != null) {
                let c = this.yk;
                c.imageTilesReady = delegateRemove(c.imageTilesReady, runOn(this, this.yp));
            }
            this.yk = this.w5;
            if (this.yk != null) {
                let d = this.yk;
                d.imageTilesReady = delegateCombine(d.imageTilesReady, runOn(this, this.yp));
            }
        }
        w4() {
            return new TileSeries();
        }
        yp(a, b) {
            if (this.imageTilesReady != null) {
                this.imageTilesReady(this, new ImageTilesReadyEventArgs());
            }
        }
    }
    GeographicTileSeries.$t = /*@__PURE__*/ markType(GeographicTileSeries, 'GeographicTileSeries', GeographicShapeSeriesBase.$);
    return GeographicTileSeries;
})();
