import { IgrGeographicMapImagery } from "./igr-geographic-map-imagery";
import { TileGeneratorMapImagery as TileGeneratorMapImagery_internal } from "./TileGeneratorMapImagery";
/**
 * Represents a CustomMapImagery MapImagery
*/
export class IgrTileGeneratorMapImagery extends IgrGeographicMapImagery {
    createImplementation() {
        return new TileGeneratorMapImagery_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Gets or sets the culture name for this tile source.
    */
    get tileGenerator() {
        return this.i.tileGenerator;
    }
    set tileGenerator(v) {
        this.i.tileGenerator = v;
    }
}
