/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Series } from "igniteui-react-charts";
import { typeCast, Number_$type, runOn, delegateRemove, delegateCombine, markType, TypeRegistrar } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { SeriesView } from "igniteui-react-charts";
import { SeriesViewer } from "igniteui-react-charts";
import { PropertyMetadata } from "igniteui-react-core";
import { PlatformConstants } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var GeographicMapSeriesHost = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicMapSeriesHost, _super);
    function GeographicMapSeriesHost() {
        var _this = _super.call(this) || this;
        _this.w3 = null;
        _this.w5 = _this.w4();
        return _this;
    }
    GeographicMapSeriesHost.prototype.qi = function () {
        _super.prototype.qi.call(this);
        if (this.w5 != null) {
            this.w5.qi();
        }
    };
    GeographicMapSeriesHost.prototype.get_fd = function () {
        return true;
    };
    GeographicMapSeriesHost.prototype.kr = function (a, b) {
        var c = this.nf(b);
        if (c == "LatitudeMemberPath") {
            c = "YMemberPath";
        }
        if (c == "LongitudeMemberPath") {
            c = "XMemberPath";
        }
        return this.w5.kr(a, c);
    };
    GeographicMapSeriesHost.prototype.mf = function (a) {
        var b = this.nf(a);
        if (b == "LatitudeMemberPath") {
            b = "YMemberPath";
        }
        if (b == "LongitudeMemberPath") {
            b = "XMemberPath";
        }
        return this.w5.mf(b);
    };
    GeographicMapSeriesHost.prototype.get_kj = function () {
        return this.k1(this.w5);
    };
    GeographicMapSeriesHost.prototype.set_kj = function (a) {
        this.o1(this.w5, a);
    };
    GeographicMapSeriesHost.prototype.ed = function (a, b, c, d, e) {
        return this.w5.ed(a, b, c, d, e);
    };
    GeographicMapSeriesHost.prototype.ai = function () {
        return this.w5.ai();
    };
    GeographicMapSeriesHost.prototype.bp = function () {
        return this.w5;
    };
    Object.defineProperty(GeographicMapSeriesHost.prototype, "w5", {
        get: function () {
            return this.w3;
        },
        set: function (a) {
            var b = this.w3;
            var c = this.w5 != a;
            if (c) {
                this.w3 = a;
                this.xa(b, this.w3);
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapSeriesHost.prototype.get_hasMarkers = function () {
        return this.w5.hasMarkers;
    };
    GeographicMapSeriesHost.prototype.xa = function (a, b) {
        if (this.w3 != null) {
            var hostedSeries_ = this.w3;
            hostedSeries_.externalObject = TypeRegistrar.createFromInternal(hostedSeries_, PlatformConstants.Prefix, PlatformConstants.Postfix);
            hostedSeries_.externalObject._implementation = hostedSeries_;
        }
        this.ph(this.w5);
        this.w6.ci();
        if (a != null) {
            var c = (a);
            this.r5(c, null);
        }
        if (b != null) {
            var d = (b);
            this.r5(d, this);
        }
    };
    GeographicMapSeriesHost.prototype.dh = function (a, b, c) {
        return this.dj(this.w5, a, b, c);
    };
    GeographicMapSeriesHost.prototype.di = function (a, b, c) {
        return this.dk(this.w5, a, b, c);
    };
    GeographicMapSeriesHost.prototype.ko = function (a) {
        return this.kx(this.w5, a);
    };
    GeographicMapSeriesHost.prototype.kb = function (a, b) {
        return this.w5.kb(a, b);
    };
    GeographicMapSeriesHost.prototype.j9 = function (a, b) {
        return this.w5.j9(a, b);
    };
    GeographicMapSeriesHost.prototype.i6 = function (a, b, c) {
        return this.w5.i6(a, b, c);
    };
    GeographicMapSeriesHost.prototype.wh = function (a, b, c) {
        return this.w5.wh(a, b, c);
    };
    GeographicMapSeriesHost.prototype.ws = function (a) {
        return this.w5.ws(a);
    };
    GeographicMapSeriesHost.prototype.ao = function (a) {
        return this.w5.ao(a);
    };
    GeographicMapSeriesHost.prototype.wt = function (a) {
        return this.w5.wt(a);
    };
    GeographicMapSeriesHost.prototype.ap = function (a) {
        return this.w5.ap(a);
    };
    GeographicMapSeriesHost.prototype.wu = function (a) {
        return this.w5.wu(a);
    };
    GeographicMapSeriesHost.prototype.wv = function (a) {
        return this.w5.wv(a);
    };
    GeographicMapSeriesHost.prototype.i2 = function (a, b, c) {
        return this.w5.i2(a, b, c);
    };
    GeographicMapSeriesHost.prototype.wd = function (a, b, c) {
        return this.w5.wd(a, b, c);
    };
    GeographicMapSeriesHost.prototype.i4 = function (a, b, c) {
        return this.i6(a, b, c);
    };
    GeographicMapSeriesHost.prototype.wf = function (a, b, c) {
        return this.w5.wf(a, b, c);
    };
    GeographicMapSeriesHost.prototype.wi = function (a, b, c) {
        return this.w5.wi(a, b, c);
    };
    GeographicMapSeriesHost.prototype.i7 = function (a, b, c) {
        return this.w5.i7(a, b, c);
    };
    GeographicMapSeriesHost.prototype.we = function (a, b, c) {
        return this.w5.we(a, b, c);
    };
    GeographicMapSeriesHost.prototype.i3 = function (a, b, c) {
        return this.w5.i3(a, b, c);
    };
    GeographicMapSeriesHost.prototype.wg = function (a, b, c) {
        return this.w5.wg(a, b, c);
    };
    GeographicMapSeriesHost.prototype.i5 = function (a, b, c) {
        return this.w5.i5(a, b, c);
    };
    GeographicMapSeriesHost.prototype.j5 = function (a) {
        return this.w5.j5(a);
    };
    GeographicMapSeriesHost.prototype.ix = function () {
        return this.w5.ix();
    };
    GeographicMapSeriesHost.prototype.it = function (a) {
        return this.w5.it(a);
    };
    GeographicMapSeriesHost.prototype.kp = function (a) {
        return this.w5.kp(a);
    };
    GeographicMapSeriesHost.prototype.ct = function () {
        return new HostSeriesView(this);
    };
    GeographicMapSeriesHost.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.w6 = typeCast(HostSeriesView.$, a);
    };
    Object.defineProperty(GeographicMapSeriesHost.prototype, "w7", {
        get: function () {
            return this.c(GeographicMapSeriesHost.xc);
        },
        set: function (a) {
            this.h(GeographicMapSeriesHost.xc, a);
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapSeriesHost.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.w5.dc = this.dc;
                if (c != null) {
                    c.rd(this.w5);
                }
                if (d != null) {
                    this.dc.nh(this.w5);
                }
                this.w5.rf(this.wx);
                this.w5.index = this.index;
                this.p2(this.w5);
                this.kh = this.w5.kh;
                var e = typeCast(SeriesViewer.$, c);
                if (e != null) {
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.xb));
                }
                if (this.dc != null) {
                    var f = this.dc;
                    f.actualWindowRectChanged = delegateCombine(f.actualWindowRectChanged, runOn(this, this.xb));
                }
                this.w9();
                break;
            case "SyncLink":
                this.w5.c4 = this.c4;
                break;
            case "VisibleFromScale":
                this.w9();
                break;
            case "Index":
                this.w5.index = this.index;
                break;
            case "ItemsSource":
                this.w6.cj();
                break;
            case "Resolution":
                this.w6.cq();
                break;
            case "TransitionDuration":
                this.w6.ct();
                break;
            case "Opacity":
                this.w6.cn();
                break;
            case "Visibility":
                var hs_ = this.w5;
                var v_ = this._visibility;
                hs_.visibility = v_;
                break;
            case "MouseOverEnabled":
                this.w5.f9 = this.f9;
                break;
            case "ExpectFunctions":
                this.w5.expectFunctions = this.expectFunctions;
                break;
            case "Thickness":
                this.w6.cs();
                break;
            case "Brush":
                this.w6.ch();
                break;
            case "Outline":
                this.w6.cp();
                break;
            case "ActualBrush":
                this.w6.ce();
                break;
            case "ActualOutline":
                this.w6.cf();
                break;
            case "MarkerFillOpacity":
                if (!isNaN_(this.jh)) {
                    this.w6.cm();
                }
                break;
            case "AreaFillOpacity":
                if (!isNaN_(this.il)) {
                    this.w6.cg();
                }
                break;
            case "OutlineMode":
                this.w6.co();
                break;
            case "ShowDefaultTooltip":
                this.w6.cr();
                break;
            case "Title":
                this.w5.title = this.title;
                break;
            case "LegendItemBadgeMode":
                this.w6.ck();
                break;
            case "LegendItemBadgeShape":
                this.w6.cl();
                break;
            case "Legend":
                this.w5.legend = this.legend;
                this.cw.a5();
                break;
        }
    };
    GeographicMapSeriesHost.prototype.w9 = function () {
        if (this.dc == null || this.w5 == null) {
            return;
        }
        if (!isNaN_(this.w7)) {
            if (this.dc.wh.width > this.w7) {
                var hs_ = this.w5;
                var v_ = 1;
                hs_.visibility = v_;
            }
            else {
                var hs2_ = this.w5;
                var v2_ = 0;
                hs2_.visibility = v2_;
            }
        }
    };
    GeographicMapSeriesHost.prototype.xb = function (a, b) {
        this.w9();
    };
    GeographicMapSeriesHost.prototype.ru = function (a) {
        _super.prototype.ru.call(this, a);
        if (this.w5 != null) {
            this.w5.ru(a);
        }
    };
    GeographicMapSeriesHost.prototype.q7 = function (a) {
        _super.prototype.q7.call(this, a);
        if (this.w5 != null) {
            this.w5.qp();
        }
    };
    GeographicMapSeriesHost.prototype.rt = function (a, b, c, d, e) {
        if (this.w5 != null) {
            this.w5.rt(a, b, c, d, e);
        }
    };
    GeographicMapSeriesHost.prototype.a2 = function (a, b) {
        return this.w5.a2(a, b);
    };
    GeographicMapSeriesHost.prototype.sg = function () {
        _super.prototype.sg.call(this);
        this.w5.sg();
    };
    GeographicMapSeriesHost.prototype.get_coercionMethods = function () {
        return this._coercionMethods;
    };
    GeographicMapSeriesHost.prototype.set_coercionMethods = function (a) {
        this._coercionMethods = a;
        this.w5.coercionMethods = a;
    };
    GeographicMapSeriesHost.prototype.p1 = function (a) {
        _super.prototype.p1.call(this, a);
        if (this.w5 != null) {
            var b = this.w5.kn();
            this.pa(a, b);
        }
    };
    GeographicMapSeriesHost.$t = markType(GeographicMapSeriesHost, 'GeographicMapSeriesHost', Series.$);
    GeographicMapSeriesHost.xc = DependencyProperty.i("VisibleFromScale", Number_$type, GeographicMapSeriesHost.$, new PropertyMetadata(2, 1, function (a, b) {
        var c = a;
        c.raisePropertyChanged("VisibleFromScale", b.oldValue, b.newValue);
    }));
    return GeographicMapSeriesHost;
}(Series));
export { GeographicMapSeriesHost };
/**
 * @hidden
 */
var HostSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HostSeriesView, _super);
    function HostSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cd = null;
        _this.cd = a;
        return _this;
    }
    HostSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
    };
    HostSeriesView.prototype.ci = function () {
        this.cd.legendItemVisibility = 1;
        this.cd.w5.legendItemVisibility = 0;
        this.cd.w5.itemsSource = this.cd.itemsSource;
        this.cd.w5.index = this.cd.index;
        this.cd.w5.vk = this.cd.vk;
        this.cd.w5.v0 = this.cd.vk;
        this.cd.w5.cj = this.cd.cj;
        this.cd.w5.jk = this.cd.jk;
        this.cd.w5.ke = this.cd.ke;
        this.cd.w5._opacity = this.cd._opacity;
        this.cd.w5.jq = this.cd.jq;
        this.cd.w5.il = this.cd.il;
        this.cd.w5.jh = this.cd.jh;
        this.cd.w5.gq = this.cd.gq;
        this.cd.w5.legendItemBadgeShape = this.cd.legendItemBadgeShape;
        this.cd.w5.be = this.cd.be;
    };
    HostSeriesView.prototype.cj = function () {
        this.cd.w5.itemsSource = this.cd.itemsSource;
    };
    HostSeriesView.prototype.cq = function () {
        this.cd.w5.jk = this.cd.jk;
    };
    HostSeriesView.prototype.ct = function () {
        this.cd.w5.ke = this.cd.ke;
    };
    HostSeriesView.prototype.cn = function () {
        this.cd.w5._opacity = this.cd._opacity;
    };
    HostSeriesView.prototype.cs = function () {
        this.cd.w5.jq = this.cd.jq;
    };
    HostSeriesView.prototype.ch = function () {
        this.cd.w5.vk = this.cd.vk;
    };
    HostSeriesView.prototype.cp = function () {
        this.cd.w5.v0 = this.cd.v0;
    };
    HostSeriesView.prototype.ce = function () {
        this.cd.w5.vk = this.cd.ve;
    };
    HostSeriesView.prototype.cf = function () {
        this.cd.w5.v0 = this.cd.vi;
    };
    HostSeriesView.prototype.ck = function () {
        this.cd.w5.be = this.cd.be;
    };
    HostSeriesView.prototype.cl = function () {
        this.cd.w5.legendItemBadgeShape = this.cd.legendItemBadgeShape;
    };
    HostSeriesView.prototype.cg = function () {
        this.cd.w5.il = this.cd.il;
    };
    HostSeriesView.prototype.cm = function () {
        this.cd.w5.jh = this.cd.jh;
    };
    HostSeriesView.prototype.co = function () {
        this.cd.w5.cj = this.cd.cj;
    };
    HostSeriesView.prototype.cr = function () {
        this.cd.w5.gq = this.cd.gq;
    };
    HostSeriesView.$t = markType(HostSeriesView, 'HostSeriesView', SeriesView.$);
    return HostSeriesView;
}(SeriesView));
export { HostSeriesView };
