/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { HostSeriesView } from "./HostSeriesView";
import { ScatterSeries } from "igniteui-react-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { markType, enumGetBox, runOn, delegateCombine, delegateRemove, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "igniteui-react-charts";
import { ScatterItemSearchMode_$type } from "igniteui-react-charts";
import { PropertyMetadata } from "igniteui-react-core";
/**
 * @hidden
 */
var GeographicSymbolSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicSymbolSeriesView, _super);
    function GeographicSymbolSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cu = null;
        _this.cu = a;
        return _this;
    }
    GeographicSymbolSeriesView.prototype.a4 = function () {
        _super.prototype.a4.call(this);
        if (!this.t) {
        }
    };
    GeographicSymbolSeriesView.prototype.ci = function () {
        var a = this.cu.w5;
        _super.prototype.ci.call(this);
        a.aay = this.cu.yt;
        a.aa6 = this.cu.yr;
        a.xf = this.cu.xf;
        a.x7 = this.cu.xv;
        a.xo = this.cu.xg;
    };
    GeographicSymbolSeriesView.prototype.cw = function () {
        this.cu.w5.aay = this.cu.yt;
    };
    GeographicSymbolSeriesView.prototype.cv = function () {
        this.cu.w5.aa6 = this.cu.yr;
    };
    GeographicSymbolSeriesView.prototype.c2 = function () {
        this.cu.w5.xf = this.cu.xf;
    };
    GeographicSymbolSeriesView.prototype.c0 = function () {
        this.cu.w5.x7 = this.cu.xv;
    };
    GeographicSymbolSeriesView.prototype.c1 = function () {
        this.cu.w5.xo = this.cu.xg;
    };
    GeographicSymbolSeriesView.prototype.c3 = function () {
        this.cu.w5.aae = this.cu.xh;
    };
    GeographicSymbolSeriesView.prototype.c5 = function () {
        this.cu.w5.xAxis = this.cu.dc.w7;
    };
    GeographicSymbolSeriesView.prototype.c6 = function () {
        this.cu.w5.yAxis = this.cu.dc.w9;
    };
    GeographicSymbolSeriesView.prototype.c4 = function () {
        var a = this.cu.w5;
        if (this.cu.dc == null) {
            a.xAxis = null;
            a.yAxis = null;
            return;
        }
        a.xAxis = this.cu.dc.w7;
        a.yAxis = this.cu.dc.w9;
    };
    GeographicSymbolSeriesView.prototype.cy = function () {
        this.cu.w5.yy = this.cu.yd;
    };
    GeographicSymbolSeriesView.prototype.cx = function () {
        this.cu.w5.yo = this.cu.x9;
    };
    GeographicSymbolSeriesView.prototype.cz = function () {
        this.cu.w5.yp = this.cu.ya;
    };
    GeographicSymbolSeriesView.$t = markType(GeographicSymbolSeriesView, 'GeographicSymbolSeriesView', HostSeriesView.$);
    return GeographicSymbolSeriesView;
}(HostSeriesView));
export { GeographicSymbolSeriesView };
/**
 * @hidden
 */
var GeographicSymbolSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicSymbolSeries, _super);
    function GeographicSymbolSeries() {
        var _this = _super.call(this) || this;
        _this.yf = null;
        _this.yi = false;
        _this.yh = false;
        _this.assigningScatterStyle = null;
        _this.assigningScatterMarkerStyle = null;
        _this.ab = GeographicSymbolSeries.$;
        return _this;
    }
    GeographicSymbolSeries.prototype.bk = function () {
        return new GeographicSymbolSeries();
    };
    GeographicSymbolSeries.prototype.get_ek = function () {
        return true;
    };
    GeographicSymbolSeries.prototype.ct = function () {
        return new GeographicSymbolSeriesView(this);
    };
    GeographicSymbolSeries.prototype.q3 = function (a) {
        _super.prototype.q3.call(this, a);
        this.yg = a;
    };
    GeographicSymbolSeries.prototype.jm = function () {
        return 0.7;
    };
    GeographicSymbolSeries.prototype.w4 = function () {
        return new ScatterSeries();
    };
    GeographicSymbolSeries.prototype.get_ff = function () {
        return true;
    };
    GeographicSymbolSeries.prototype.rc = function (a, b, c, d) {
        _super.prototype.rc.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.yg.c4();
                break;
            case GeographicSymbolSeries.$$p[5]:
                this.yg.cw();
                break;
            case GeographicSymbolSeries.$$p[4]:
                this.yg.cv();
                break;
            case GeographicSymbolSeries.$$p[6]:
                this.yg.cy();
                break;
            case "XAxis":
                this.yg.c5();
                break;
            case "YAxis":
                this.yg.c6();
                break;
            case GeographicSymbolSeries.$$p[1]:
                this.w5.zu = this.yk;
                this.yi = this.yk;
                if (this.yk) {
                    var e = this.w5;
                    e.assigningScatterStyle = delegateCombine(e.assigningScatterStyle, runOn(this, this.yy));
                }
                else {
                    var f = this.w5;
                    f.assigningScatterStyle = delegateRemove(f.assigningScatterStyle, runOn(this, this.yy));
                }
                break;
            case GeographicSymbolSeries.$$p[0]:
                this.w5.zt = this.yj;
                this.yh = this.yj;
                if (this.yk) {
                    var g = this.w5;
                    g.assigningScatterMarkerStyle = delegateCombine(g.assigningScatterMarkerStyle, runOn(this, this.yx));
                }
                else {
                    var h = this.w5;
                    h.assigningScatterMarkerStyle = delegateRemove(h.assigningScatterMarkerStyle, runOn(this, this.yx));
                }
                break;
            case GeographicSymbolSeries.$$p[2]:
                this.w5.zd = this.ye;
                break;
            case GeographicSymbolSeries.$$p[3]:
                this.w5.aad = this.ym;
                break;
        }
    };
    GeographicSymbolSeries.prototype.yy = function (a, b) {
        if (this.assigningScatterStyle != null) {
            this.assigningScatterStyle(this, b);
        }
    };
    GeographicSymbolSeries.prototype.yx = function (a, b) {
        if (this.assigningScatterMarkerStyle != null) {
            this.assigningScatterMarkerStyle(this, b);
        }
    };
    GeographicSymbolSeries.$t = markType(GeographicSymbolSeries, 'GeographicSymbolSeries', GeographicMarkerSeries.$);
    GeographicSymbolSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicSymbolSeries, 'raisePropertyChanged', ['IsCustomScatterMarkerStyleAllowed:yj:yz', [0, false], 'IsCustomScatterStyleAllowed:yk:y0', [0, false], 'ItemSearchMode:ye:y1', [ScatterItemSearchMode_$type, enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:ym:y2', [1, 10000], 'LatitudeMemberPath:yr:y3', [2, null], 'LongitudeMemberPath:yt:y4', [2, null], 'MarkerCollisionAvoidance:yd:y5', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'UseLightweightMarkers:yl:y6', [0, false]]);
    return GeographicSymbolSeries;
}(GeographicMarkerSeries));
export { GeographicSymbolSeries };
