import { ImageTilesReadyEventArgs as ImageTilesReadyEventArgs_internal } from "./ImageTilesReadyEventArgs";
var IgrImageTilesReadyEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrImageTilesReadyEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrImageTilesReadyEventArgs.prototype.createImplementation = function () {
        return new ImageTilesReadyEventArgs_internal();
    };
    Object.defineProperty(IgrImageTilesReadyEventArgs.prototype, "nativeElement", {
        get: function () {
            return this._implementation.nativeElement;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrImageTilesReadyEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrImageTilesReadyEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrImageTilesReadyEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    return IgrImageTilesReadyEventArgs;
}());
export { IgrImageTilesReadyEventArgs };
