import { Series } from "igniteui-react-charts";
import { Point, Type } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "igniteui-react-charts";
import { Axis } from "igniteui-react-charts";
import { HighlightingInfo } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { SeriesView } from "igniteui-react-charts";
import { RenderSurface } from "igniteui-react-charts";
import { DataContext } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class GeographicMapSeriesHost extends Series {
    static $t: Type;
    qi(): void;
    constructor();
    private w3;
    protected get_fd(): boolean;
    kr(a: any, b: string): any;
    mf(a: string): string;
    protected get_kj(): any;
    protected set_kj(a: any): void;
    ed(a: List$1<SeriesPointOfInterest>, b: boolean, c: boolean, d: number, e: boolean): boolean;
    ai(): Axis[];
    bp(): Series;
    get w5(): Series;
    set w5(a: Series);
    protected get_hasMarkers(): boolean;
    protected xa(a: any, b: any): void;
    dh(a: any, b: Point, c: boolean): HighlightingInfo;
    di(a: any, b: Point, c: boolean): HighlightingInfo;
    ko(a: Point): any;
    kb(a: Point, b: boolean): number;
    j9(a: Point, b: boolean): number;
    i6(a: Point, b: boolean, c: boolean): number;
    wh(a: Point, b: boolean, c: boolean): Point;
    ws(a: Point): Rect;
    ao(a: Point): Rect[];
    wt(a: Point): Rect;
    ap(a: Point): Rect[];
    wu(a: Point): Rect;
    wv(a: Point): Rect;
    i2(a: Point, b: boolean, c: boolean): number;
    wd(a: Point, b: boolean, c: boolean): Point;
    i4(a: Point, b: boolean, c: boolean): number;
    wf(a: Point, b: boolean, c: boolean): Point;
    wi(a: Point, b: boolean, c: boolean): Point;
    i7(a: Point, b: boolean, c: boolean): number;
    we(a: Point, b: boolean, c: boolean): Point;
    i3(a: Point, b: boolean, c: boolean): number;
    wg(a: Point, b: boolean, c: boolean): Point;
    i5(a: Point, b: boolean, c: boolean): number;
    j5(a: Point): number;
    ix(): number;
    it(a: Point): number;
    kp(a: Point): any;
    protected abstract w4(): Series;
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    w6: HostSeriesView;
    static readonly xc: DependencyProperty;
    get w7(): number;
    set w7(a: number);
    protected rc(a: any, b: string, c: any, d: any): void;
    private w9;
    private xb;
    ru(a: boolean): void;
    protected q7(a: boolean): void;
    rt(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    a2(a: Point, b: boolean): DataContext;
    sg(): void;
    protected get_coercionMethods(): any;
    protected set_coercionMethods(a: any): void;
    protected p1(a: any): void;
}
/**
 * @hidden
 */
export declare class HostSeriesView extends SeriesView {
    static $t: Type;
    constructor(a: GeographicMapSeriesHost);
    private cd;
    a3(a: RenderingContext, b: RenderingContext): void;
    ci(): void;
    cj(): void;
    cq(): void;
    ct(): void;
    cn(): void;
    cs(): void;
    ch(): void;
    cp(): void;
    ce(): void;
    cf(): void;
    ck(): void;
    cl(): void;
    cg(): void;
    cm(): void;
    co(): void;
    cr(): void;
}
