import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { ShapeItemSearchMode } from "igniteui-react-charts";
import { BrushScale } from "igniteui-react-charts";
import { ShapefileConverter } from "igniteui-react-core";
import { SeriesView } from "igniteui-react-charts";
import { Type } from "igniteui-react-core";
import { AssigningShapeStyleEventArgs } from "igniteui-react-charts";
import { AssigningShapeMarkerStyleEventArgs } from "igniteui-react-charts";
import { HostSeriesView } from "./HostSeriesView";
/**
 * @hidden
 */
export declare abstract class GeographicShapeSeriesBase extends GeographicMapSeriesHost {
    static $t: Type;
    protected ct(): SeriesView;
    xh: GeographicShapeSeriesBaseView;
    q3(a: SeriesView): void;
    x4: string;
    protected get_ff(): boolean;
    protected get_ef(): boolean;
    xp: boolean;
    xo: boolean;
    protected xm: boolean;
    protected xl: boolean;
    xg: ShapeItemSearchMode;
    xs: number;
    xt: string;
    xf: BrushScale;
    xn: boolean;
    xr: number;
    assigningShapeStyle: (sender: any, args: AssigningShapeStyleEventArgs) => void;
    assigningShapeMarkerStyle: (sender: any, args: AssigningShapeMarkerStyleEventArgs) => void;
    protected rc(a: any, b: string, c: any, d: any): void;
    private x7;
    private x6;
    private x8;
    private x9;
    private xi;
    private xk;
    get xj(): ShapefileConverter;
    set xj(a: ShapefileConverter);
    xq: number;
    protected get_g8(): boolean;
    protected set_g8(a: boolean): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class GeographicShapeSeriesBaseView extends HostSeriesView {
    static $t: Type;
    constructor(a: GeographicShapeSeriesBase);
    private cu;
    ci(): void;
    cv(): void;
    cx(): void;
    cw(): void;
}
