import { ShapeSeriesBase } from "igniteui-react-charts";
import { IMapRenderDeferralHandler } from "igniteui-react-core";
import { GeographicMapImagery } from "./GeographicMapImagery";
import { Type, EventArgs } from "igniteui-react-core";
import { Series } from "igniteui-react-charts";
import { SeriesView } from "igniteui-react-charts";
import { Rect } from "igniteui-react-core";
import { DependencyObject } from "igniteui-react-core";
import { RenderSurface } from "igniteui-react-charts";
import { FrameworkElement } from "igniteui-react-core";
import { ShapeSeriesViewBase } from "igniteui-react-charts";
import { RenderingContext } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class TileSeries extends ShapeSeriesBase implements IMapRenderDeferralHandler {
    static $t: Type;
    protected bk(): Series;
    protected get_f4(): boolean;
    constructor();
    protected ct(): SeriesView;
    q3(a: SeriesView): void;
    protected get_yf(): boolean;
    protected aac: TileSeriesView;
    get aag(): GeographicMapImagery;
    set aag(a: GeographicMapImagery);
    private aae;
    private aad;
    protected get aaf(): GeographicMapImagery;
    protected set aaf(a: GeographicMapImagery);
    protected rc(a: any, b: string, c: any, d: any): void;
    private aal;
    imageTilesReady: (sender: any, e: EventArgs) => void;
    private aam;
    private aah;
    register(a: DependencyObject, b: (arg1: boolean) => void): void;
    unRegister(a: DependencyObject): void;
    deferredRefresh(): void;
    deferAction(a: () => void): void;
    protected su(a: Rect, b: Rect): void;
    private aai;
    rv(a: boolean): void;
    protected aan(a: boolean, b: SeriesView): void;
    rt(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    private aao;
    o7(a: boolean, b: SeriesView): void;
}
/**
 * @hidden
 */
export declare class TileSeriesView extends ShapeSeriesViewBase {
    static $t: Type;
    constructor(a: TileSeries);
    protected dn: TileSeries;
    a4(): void;
    protected cx(a: FrameworkElement, b: PathGeometry): void;
    protected di(a: number, b: List$1<PointCollection>): PathGeometry;
    protected dh(a: number, b: any): FrameworkElement;
    protected c1(a: FrameworkElement, b: boolean): void;
    cz(a: FrameworkElement, b: any, c: boolean): void;
    private dz;
    c7(): void;
    c6(): void;
    dr(a: Rect): void;
    private dq;
    private dp;
    du(a: GeographicMapImagery, b: GeographicMapImagery): void;
    private dt;
    dv(a: GeographicMapImagery, b: GeographicMapImagery): void;
    dx(): void;
    protected bj(a: RenderingContext, b: boolean): void;
    dw(): void;
    ds(): void;
    dy(a: Rect): void;
}
