import { IgrGetTileImageUriArgs } from "igniteui-react-core";
import { IgrGeographicMapImagery } from "./igr-geographic-map-imagery";
import { CustomMapImagery as CustomMapImagery_internal } from "./CustomMapImagery";
/**
 * Represents a CustomMapImagery MapImagery
*/
export declare class IgrCustomMapImagery extends IgrGeographicMapImagery {
    /**
                                 * @hidden
                                 */
    get i(): CustomMapImagery_internal;
    constructor();
    private _getTileImageUri;
    private _getTileImageUri_wrapped;
    /**
     * Raised when URI for tiles should be provided
    */
    get getTileImageUri(): (s: IgrCustomMapImagery, e: IgrGetTileImageUriArgs) => void;
    set getTileImageUri(ev: (s: IgrCustomMapImagery, e: IgrGetTileImageUriArgs) => void);
}
